Package: MLInterfaces
Title: Uniform interfaces to R machine learning procedures for data in
        Bioconductor containers
Version: 1.92.0
Authors@R: c(
        person("Vincent", "Carey", role=c("cre", "aut"), comment = c(ORCID = "0000-0003-4046-0063"), email="stvjc@channing.harvard.edu"),
        person("Jess", "Mar", role=c("aut")),
	person("Jason", "Vertrees", role=c("ctb")),
	person("Laurent", "Gatto", role=c("ctb")),
        person("Phylis", "Atieno",role = "ctb",
        comment = "Translated vignettes from Sweave to Rmarkdown / HTML."
          ))
Description: This package provides uniform interfaces to machine 
	learning code for data in R and Bioconductor containers.
License: LGPL
Depends: R (>= 3.5), Rcpp, methods, BiocGenerics (>= 0.13.11), Biobase,
        annotate, cluster
Imports: gdata, pls, sfsmisc, MASS, rpart, genefilter, fpc, ggvis,
        shiny, gbm, RColorBrewer, hwriter, threejs (>= 0.2.2), mlbench,
        stats4, tools, grDevices, graphics, stats, magrittr,
        SummarizedExperiment
Suggests: class, e1071, ipred, randomForest, gpls, pamr, nnet, ALL,
        hgu95av2.db, som, hu6800.db, lattice, caret (>= 5.07),
        golubEsets, ada, keggorthology, kernlab, mboost, party, klaR,
        BiocStyle, knitr, testthat, airway
Enhances: parallel
LazyLoad: yes
biocViews: Classification, Clustering
NeedsCompilation: no
Packaged: 2026-04-28 23:19:39 UTC; biocbuild
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/MLInterfaces
git_branch: RELEASE_3_23
git_last_commit: 5f7da61
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Author: Vincent Carey [cre, aut] (ORCID:
    <https://orcid.org/0000-0003-4046-0063>),
  Jess Mar [aut],
  Jason Vertrees [ctb],
  Laurent Gatto [ctb],
  Phylis Atieno [ctb] (Translated vignettes from Sweave to Rmarkdown /
    HTML.)
Maintainer: Vincent Carey <stvjc@channing.harvard.edu>

exportPattern("..*")

# from CHECK of 3/25/2020

  importFrom("grDevices", "colorRampPalette")
  importFrom("graphics", "axis", "barplot", "image", "legend", "pairs",
             "par", "points", "text")
  importFrom("methods", "is", "new")
  importFrom("stats", "as.formula", "cutree", "dist", "hclust", "mad",
             "median", "model.frame", "model.matrix", "model.response",
             "na.fail", "prcomp", "predict", "quantile", "terms", "var")
  importFrom("magrittr", "%>%")
  import(SummarizedExperiment)

#import("methods")
#import("tools")
#import("BiocGenerics", except="var")
#import("Biobase")
#import("annotate")
#import("MASS")
#import("rpart")
#import("sfsmisc")
#import("pls")
#import("shiny")
#import("ggvis")
#import("fpc")
#import(threejs)
#import(mlbench)
#
#importFrom(gbm, gbm, predict.gbm)
#
#importFrom("genefilter", "rowttests")
#importFrom("base", "plot")
#importFrom("cluster", "silhouette")
#importFrom("gdata", "drop.levels")
#
#importFrom("RColorBrewer", "brewer.pal")
#
#importFrom("hwriter", "hwrite")
#
#exportClasses( 
#	"varImpStruct",
##	"raboostCont", "daboostCont",
#	"classifierOutput", "learnerSchema", #"nonstandardLearnerSchema",
#	"xvalSpec", "clusteringOutput")
#	
#exportMethods("show", "RObject", "confuMat", "trainInd",
#              "precision", "recall", "sensitivity", "macroF1",
#              "F1", "acc", "tp", "tn", "fp", "fn", "specificity",
#              "MLearn", "planarPlot", "Predict", "getVarImp", 
#              "trainScores","trainPredictions",
#              "testScores", "testPredictions",
#              "predictions", "predScores", "predScore", 
#              "fsHistory", "report", "getDist", "getConverter")
#
#export(randomForestI, knnI, dldaI, nnetI, rpartI, 
#       ldaI, svmI, ldaI.predParms, qdaI, glmI.logistic, 
#       RABI, lvqI, naiveBayesI, baggingI, knn2, dlda2, 
#       rab, lvq, RAB, DAB, plsda2, svm2, ksvm2, 
#       xvalSpec, getVarImp, balKfold.xvspec, 
#       makeLearnerSchema, standardMLIConverter, sldaI, 
#       fs.absT, fs.probT, ksvmI, knn.cvI, knn.cv2, 
#       adaI, fs.topVariance, hclustI, kmeansI, pamI,
#       blackboostI,
#       gbm2, BgbmI, plsdaI,
#       confuTab) 
#
#S3method("predict", "classifierOutput")
#
#exportMethods("plot")
#export(hclustWidget, mlearnWidget)
#
#exportClasses("projectedLearner")
#export(projectLearnerToGrid)
#exportMethods("learnerIn3D", "plotOne")
#
#export(plspinHcube)
#
## recommended
#importFrom("grDevices", "colorRampPalette")
#importFrom("graphics", "axis", "barplot", "legend", "pairs", "par",
#             "points", "text")
#importFrom("stats", "as.formula", "cutree", "dist", "hclust", "median",
#             "model.frame", "model.matrix", "model.response", "na.fail",
#             "prcomp", "predict", "quantile", "terms", "var")
#

README.txt for MLInterfaces, Jun 19 2015

hclustWidget has been added to demonstrate roles for shiny, fpc, and ggvis in
tuning cluster analysis.

README.txt for MLInterfaces, Sep 16 2008

The *B methods have been removed.  The NAMESPACE is used to reduce
the number of symbols/classes/methods in play.  Handling of 
unsupervised learning via MLearn is in design.

README.txt for MLInterfaces, Sept 9 2007

Version 2.0 of MLInterfaces is imminent; I hope it will be available by
Sept 24.  Version 1.11.15+ includes a number of new approaches to
simplify maintenance and extensibility

Basic approach:
A learner function defined in a package with a namespace, that uses a formula interface,
and that has a predict method, is the most reasonable case and the one that the
interface design is based on.  A schema object is defined to provide access
to such learners and to define how their outputs are converted to standard
structures.

1) It is intended that all use will be through MLearn(formula, data, ...)
  a) The simplest usage is MLearn(formula, data, learnerSchema, trainInds).
Instances of learnerSchema identify the package and function constituting
the learner, and include a converter function with standard calling sequence
that converts results of the learner function into a classifierOutput
or clusteringOutput instance.  classifierOutput is currently defined, and
it manages the predictions (test and train) and any goodness of prediction
information produced.  It also includes the call and the full representation
of the learner's output.  When feature selection has been used in cross-validation,
the 'history' of feature selection is retained.
  b) Cross-validation is carried out using 
      MLearn(formula, data, learnerSchema, xvalSpec, ...)
Instances of xvalSpec define the partitioning of the data.  Of note is that
the former implementations of xval/xvalML did not generate MLOutput instances,
but the new implementation will generate objects identical in nature to those
produced in the train/test scheme described in 1a)
  At present MLearn+xvalSpec yields has all functionality of previous versions (including
support for functionally specified partition) but the way of handling feature selection
is different.  Instead of returning a set of feature scores, the function defining
feature selection needs to return a formula that includes the chosen features.  An
example of this is given with help(MLearn), and also shown below.  One feature
that is not retained with MLearn+xvalSpec is the xvalLoop generic with its support
for cluster computing.  I will introduce that ASAP, when I have a working example.
  c) So far, only supervised learning is handled in the new approach.  Now that
cross-validation is working, I will start to deal with unsupervised methods.
  d) A brief vignette that describes basic architecture with examples is in in
MLint_devel.Rnw.  This will be elaborated soon.

2) Back-compatibility and deprecation.  I have left the *B methods in place,
but they have been sequestered into a single file Bmethods.R.  Eventually
they will be deprecated, possibly by Sept 24.  The old version of MLearn,
which uses a string to identify the learner and a switch statement to
act, is retained for now but I do not intend to improve it in any way.
There was a problem with parameter capture in this design that motivated
the move to a schematic approach to learner specification.  It can stay 
indefinitely; we will just discourage use of strings and encourage the use of
schema objects to specify learners.

3) Benefits.  The primary MLearn method definition is 18 lines long.
Converter functions are typically around 8 lines long, and vary primarily
because of the different approaches to the 'predict' generic taken in
various machine learning packages.  We will not need a separate xval
wrapper.

4) Costs.  The calling sequence is modified slightly, so we would have
MLearn(sp~CL+RW, crabs, ldaI, c(1:25, 101:125)) instead of
MLearn(sp~CL+RW, crabs, "lda", c(1:25, 101:125)).  In most cases,
tuning parameters are passed using ... after the trainInd or
xvalSpec.  

Some learners have such idiosyncratic implementations (no formula interface, 
no predict method) that bridge methods need to be defined, and the schemas are
specified using closures to fix the tuning parameters: knnI(k=3,l=1) for example.
I would like to handle all tuning parameters uniformly, but this minority
of learners cannot be allowed to force major complexities on this package.


5) Examples

a) A simple formula+data frame test vs train exercise:

rf1 = MLearn(sp~CW+RW, data=crabs, randomForestI, kp, ntree=600 )
confuMat(rf1)

b) Cross-validation, LOO:

nn1cv = MLearn(sp~CW+RW, data=crabs[c(1:20,101:120),], nnetI, xvalSpec("LOO"), size=3, decay=.01 )

c) 5-fold cross-validation, partitions are balanced with respect to outcome class frequencies

nn2cv = MLearn(sp~CW+RW, data=crabs[c(1:20,101:120),], nnetI,
                  xvalSpec("LOG",5, balKfold.xvspec(5)), size=3, decay=.01 )

d) 5-fold cross-validation, feature selection using top 25% of features when ranked by
   two-sample t.  First define the fsFun:

fsFun.rowtQ3 = function(formula, data) {
 # facilitation of a rowttests with a formula/data.frame takes a little work
 mf = model.frame(formula, data)
 mm = model.matrix(formula, data)
 respind = attr( terms(formula, data=data), "response" )
 x = mm
 if ("(Intercept)" %in% colnames(x)) x = x[,-which(colnames(x) == "(Intercept)")]
 y = mf[, respind]
 respname = names(mf)[respind]
 nuy = length(unique(y))
 if (nuy > 2) warning("number of unique values of response exceeds 2")
 #dm = t(data.matrix(x))
 #dm = matrix(as.double(dm), nr=nrow(dm)) # rowttests seems fussy
 ans = abs( rowttests(t(x), factor(y), tstatOnly=TRUE)[[1]] )
 names(ans) = colnames(x)
 ans = names( ans[ which(ans > quantile(ans, .75) ) ] )
 btick = function(x) paste("`", x, "`", sep="")  # support for nonsyntactic varnames
 as.formula( paste(respname, paste(btick(ans), collapse="+"), sep="~"))
}

now deploy

library(golubEsets)
data(Golub_Train)
litg = Golub_Train[ 100:150, ]
g1 = MLearn(ALL.AML~. , litg, nnetI, xvalSpec("LOG",5, balKfold.xvspec(5), fsFun=fsFun.rowtQ3), size=3, decay=.01 )
confuMat(g1)
fsHistory(g1)

the fsFun is messy, and the acceptance criterion can be factored out to give more flexibility, eventually

setClass("raboostCont", representation(formula="formula", call="call"), contains="list")
setClass("daboostCont", contains="raboostCont")

setMethod("show", "raboostCont", function(object) {
 if (is(object, "daboostCont")) cat("discrete adaboost object,", length(object), "iterations.\n")
 else cat("real adaboost object,", length(object), "iterations.\n")
 cat("the call was:\n")
 print(object@call)
})

RAB = function(formula, data, maxiter=200, maxdepth=1) {
 if (as.character(as.list(formula)[[3]])[1] == ".") stop("please state the formula explicitly, no \".\"")
 theCall = match.call()
 out = list()
 tmpy = model.response(model.frame(formula, data=data))
 if (!is.factor(tmpy)) stop("response vbl must be factor with levels -1, 1")
 tmpy = as.character(tmpy)
 numy = as.numeric(tmpy)
 if (!all(tmpy %in% c("-1","1"))) stop("response must be coded -1, 1")
 N = nrow(data)
 w = rep(1/N, N)
 data = data.frame(data, w=w)
 print("real adaboost iterations:")
 for (i in seq_len(maxiter)) {
    cat(i)
    data$w = w
    tr = rpart(formula, data=data, maxdepth=maxdepth, weights=w)
    p = rpart:::predict.rpart(tr)[,2]
    p[p < .000001] = .000001
    p[p > .999999] = .999999
    f = .5*log(p/(1-p))
    w = w*exp(-numy*f)
    w = w/sum(w)
    out[[i]] = list(tree=tr, weight=w)
    }
 new("raboostCont", out, formula=formula, call=theCall)
}

setGeneric("Predict", function(object, ...) standardGeneric("Predict"))
setMethod("Predict", c("raboostCont"), function( object, ...) {
 logit = function(x) {
     x[x < .000001] = .000001
     x[x > .999999] = .999999
     log(x/(1-x))
     }
 argl = list(...)
 if (length(argl) > 0) {
   newdata = argl[["newdata"]]
   ans = lapply(object, function(x) rpart:::predict.rpart(x$tree, newdata))
 }
 else ans = lapply(object, function(x) rpart:::predict.rpart(x$tree))
 if (length(dim(ans[[1]])) == 2) newf = lapply(ans, function(x) .5*logit(x[,2]))
 else newf = lapply(ans, function(x) .5*logit(x[2]))
 addf = newf[[1]]
 for (i in 2:length(newf)) addf = addf+newf[[i]]
 ifelse(addf>0, 1, -1)
})

setMethod("Predict", c("daboostCont"), function( object, ...) {
 logit = function(x) {
     x[x < .000001] = .000001
     x[x > .999999] = .999999
     log(x/(1-x))
     }
 argl = list(...)
 if (length(argl) > 0) {
   newdata = argl[["newdata"]]
   ans = lapply(object, function(x) rpart:::predict.rpart(x$tree, newdata, type="class"))
 }
 else ans = lapply(object, function(x) rpart:::predict.rpart(x$tree, type="class"))
 anac = function(x) as.numeric(as.character(x))
 addf = object[[1]]$cm*anac(ans[[1]])
 for (i in 2:length(ans)) addf = addf+object[[i]]$cm*anac(ans[[i]])
 ifelse(addf>0, 1, -1)
})
	
DAB = function(formula, data, maxiter=200, maxdepth=1) {
 if (as.character(as.list(formula)[[3]])[1] == ".") stop("please state the formula explicitly, no \".\"")
 theCall = match.call()
 out = list()
 tmpy = model.response(model.frame(formula, data=data))
 if (!is.factor(tmpy)) stop("response vbl must be factor with levels -1, 1")
 tmpy = as.character(tmpy)
 numy = as.numeric(tmpy)
 if (!all(tmpy %in% c("-1","1"))) stop("response must be coded -1, 1")
 N = nrow(data)
 w = rep(1/N, N)
 data = data.frame(data, w=w)
 print("Discrete adaboost iterations:")
 for (i in seq_len(maxiter)) {
    cat(i)
    data$w = w
    tr = rpart(formula, data=data, maxdepth=maxdepth, weights=w)
    predcl = rpart:::predict.rpart(tr, type="class")
    err = mean(1*(fail <- (tmpy != as.character(predcl))))
    cm = log((1-err)/err)
    w = w*exp(cm*(1*fail))
    w = w/sum(w)
    out[[i]] = list(tree=tr, weight=w, cm=cm)
    }
 tmp = new("raboostCont", out, formula=formula, call=theCall)
 new("daboostCont", tmp)
}

mkfmla = function(respn, nvec) {
 as.formula(paste(respn, "~", paste(make.names(nvec), collapse="+")))
}

tonp = function(x, pos="Yes") {
 tmp = ifelse(x==pos,1,-1)
 factor(tmp)
}


RAB4es = function (respn, eset, val, maxiter=10, maxdepth=4)
{
    ee = data.frame(t(exprs(eset)))
    nn = names(ee)
    ff = mkfmla(respn, nn)
    tmp = tonp(eset[[respn]], val)
    ee = data.frame(ee, tmp)
    names(ee)[ncol(ee)] = respn
    RAB(ff, data=ee, maxiter=maxiter, maxdepth=maxdepth)
}

fs.absT = function(N) function(formula, data) {
 # take features using top N t stat in abs val
 # facilitation of a rowttests with a formula/data.frame takes a little work
 mf = model.frame(formula, data)
 mm = model.matrix(formula, data)
 respind = attr( terms(formula, data=data), "response" )
 x = mm
 if ("(Intercept)" %in% colnames(x)) x = x[,-which(colnames(x) == "(Intercept)")]
 if (N > dim(x)[2]) stop("N in fs.absT exceeds number of features available")
 y = mf[, respind]
 respname = names(mf)[respind]
 nuy = length(unique(y))
 if (nuy > 2) warning("number of unique values of response exceeds 2")
 ans = abs( genefilter::rowttests(t(x), factor(y), tstatOnly=TRUE)[[1]] )
 names(ans) = colnames(x)
 ans = names( sort(abs(ans),decreasing=TRUE)[seq_len(N)] )
 btick = function(x) paste("`", x, "`", sep="")  # support for nonsyntactic varnames
 as.formula( paste(respname, paste(btick(ans), collapse="+"), sep="~"))
}

fs.probT = function(p) function(formula, data) {
 # take features using features giving t stats in the 100pth percentile or above
 # facilitation of a rowttests with a formula/data.frame takes a little work
 if (p <= 0 | p >=1 ) stop("p in fs.percT must be in (0,1)")
 mf = model.frame(formula, data)
 mm = model.matrix(formula, data)
 respind = attr( terms(formula, data=data), "response" )
 x = mm
 if ("(Intercept)" %in% colnames(x)) x = x[,-which(colnames(x) == "(Intercept)")]
 y = mf[, respind]
 respname = names(mf)[respind]
 nuy = length(unique(y))
 if (nuy > 2) warning("number of unique values of response exceeds 2")
 ans = abs( genefilter::rowttests(t(x), factor(y), tstatOnly=TRUE)[[1]] )
 names(ans) = colnames(x)
 ans = names( ans[ which(ans > quantile(ans, p) ) ] )
 btick = function(x) paste("`", x, "`", sep="")  # support for nonsyntactic varnames
 as.formula( paste(respname, paste(btick(ans), collapse="+"), sep="~"))
}

fs.topVariance = function(p) function(formula, data) {
 # take features using features giving variance over samples the 100pth percentile or above
 if (p <= 0 | p >=1 ) stop("p in fs.topVariance must be in (0,1)")
 mf = model.frame(formula, data)
 mm = model.matrix(formula, data)
 respind = attr( terms(formula, data=data), "response" )
 respname = names(mf)[respind]
 x = mm
 if ("(Intercept)" %in% colnames(x)) x = x[,-which(colnames(x) == "(Intercept)")]
 ans = apply(x, 2, var, na.rm=TRUE)
 qv = quantile(ans, p)
 kp = which(ans > qv)
 names(ans) = colnames(x)
 ans = names( ans[ which(ans > quantile(ans, p) ) ] )
 btick = function(x) paste("`", x, "`", sep="")  # support for nonsyntactic varnames
 as.formula( paste(respname, paste(btick(ans), collapse="+"), sep="~"))
}

#####################
# PACKAGE: nnet
#####################
#
#####################
# title: nnetB
# description: interface to nnet {nnet}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# nnOut <- nnetB(golubMerge[100:200,], "ALL.AML", train)
# note: entropy, softmax, censored, linout (mutually exclusive) 
# are left to the user to specify if something other than the default
# is required (see nnet man page)
####################

setGeneric("nnetB", function(exprObj, classifLab, trainInd, weights, size=2, Wts, 
		mask, skip=FALSE, rang=0.7, decay=0, maxit=100, Hess=FALSE, trace=TRUE, MaxNWts=1000, 
		abstol=1.0e-4, reltol=1.0e-8, metric="euclidean", ...){
		standardGeneric("nnetB")
})


setMethod("nnetB", c("ExpressionSet", "character", "integer", "ANY", "ANY", 
		"ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", 
		"ANY", "ANY", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, weights, size, Wts, mask, 
			skip, rang, decay, maxit, Hess, trace, MaxNWts, abstol, reltol, metric, ...){
		
			cl <- pData(exprObj)[[classifLab]][trainInd]

			trainDat <- data.frame(t(exprs(exprObj)[,trainInd]), sampLab = cl)
			testDat <- data.frame(t(exprs(exprObj)[,-trainInd]))

			dis <- dist(testDat, method=metric)
	
			if(missing(weights)){ weights <- rep(1,length(cl)) }
			if(missing(Wts)){ Wts <- NULL }
			if(missing(mask)){ mask <- NULL }
			out <- nnet::nnet(sampLab~., data=trainDat, weights=weights, size=size, skip=skip, 
						rang=rang, decay=decay, maxit=maxit, Hess=Hess, trace=trace, 
						MaxNWts=MaxNWts, abstol=abstol, reltol=reltol, ...) 

			new("classifOutput", method="nnet",
	predLabels=newPredClass(as.character(predict(out, testDat, type="class"))), 
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
        predScores=newProbMat(predict(out, newdata=testDat)), call=match.call(),
        distMat=dis, RObject=out)	
})		  

#####################
# PACKAGE: e1071
#####################
#
#####################
# title: bclustB
# description: interface to bclust {e1071}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	dist.method	for distance matrix (equivalent to the "metric" argument in other 
#			machLI interfaces, eg. see knnB)
# value:
# 	object of class "classifPred"
# example:
# bOut <- bclustB(golubMerge[100:200,], "ALL.AML", 2)
####################

setGeneric("bclustB", function(exprObj, k, height=0, iter.base=10, minsize=0, dist.method="euclidian", 
		hclust.method="average", base.method="kmeans", base.centers=5, verbose=TRUE, 
		final.kmeans=FALSE, docmdscale=FALSE, resample=TRUE, weights, maxcluster=5, ...){
		standardGeneric("bclustB")
})

setMethod("bclustB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY",
		"ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, k, height, iter.base, minsize, dist.method, hclust.method, base.method, 
			base.centers, verbose, final.kmeans, docmdscale, resample, weights, 
			maxcluster, ...){

			if(missing(weights)){ weights <- NULL }

			dat <- t(exprs(exprObj))
			dis <- dist(dat, method=dist.method)
			out <- e1071::bclust(dat, k, iter.base=iter.base, minsize=minsize, 
						dist.method=dist.method, hclust.method=hclust.method, 
						base.method=base.method, base.centers=base.centers, 
						verbose=verbose, final.kmeans=final.kmeans,
						docmdscale=docmdscale, resample=resample, weights=weights, 
									maxcluster=maxcluster, ...)
# CANNOT USE WRAPCLUST                tmp <- wrapClust( out, k, height, dis) 
		if (k > 0 && height > 0) warn("both k and height provided, using k")
		if (k > 0) clinds <- newGroupIndex(out$cluster)
		else if (k == 0 & height > 0)
			clinds <- cutree(out$hclust, h=height)
		clsco <- newSilhouetteVec(cluster::silhouette(clinds,dis)[,3])
                new("clustOutput", method="bclust",
                        RObject=out, call=match.call(),
                        distMat=dis,
                        clustIndices=clinds, clustScores=clsco)


})

#####################
# title: cmeansB
# description: interface to cmeans {e1071}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	dist		for distance matrix (equivalent to the "metric" argument in other 
#			machLI interfaces, eg. see knnB)
# value:
# 	object of class "classifPred"
# example:
# cOut <- cmeansB(golubMerge[100:200,], "ALL.AML", 2)
####################

setGeneric("cmeansB", function(exprObj, k, height=0, iter.max=100, verbose=FALSE, dist="euclidean", 
		method="cmeans", m=2, rate.par=NULL){
		standardGeneric("cmeansB")
})

setMethod("cmeansB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, k, height=0, iter.max, verbose, dist, method, m, rate.par){

			dat <- t(exprs(exprObj))
			dis <- dist(dat, method=dist)
			out <- e1071::cmeans(dat, k, iter.max=iter.max, verbose=verbose, dist=dist,
						method=method, m=m, rate.par=rate.par)
			
                	clinds <- newGroupIndex(out$cluster)
                	clsco <- newSilhouetteVec(cluster::silhouette( clinds, dis )[,3])
                new("clustOutput", method="cmeans",
                        RObject=out, call=match.call(),
                        distMat=dis,
                        clustIndices=clinds, clustScores=clsco)
})


setGeneric("cshellB", function(exprObj, k, height=0, iter.max=20, verbose=FALSE, dist="euclidean", 
		method="cshell", m=2, radius){
		standardGeneric("cshellB")
})

setMethod("cshellB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, k, height, iter.max, verbose, dist, method, m, radius){

		dat <- t(exprs(exprObj))
		dis <- dist(dat, method=dist)

		if(missing(radius)){

			out <- e1071::cshell(dat, k, iter.max=iter.max, verbose=verbose, dist=dist,
						method=method, m=m)
		}
		else{
			out <- e1071::cshell(dat, k, iter.max=iter.max, verbose=verbose, dist=dist,
						method=method, m=m, radius=radius)
		}
                clinds <- newGroupIndex(out$cluster)
                clsco <- newMembMat(out$membership)
                new("clustOutput", method="cmeans",
                        RObject=out, call=match.call(),
                        distMat=dis,
                        clustIndices=clinds, clustScores=clsco)

})

######################
## title: icaB
## description: interface to ica {e1071}
## arguments:
##	exprObj		ExpressionSet
##	metric		for distance matrix 
## value:
## 	object of class "classifPred"
##	where sampLabels are the labels of the original sample
## example:
## icaOut <- icaB(golubMerge[100:150,], "ALL.AML", 100)
## note: is there a better way to specify a learning rate? 
## ica {e1071} outputs weights and projection that are all NaN
## initweights output corresponds to the condensed profiles (rows) across columns
#####################
#
#setGeneric("icaB", function(exprObj, classifLab, lrate, epochs=100, ncomp, fun="negative", metric="euclidean"){
#		standardGeneric("icaB")
#})

#setMethod("icaB", c("ExpressionSet", "character", "ANY", "ANY", "ANY", "ANY", "ANY"), 
#			function(exprObj, classifLab, lrate, epochs, ncomp, fun, metric){
#			
#			dat <- t(exprs(exprObj))
#			dis <- dist(dat, method=metric)
#			out <- e1071::ica(dat, lrate, epochs=epochs, ncomp=dim(dat)[2], fun=fun)
#
#			new("classifPred", sampLabels=pData(exprObj)[[classifLab]], distMat=dis, classifObj=out)
#})
#
######################
## title: lcaB
## description: interface to lca {e1071}
# arguments:
#	exprObj		ExpressionSet
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# x <- matrix(sample(c(0,1), 7272, replace=T), ncol=72, nrow=12)
# colnames(x) <- golubMerge$"ALL.AML"
# g2Merge <- golubMerge[100:111,]
# exprs(g2Merge) <- x
# lcaOut <- lcaB(g2Merge, "ALL.AML", 2)
# note: artificial example since data needs to be binary
# for > 15 genes, lca algorithm runs out of memory
# for a much larger number of genes, error is returned
####################

setGeneric("lcaB", function(exprObj, k, niter=100, matchdata=TRUE, verbose=FALSE, metric="euclidean"){
	standardGeneric("lcaB")
})

setMethod("lcaB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY"), 
			function(exprObj, k, niter, matchdata, verbose, metric){

			dat <- t(exprs(exprObj))
	if (!all(dat %in% c(0,1))) stop("binary expr data required")
			dis <- dist(dat, method=metric)
			out <- e1071::lca(dat, k, niter=niter, matchdata=matchdata, verbose=verbose) 
                	clinds <- newGroupIndex(out$matching)
                	clsco <- newSilhouetteVec(cluster::silhouette( clinds, dis )[,3])
                	new("clustOutput", method="lca",
                        	RObject=out, call=match.call(),
                        	distMat=dis,
                        	clustIndices=clinds, clustScores=clsco)
})

#####################
# title: naiveBayesB
# description: interface to naiveBayes {e1071}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 24), sample(48:72, 12))
# nbOut <- naiveBayesB(golubMerge[100:110,], "ALL.AML", train)
# note:
# algorithm appears to be bad at handling a large number of genes (ie. columns in naiveBayes)
####################

setGeneric("naiveBayesB", function(exprObj, classifLab, trainInd,	na.action=na.pass, threshold=0.001, 
		metric="euclidean"){
		standardGeneric("naiveBayesB")
})

setMethod("naiveBayesB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, na.action, threshold, metric){

		cl <- pData(exprObj)[[classifLab]][trainInd]		
		trainDat <- data.frame(y=cl, t(exprs(exprObj)[,trainInd]))
		testDat <- data.frame(t(exprs(exprObj)[,-trainInd]))	
		dis <- dist(testDat, method=metric)
		model <- e1071::naiveBayes(y~., data=trainDat)
		out <- predict( model, newdata=testDat )
                new("classifOutput", method="naiveBayes",
                        predLabels=newPredClass(as.character(out)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
                #        predScores=newQualScore(attr(out,"prob")),
                        RObject=model, call=match.call(), distMat=dis)
                                                                                
})

#####################
# title: svmB
# description: interface to svm {e1071} 
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# svmOut <- svmB(golubMerge[100:200,], "ALL.AML", train)
#####################

setGeneric("svmB", function(exprObj, classifLab, trainInd, scale=TRUE, 
		type, kernel="radial", degree=3, gamma, coef0 = 0, 
		cost = 1, nu = 0.5, class.weights, cachesize = 40, 
		tolerance = 0.001, epsilon = 0.1, shrinking = TRUE, cross = 0, 
		fitted = TRUE, subset, na.action = na.omit, decision.values=FALSE, metric="euclidean", ...){
		standardGeneric("svmB")
})

setMethod("svmB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", "ANY",
		"ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", 
		"ANY", "ANY", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, scale, type, kernel, degree, gamma, 
		coef0, cost, nu, class.weights, cachesize, tolerance, epsilon, shrinking, 
		cross, fitted, subset, na.action, decision.values, metric, ...){

			trainDat <- t(exprs(exprObj)[,trainInd])
			testDat <- t(exprs(exprObj)[,-trainInd])
			dis <- dist(testDat, method=metric)
			cl <- pData(exprObj)[[classifLab]][trainInd]

			if(missing(type)){ type <- NULL }
			if(missing(class.weights)){ class.weights <- NULL }
			if(missing(gamma)){ gamma <- 1/ncol(trainDat) }

			out <- e1071::svm(trainDat, cl, scale=scale, type=type, kernel=kernel, degree=degree, 
					gamma=gamma, coef0=coef0, cost=cost, nu=nu, class.weights=class.weights, 
					cachesize=cachesize, tolerance=tolerance, epsilon=epsilon, shrinking=shrinking, 
					cross=cross, fitted=fitted, subset=subset, na.action = na.action, ...)
		  			
			ans <- predict(out, newdata=testDat,
				decision.values=decision.values, na.action=na.action)
                new("classifOutput", method="svm",
                        predLabels=newPredClass(as.character(ans)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
                #        predScores=newQualScore(attr(out,"prob")),
                        RObject=out, call=match.call(), distMat=dis)
			
})

# description: interface to som {som} 
# arguments:
#	exprObj		ExpressionSet
#	xdim		x dimension
#	ydim		y dimension
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# somOut <- somB(golubMerge[100:200,], "ALL.AML", 2, 3)
#####################

setClass("somout", contains="list")
setMethod("show", "somout", function(object) {
 cat("somB output\n")
 print(object$call)
 cat("available elements:\n")
 print(names(object))
})

setGeneric("somB", function(exprObj, classifLab, xdim=3, ydim=3, init="linear", alpha, alphaType="inverse", 
		neigh="gaussian", topol="rect", radius, rlen, err.radius=1, inv.alp.c, metric="euclidean"){
		standardGeneric("somB")
})

setMethod("somB", c("ExpressionSet", "character", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", 
		"ANY", "ANY"), 
		function(exprObj, classifLab, xdim, ydim, init, alpha, alphaType, neigh, topol, 
		radius, rlen, err.radius, inv.alp.c, metric){

		if(missing(alpha)){ alpha <- NULL }
		if(missing(radius)){ radius <- NULL }
		if(missing(rlen)){ rlen <- NULL }
		if(missing(inv.alp.c)){ inv.alp.c <- NULL }
		dat <- t(exprs(exprObj))
		dis <- dist(dat, method=metric)
		out <- som::som(dat, xdim, ydim, init=init, alpha=alpha, alphaType=alphaType, neigh=neigh,
				topol=topol, radius=radius, rlen=rlen, err.radius=err.radius,
				inv.alp.c=inv.alp.c)

		new("somout", list(method="som", somout=out, call=match.call()))
})
	


setClass("SOMBout", contains="list")
setMethod("show", "SOMBout", function(object) {
 cat("SOMB output\n")
 print(object$call)
 cat("available elements:\n")
 print(names(object))
})

setMethod("SOMB", c("ExpressionSet", "character", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, classifLab, kx, ky, topo, rlen, alpha, radii, init, metric){

		dat <- t(exprs(exprObj))
		dis <- dist(dat, method=metric)
		sgrid <- class::somgrid(xdim=kx, ydim=ky, topo=topo)
		out <- class::SOM(dat, sgrid, rlen=rlen, alpha=alpha, radii=radii, init)
#		new("classifPred", sampLabels=pData(exprObj)[[classifLab]], distMat=dis, classifObj=out)
# this function has no commonality with the others, just return a list for now
		new("SOMBout", list(method="SOM", SOMout=out, SOMgrid=sgrid, distMat=dis,
			call=match.call()))

})

#setGeneric("xval", function(data, classLab, proc, xvalMethod, group, indFun, niter, fsFun=NULL, fsNum=NULL,
# decreasing=TRUE, cluster = NULL, ...)
# standardGeneric("xval"))
#
#chkMLInterfaceProc <- function(x) {
# if (!is(x, "genericFunction")) stop("requires generic function [not name] as proc")
# xn <- x@generic
##
## the following gets the 'defined' type signature for the generic
## [note that the definition of signature for a generic 
## by JMC is the list of formal parameters -- i need the signature
## for a method.
##
# tySig <- methods::methodSignatureMatrix(getMethod(xn, c("ExpressionSet", "character", "integer")))[2,]
# if( x@package != "MLInterfaces" || !all(tySig == c("ExpressionSet", "character",
#	"integer"))) stop(paste(x, "not bearing proper signature"))
# else return(TRUE)
#}
#
#setMethod("xval", c("ExpressionSet", "character", "genericFunction", "character", "integer", "ANY", "ANY", "ANY",
#                    "ANY", "ANY", "ANY" ),
#          function(data, classLab, proc, xvalMethod="LOO", group, indFun, niter, fsFun=NULL, fsNum=10, decreasing=TRUE, cluster = NULL,...) {
#
#          if (!(xvalMethod %in% c("LOO", "LOG", "FUN"))) 
#              stop("unrecognised xvalMethod")
#          if(!any(classLab == names(pData(data))))
#              stop("unrecognised classLab")
#          xvalLoop <- xvalLoop(cluster)
#	  N = ncol(exprs(data))
#          inds <- seq_len(N)
#
#          ## cross-validation selection procedure
#          if (xvalMethod == "LOO")
#          {
#              n <- length(inds)
#              selnProc <- function(i) -i
#          }
#          else if (xvalMethod == "LOG")
#          {
#              ug <- unique(group)
#              n <- length(ug)
#              selnProc <- function(i) group != ug[i]
#          }
#          else                          # FUN
#          {
#              n <- niter
#              selnProc <- function(i) indFun( data, classLab, i )
#          }
#
#          fs.idx <- seq_len(nrow(exprs(data)))           # feature set index
#          ## feature set selection
#          if (missing(fsFun))
#              fsProc <- function(idx, fs.idx) fs.idx
#          else
#          { ## original by Stephen Henderson, to support feature selection
#              if (!is.function(fsFun)) stop("fsFun should be a function")
#              fsProc <- function(idx, fs.idx) {
#                  fs.scores <- fsFun(data[,idx], classLab)
#                  sort(fs.scores, index.return=TRUE, decreasing=decreasing)$ix[seq_len(fsNum)]
#              }
#          }
#
#          ## cross-validator
#          xvalidator <- function(i, ...) {
#              idx <- selnProc(i)
#              fs.idx <- fsProc(idx, fs.idx)
#              list( proc( data[fs.idx,], classLab, inds[idx], ...)@predLabels@.Data, fs.idx )
#          }
#
#          out <- xvalLoop( seq_len(n), xvalidator, ... )
#          classif <- unlist( sapply( out, function(x) x[[1]] ) )
#
#          if (!is.function(fsFun))
#              return(classif)
#          else {
#              fs.memory <- as.vector( sapply( out, function(x) x[[2]] ) )
#              return(list(fs.memory=fs.memory, out=classif))
#         }
#      })
#
#setMethod("xval", c("ExpressionSet", "character", "genericFunction", "character", "missing", "ANY", "ANY", "ANY",
#  "ANY", "ANY", "ANY" ),
#function(data, classLab, proc, xvalMethod="LOO", group=0:0, indFun, niter, fsFun=NULL, fsNum=10, decreasing=TRUE, cluster = NULL, ...) 
#{
#    xval(data, classLab, proc, xvalMethod="LOO", group=0:0)
#})
#
#
#balKfold <- function(K) function( data, clab, iternum ) {
##
## old approach that assumes data are ExpressionSet...
##
# clabs <- pData(data)[[clab]]
# narr <- nrow(pData(data))
# cnames <- unique(clabs)
# ilist <- list()
# for (i in seq_len(length(cnames)))
#   ilist[[cnames[i]]] <- which( clabs == cnames[i] )
# clens <- lapply(ilist,length)
# nrep <- lapply(clens, function(x) ceiling(x/K))
# grpinds <- list()
# for (i in seq_len(length(nrep)))
#   grpinds[[i]] <- rep(seq_len(K), nrep[[i]])[seq_len(clens[[i]])]
# (seq_len(narr))[ - which( unlist(grpinds)==iternum ) ]
#}

balKfold.xvspec <- function(K) function( data, clab, iternum ) {
# redefined for data.frame application in xvalSpec usage
# defines the training set indices
 clabs <- data[[clab]]
 narr <- nrow(data)
 cnames <- unique(clabs)
 ilist <- list()
 for (i in seq_len(length(cnames)))
   ilist[[cnames[i]]] <- which( clabs == cnames[i] )
 clens <- lapply(ilist,length)
 nrep <- lapply(clens, function(x) ceiling(x/K))
 grpinds <- list()
 for (i in seq_len(length(nrep)))
   grpinds[[i]] <- rep(seq_len(K), nrep[[i]])[seq_len(clens[[i]])]
 (seq_len(narr))[ - which( unlist(grpinds)==iternum ) ]
}


## xvalLoop is a 'hook' to customize how xval execute. The default is
## a simple lapply

setGeneric("xvalLoop", function( cluster, ... ) standardGeneric("xvalLoop") )

setMethod("xvalLoop", signature( cluster = "ANY" ), # default method -- return function 'lapply'
          function( cluster, ... ) lapply )

#setGeneric("xvalML", 
#          function(formula, data, proc, xvalMethod="LOO", 
#            group, indFun, niter, fsFun=NULL, fsNum=10, 
#            decreasing=TRUE, cluster = NULL,...) 
#  { standardGeneric("xvalML") })
#
#setMethod("xvalML", c("formula", "ExpressionSet", "character", 
#                    "character", "numeric", "ANY", "ANY", "ANY",
#                    "ANY", "ANY", "ANY" ),
#          function(formula, data, proc, 
#                     xvalMethod="LOO", group, 
#                     indFun, niter, fsFun=NULL, fsNum=10, 
#                     decreasing=TRUE, cluster = NULL,...) {
#
#          if (!(xvalMethod %in% c("LOO", "LOG", "FUN"))) 
#              stop("unrecognised xvalMethod")
#          xvalLoop <- xvalLoop(cluster)
#          
#	  classLab = respn = as.character(as.list(formula)[[2]])
#          if(!any(classLab == names(pData(data))))
#              stop("unrecognised response variable")
#          N <- ncol(exprs(data))
#          inds <- seq_len(N)
#
#          ## cross-validation selection procedure
#          if (xvalMethod == "LOO")
#          {
#              n <- length(inds)
#              selnProc <- function(i) -i
#          }
#          else if (xvalMethod == "LOG")
#          {
#              ug <- unique(group)
#              n <- length(ug)
#              selnProc <- function(i) group != ug[i]
#          }
#          else                          # FUN
#          {
#              n <- niter
#              selnProc <- function(i) indFun( data, classLab, i )
#          }
#
#	  #reddata = exprs(data)[ attr(terms(formula), "term.labels")
#          fs.idx <- seq_len(nrow(exprs(data)))           # feature set index
#          ## feature set selection
#          if (missing(fsFun))
#              fsProc <- function(idx, fs.idx) fs.idx
#          else
#          { ## original by Stephen Henderson, to support feature selection
#              if (!is.function(fsFun)) stop("fsFun should be a function")
#              fsProc <- function(idx, fs.idx) {
#                  fs.scores <- fsFun(data[,idx], classLab)
#                  sort(fs.scores, index.return=TRUE, decreasing=decreasing)$ix[seq_len(fsNum)]
#              }
#          }
#
#          ## cross-validator
#          allGN = rownames(exprs(data))
#          xvalidator <- function(i, ...) {
##	      if (i == 1) print("xval iteration:") -- consider verbosity check
##              cat(i)
#              idx <- selnProc(i)
#              fs.idx <- fsProc(idx, fs.idx)
##
## BAD!!!  why not use the actual formula?  feature selection
## present in build 24497 assumes using all features in data
## we want to use formula unless fsFun exists
##
#              if (!is.null(fsFun)) newfmla = mkfmla(respn, allGN[fs.idx])
#              else newfmla = formula
#              list( MLearn(newfmla, data[fs.idx,], proc, inds[idx], ...)@predLabels@.Data, fs.idx )
#          }
#
#          out <- xvalLoop( seq_len(n), xvalidator, ... )
#          classif <- unlist( sapply( out, function(x) x[[1]] ) )
#
#          if (!is.function(fsFun))
#              return(as.factor(as.character(classif)))
#          else {
#              fs.memory <- as.vector( sapply( out, function(x) x[[2]] ) )
#              return(list(fs.memory=fs.memory, out=classif))
#         }
#      })
#
#setMethod("xvalML", c("formula", "ExpressionSet", "character", 
#                    "character", "missing", "missing", "missing", "missing",
#                    "missing", "missing", "missing" ),
#          function(formula, data, proc, 
#                     xvalMethod="LOO", group, 
#                     indFun, niter, fsFun=NULL, fsNum=10, 
#                     decreasing=TRUE, cluster = NULL,...) {
#xvalML( formula, data, proc, xvalMethod, 0, 
#		...)
#})
#
#setMethod("xvalML", c("formula", "ExpressionSet", "character", 
#                    "character", "missing", "missing", "missing", "function",
#                    "missing", "missing", "missing" ),
#          function(formula, data, proc, 
#                     xvalMethod="LOO", group, 
#                     indFun, niter, fsFun=NULL, fsNum=10, 
#                     decreasing=TRUE, cluster = NULL,...) {
#xvalML( formula, data, proc, xvalMethod, 0, , , fsFun ,
#		...)
#})
#
#setMethod("xvalML", c("formula", "ExpressionSet", "character", 
#                    "character", "missing", "missing", "missing", "function",
#                    "numeric", "missing", "missing" ),
#          function(formula, data, proc, 
#                     xvalMethod="LOO", group, 
#                     indFun, niter, fsFun=NULL, fsNum=10, 
#                     decreasing=TRUE, cluster = NULL,...) {
#xvalML( formula, data, proc, xvalMethod, 0, , , fsFun , fsNum,
#		...)
#})

setGeneric("stat.diag.daB", function(exprObj, classifLab, trainInd, 
 pool=1, metric="euclidean", ...) standardGeneric("stat.diag.daB") )

setMethod("stat.diag.daB", c("ExpressionSet", "character", "integer", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, pool,  
                       metric, ...){
		
			require(sma) # nice if it had a namespace
			cl <- pData(exprObj)[[classifLab]][trainInd]

			trainDat <- t(exprs(exprObj)[,trainInd])
			testDat <- t(exprs(exprObj)[,-trainInd])

			dis <- dist(testDat, method=metric)
	
			out <- stat.diag.da(trainDat,
   as.integer(factor(cl)), testDat, pool=pool )

			new("classifOutput", method="stat.diag.da",
	predLabels=newPredClass(as.character(out$pred)), 
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
        call=match.call(),
        distMat=dis, RObject=out)	
})		  

#####################
# PACKAGE: stats (formerly mva)
#####################

wrapClust <- function( out, k, height, dis )
{
                if (k>0 && height>0)
                        {
                        warning("both nclust(k) and height supplied, using nclust")
                        clinds <- newGroupIndex(cutree(out,k))
                        }
                else if (k > 0 && height == 0)
                        clinds <- newGroupIndex(cutree(out,k))
                else if (k == 0 && height > 0)
                        clinds <- newGroupIndex(cutree(as.hclust(out),h=height))                else clinds <- NA
                clsco <- newSilhouetteVec(cluster::silhouette( clinds, dis )[,3])
return(list(clinds=clinds, clsco=clsco))
}

#
#####################
# title: hclustB
# description: interface to hclust {stats}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# hOut <- hclustB(golubMerge[100:200,], "ALL.AML")
####################

setGeneric("hclustB", function(exprObj, k, height, method="complete", members, metric="euclidean"){
			standardGeneric("hclustB")
})
setMethod("hclustB", c("ExpressionSet", "numeric", "missing", "ANY", "ANY", "ANY"), 
			function(exprObj, k, height, method, members, metric)
			hclustB(exprObj=exprObj, k=k, height=0, method=method , 
				members=members, metric=metric))
setMethod("hclustB", c("ExpressionSet", "missing", "numeric", "ANY", "ANY", "ANY"), 
			function(exprObj, k, height, method, members, metric)
			hclustB(exprObj=exprObj, k=0, height=height, method=method , 
				members=members, metric=metric))

setMethod("hclustB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY"), 
			function(exprObj, k, height, method, members, metric){

			if(missing(members)){ members <- NULL }

			dat <- t(exprs(exprObj))
			dis <- dist(dat, method=metric)
			out <- stats::hclust(dis, method=method, members=members)
#                if (k>0 && height>0) 
#                        {
#                        warning("both nclust(k) and height supplied, using nclust")
#                        clinds <- newGroupIndex(cutree(out,k))
#                        }
#                else if (k > 0 && height == 0)
#                        clinds <- newGroupIndex(cutree(out,k))
#                else if (k == 0 && height > 0)
#                        clinds <- newGroupIndex(cutree(as.hclust(out),h=height))                else clinds <- NA
#                clsco <- newSilhouetteVec(cluster::silhouette( clinds, dis )[,3])

                 tmp <- wrapClust(out, k, height, dis)

                new("clustOutput", method="hclust",
                        RObject=out, call=match.call(),
                        distMat=dis,
                        clustIndices=tmp$clinds, clustScores=tmp$clsco)

})

#####################
# title: kmeansB
# description: interface to kmeans {stats}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# kOut <- kmeansB(golubMerge[100:200,], "ALL.AML", 2)
####################

setGeneric("kmeansB", function(exprObj, k, iter.max=10, metric="euclidean"){
			standardGeneric("kmeansB")
})

setMethod("kmeansB", c("ExpressionSet", "numeric", "ANY", "ANY"), 
			function(exprObj, k, iter.max, metric){

			dat <- t(exprs(exprObj))
			dis <- dist(dat, method=metric)			
			out <- stats::kmeans(dis, centers=k, iter.max=iter.max)
                clinds <- newGroupIndex(out$cluster)
                clsco <- newSilhouetteVec(cluster::silhouette( clinds, dis )[,3])
                new("clustOutput", method="kmeans",
                        RObject=out, call=match.call(),
                        distMat=dis,
                        clustIndices=clinds, clustScores=clsco)
})

#####################
# title: prcompB
# description: interface to prcomp {stats}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# prOut <- prcompB(golubMerge[100:200,], "ALL.AML")
####################
#
#setGeneric("prcompB", function(exprObj, classifLab, retx=TRUE, center=TRUE, scale.=FALSE, tol, metric="euclidean"){
#			standardGeneric("prcompB")
#})
#
#setMethod("prcompB", c("ExpressionSet", "character", "ANY", "ANY", "ANY", "ANY", "ANY"), 
#			function(exprObj, classifLab, retx, center, scale., tol, metric){
#
#			if(missing(tol)){ tol <- NULL }
#
#			dat <- t(exprs(exprObj))
#			dis <- dist(dat, method=metric)
#			cl <- exprObj[[classifLab]]
#			row.names(dat) <- cl
#			out <- stats::prcomp(dat, retx=retx, center=center, scale.=scale., tol=tol)
#
#			new("classifPred", sampLabels=cl, distMat=dis, classifObj=out)
#
#})

setMethod("show", "learnerSchema", function(object) {
 cat("MLInterfaces schema for", object@mlFunName, "in", object@packageName, "\n")
})

makeLearnerSchema = function(packname, mlfunname, converter, predicter) {
  if (missing(predicter)) 
    return(new("learnerSchema",
               packageName=packname,
               mlFunName=mlfunname,  # assumes it is exported?
               converter=converter))
  return(new("learnerSchema",
             packageName=packname,
             mlFunName=mlfunname,
             converter=converter,
             predicter=predicter))
}

makeClusteringSchema = function(packname, mlfunname, distMethod, converter,
  agglomMethod, algorithm, ...) {
 if (missing(agglomMethod)) agglomMethod="none"
 if (missing(algorithm)) algorithm="none"
 new("clusteringSchema", packageName=packname, mlFunName=mlfunname,
   distMethod=distMethod, converter=converter, 
   agglomMethod=agglomMethod, algorithm=algorithm, extras=list(...)) }

## IMPORTANT: Confusion matrix expects
##  *known*  classes to be along the *columns* and
##  *predicted* ones to be along the *rows*

naAs0 <- function(x) {
    x[is.na(x)] <- 0
    x
}

## for testing
makeConfuMat <- function(i = 0:5, j = 15:20, k = 3) {
    if (k > 26)
        k <- 26
    m <- matrix(sample(i, 9, replace=TRUE), k)
    dimnames(m) <- list(predicted = LETTERS[seq_len(k)],
                        known = LETTERS[seq_len(k)])
    diag(m) <- sample(j, 3)
    as.table(m)
}


## See sensitivity and specificity methods in caret
## Want all the following to work on
## - 2 characters/factors/numerics
## - a table

## -> write the S4 methods and use caret

.tp <- function(mat) {
    ans <- diag(mat)
    if (nrow(mat) == 2)
        ans <- ans[1]
    return(ans)
}

.tn <- function(mat) {
    if (nrow(mat) == 2) {
        ans <- mat[2,2]
    } else {
        ans <- sapply(seq_len(nrow(mat)),
                      function(i) sum(mat[-i, ][, -i]))
        names(ans) <- rownames(mat)    
    }
    return(ans)
}

.fp <- function(mat) {
    ans <- rowSums(mat)-diag(mat)
    if (nrow(mat) == 2)
        ans <- ans[1]
    return(ans)
}

.fn <- function(mat) {
    ans <- colSums(mat)-diag(mat)
    if (nrow(mat) == 2)
        ans <- ans[2]
    return(ans)
}

.accuracy <- function(mat, naAs0. = FALSE) {
    if (naAs0.) mat <- naAs0(mat)
    sum(diag(mat))/sum(mat)
}

.sensitivity <- 
    .recall <- function(mat, naAs0. = FALSE) {
        if (naAs0.) mat <- naAs0(mat)
        diag(mat)/colSums(mat)
    }


.specificity <- function(mat, naAs0. = FALSE) {
    if (naAs0.) mat <- naAs0(mat)
    TN <- .tn(mat)
    FP <- .fp(mat)
    TN/(TN+FP)
}

.precision <- function(mat, naAs0. = FALSE) {
    if (naAs0.) mat <- naAs0(mat)
    diag(mat)/rowSums(mat)
}

.F1 <- function(mat, naAs0. = FALSE) {
    if (naAs0.) mat <- naAs0(mat)
    r <- .recall(mat, naAs0.)
    p <- .precision(mat, naAs0.)
    ans <- (2*p*r)/(p+r)
    if (naAs0.) ans <- naAs0(ans)
    return(ans)
}


.macroF1 <- function(p, r, naAs0. = FALSE) {
    if (naAs0.) p <- naAs0(p)            
    if (missing(r)) { 
        F1 <- .F1(p, naAs0. = naAs0)
    } else {
        if (naAs0.) r <- naAs0(r)            
        F1 <- (2*p*r)/(p+r)
    }
    if (naAs0.) F1 <- naAs0(F1)
    mean(F1) ## macro F1
}

## ._F1 <- function(mat, i) {
##   TP <- .tp(mat)[i]
##   FN <- .fn(mat)[i]
##   FP <- .fp(mat)[i] 
##   p <- sum(TP)/sum(TP, FP)
##   r <- sum(TP)/sum(TP, FN)
##   return((2*p*r)/(p+r))  
## }

## .macroF1_OLD <- function(p, r) {
##   if (!all.equal(names(p), names(r)))
##     stop("precision and recall do not match.")
##   p <- mean(p)
##   r <- mean(r)
##   return((2*p*r)/(p+r))
## }

setGeneric("acc", function(obj, ...) standardGeneric("acc"))
setMethod("acc", "table", function(obj, ...) .accuracy(obj, ...))

setGeneric("tp", function(obj, ...) standardGeneric("tp"))
setMethod("tp", "table", function(obj) .tp(obj))

setGeneric("tn", function(obj, ...) standardGeneric("tn"))
setMethod("tn", "table", function(obj) .tn(obj))

setGeneric("fn", function(obj, ...) standardGeneric("fn"))
setMethod("fn", "table", function(obj) .fn(obj))

setGeneric("fp", function(obj, ...) standardGeneric("fp"))
setMethod("fp", "table", function(obj) .fp(obj))

setGeneric("F1", function(obj, ...) standardGeneric("F1"))
setMethod("F1", "table", function(obj, ...) .F1(obj, ...))

setGeneric("specificity", function(obj, ...) standardGeneric("specificity"))
setMethod("specificity", "table", function(obj, ...) .specificity(obj, ...))

## Generic defined in methods-classification.R
setMethod("macroF1", c("table","missing"),
          function(obj, type, naAs0. = FALSE, ...) {
              return(.macroF1(obj, naAs0., ...))
          })

setMethod("macroF1", c("numeric","numeric"),
          function(obj, type, ...) {
              ## obj is precision
              ## type is recall
              return(.macroF1(obj, type, ...))
          })

setMethod("recall", c("table","missing"),
          function(obj, type, ...) return(.recall(obj, ...)))

setMethod("precision", c("table","missing"),
          function(obj, type, ...) return(.precision(obj, ...)))


confuTab <- function(obj, naAs0. = FALSE) {
    .makeConfuTab <- function(x) {    
        m <- matrix(x, nrow = 2)
        dimnames(m) <- list(predicted = c(TRUE, FALSE),
                            known = c(TRUE, FALSE))                        
        as.table(m)
    }
    if (naAs0.) mat <- naAs0(mat)    
    TP <- tp(obj)
    FP <- fp(obj)
    FN <- fn(obj)
    TN <- tn(obj)  
    ans <- lapply(seq_len(nrow(obj)),
                  function(i)
                      .makeConfuTab(c(TP[i], FN[i], FP[i], TN[i])))
    names(ans) <- rownames(obj)
    return(ans)
}

setOldClass("prcomp")

setClass("projectedLearner", 
   representation(
    fittedLearner="classifierOutput",
    trainingSetPCA="prcomp",
    trainingLabels="ANY",
    testLabels="ANY",
    gridFeatsProjectedToTrainingPCs = "matrix",
    gridPredictions="ANY",
    trainFeatsProjectedToTrainingPCs = "matrix",
    testFeatsProjectedToTrainingPCs = "matrix",
    trainPredictions="ANY",
    testPredictions="ANY",
    theCall="call")
)

setMethod("show", "projectedLearner", function(object) {
 cat("MLInterfaces projectedLearner instance.\n")
 cat("The call was:\n")
 print(object@theCall)
# cat("Fitted MLearn result:\n")
# show(object@fittedLearner)
 cat("dimensions of projected feature grid:\n")
 print(dim(object@gridFeatsProjectedToTrainingPCs))
})
projectLearnerToGrid = function(formula, data, learnerSchema, trainInds, ...,
    dropIntercept=TRUE, ngpts=20, predExtras=list(), predWrapper=force) {
#
# 1) check trainInds, get nrow(data), compute testInds
# 2) all steps in 2 can be done in parallel
# 2a) m1 = trained learner
# 2b) mm = model.matrix of full data, with intercept removed by default
# 2c) prcomp.train = PCA reduction of scaled, centered training data
# 2d) fullresp = model.response of full data -> trainingLabels, testLabels
# 2e) build grid in feature space, assign feature names to columns
# 3) must follow 2 but can be parallel
# 3a1) project grid into PC space of 2c
# 3a2) project test features into PC space of 2c
# 3b) obtain trained model predictions (labels) for grid inputs
  stopifnot(is.numeric(trainInds))
  nd = nrow(data)
  testInds = setdiff(seq_len(nd), trainInds)
# 2a:
  m1 = do.call(MLearn, c(list(formula, data, learnerSchema, trainInds), list(...)))
# 2b:
  mm = model.matrix( formula, data )
  if (dropIntercept) {
      ind = match("(Intercept)", colnames(mm))
      if (!is.na(ind)) mm = mm[,-ind]
      }
  trfeats = mm[trainInds,]
  tefeats = mm[-trainInds,]
# 2c:
  prcomp.train = prcomp( trfeats, scale=TRUE )
# 2d:
  fullresp = model.response(model.frame(formula, data))
  trainingLabels = as.character(fullresp[trainInds])
  testLabels = as.character(fullresp[testInds])
# 2e: 
  gpts = lapply( seq_len(ncol(trfeats)),
     function(x) seq(min(trfeats[,x]), max(trfeats[,x]), length=ngpts))
  grid = do.call( expand.grid, gpts )
  colnames(grid) = colnames(trfeats)
# 3a1:
  gridFeatsProjectedToTrainingPCs = predict(prcomp.train, data.frame(grid) ) # just coordinates FOR GRID after rotation
# 3a2:
  trainFeatsProjectedToTrainingPCs = predict(prcomp.train, trfeats ) # just coordinates FOR TRAINING DATA after rotation
  testFeatsProjectedToTrainingPCs = predict(prcomp.train, tefeats ) # just coordinates FOR TEST DATA after rotation
# 3b
  al = list(RObject(m1), newdata=grid)
  al = c(al, predExtras)
  al = c(al, ...)
  curpred = predWrapper(do.call(predict, al))
# object
  new("projectedLearner",
         fittedLearner=m1,
         trainingSetPCA=prcomp.train,
         trainingLabels=trainingLabels,
         testLabels=testLabels,
         gridFeatsProjectedToTrainingPCs = gridFeatsProjectedToTrainingPCs,
         testFeatsProjectedToTrainingPCs = testFeatsProjectedToTrainingPCs,
         trainFeatsProjectedToTrainingPCs = trainFeatsProjectedToTrainingPCs,
         trainPredictions = trainPredictions(m1),
         testPredictions = testPredictions(m1),
         gridPredictions = curpred, theCall=match.call())
}
 
setMethod("plot", "projectedLearner", function(x, y, ...) {
#    oldp = par(no.readonly=TRUE)
#    on.exit(par(oldp))
#    op = par(bg = adjustcolor("goldenrod", offset = -rep(.4, 4), alpha.f=.4), xpd = NA)
#
#    par(op)
    pairs(x@gridFeatsProjectedToTrainingPCs, 
           col=factor(x@gridPredictions), cex=1.5, pch=19)
    }
)

setGeneric("plotOne", function(x, ind1=1, ind2=2, type="showTestLabels")
   standardGeneric("plotOne"))
setMethod("plotOne", "projectedLearner", 
   function(x, ind1=1, ind2=2, type="showTestLabels") {
     proj = x@gridFeatsProjectedToTrainingPCs
     plot(proj[,ind1], proj[,ind2], col=factor(x@gridPredictions), cex=1.5,
           pch=19, xlab=paste0("PC", ind1), ylab=paste0("PC", ind2))
     switch( type,
        "showTestLabels" = {
           points(x@testFeatsProjectedToTrainingPCs[, ind1], 
                  x@testFeatsProjectedToTrainingPCs[, ind2], 
                     pch=as.character(x@testLabels), col="white")
           },
        "showTestPredictions" = {
           points(x@testFeatsProjectedToTrainingPCs[, ind1], 
                  x@testFeatsProjectedToTrainingPCs[, ind2], 
                     pch=as.character(x@testPredictions), col="white")
           },
        "showTrainLabels" = {
           points(x@trainFeatsProjectedToTrainingPCs[, ind1], 
                  x@trainFeatsProjectedToTrainingPCs[, ind2], 
                     pch=as.character(x@trainLabels), col="white")
           },
        "showTrainPredictions" = {
           points(x@trainFeatsProjectedToTrainingPCs[, ind1], 
                  x@trainFeatsProjectedToTrainingPCs[, ind2], 
                     pch=as.character(x@trainPredictions), col="white")
           } )
})


setGeneric("learnerIn3D", function(x, ind1=1, ind2=2, ind3=3, ...) 
    standardGeneric("learnerIn3D"))
setMethod("learnerIn3D", "projectedLearner", 
   function(x, ind1=1, ind2=2, ind3=3, ...)  {
#     requireNamespace("rgl")
     proj = x@gridFeatsProjectedToTrainingPCs
#     rgl::plot3d(proj[,ind1], proj[,ind2], proj[,ind3],
#            col=factor(x@gridPredictions),
#            xlab=paste0("PC", ind1),
#            ylab=paste0("PC", ind2),
#            zlab=paste0("PC", ind3),
#            ...)
#     rgl::text3d(x@testFeatsProjectedToTrainingPCs[, ind1], 
#                  x@testFeatsProjectedToTrainingPCs[, ind2], 
#                  x@testFeatsProjectedToTrainingPCs[, ind3], 
#                     texts=as.character(x@testLabels), col="black")
})

#setMethod("show", "clusteringOutput", function(object) {
# cat("MLInterfaces clustering output container\n")
# cat("The call was:\n")
# print(object@call)
#})
#
#setMethod("RObject", "clusteringOutput", function(x) x@RObject)
#
#
#setMethod("plot", "clusteringOutput", function(x, y, ...) {
# opar = par(no.readonly=TRUE)
# on.exit(par(opar))
# par(mfrow=c(2,2))
# if (x@learnerSchema@mlFunName=="hclust") plclust(RObject(x))
# else if (x@learnerSchema@mlFunName=="pam") plot(RObject(x))
## else {
##    if (missing(y)) stop("second arg must be matrix with feature data on all records")
#    partPlot(y, x@partition, las=2)
#    }
# plot(x@silhouette, main="silhouette")
# plot(x@prcomp, main="PCA screeplot")
# plot(x@prcomp$x[,1], x@prcomp$x[,2], col=x@partition,
#   xlab="PC1", ylab="PC2", main="PCA colored by partition")
#})

#####################
# PACKAGE: ipred
#####################
#
#####################
# title: baggingB
# description: interface to bagging {ipred} 
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# note:
# 	aggregation	argument specifying how to combine results for prediction 
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# hg <- baggingB(golubMerge[100:200,], "ALL.AML", train)
#####################

setGeneric("baggingB", function(exprObj, classifLab, trainInd, subset, aggregation="majority", metric="euclidean", ...){
		standardGeneric("baggingB")
})

setMethod("baggingB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY"), 
		function(exprObj, classifLab, trainInd, subset, aggregation, metric, ...){

		if(missing(subset)){ subset <- NULL }

		cl <- pData(exprObj)[[classifLab]][trainInd]		
		trainDat <- data.frame(y=cl, t(exprs(exprObj)[,trainInd]))
		testDat <- data.frame(t(exprs(exprObj)[,-trainInd]))
		dis <- dist(testDat, method=metric)
library(ipred)
		tmp <- bagging(y~., data=trainDat, subset=subset, ...)
		out <- predict(tmp, newdata=testDat)
                new("classifOutput", method="bagging",
                        predLabels=newPredClass(as.character(out)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
#                        predScores=newQualScore(attr(out,"prob")),
                        RObject=tmp, call=match.call(), distMat=dis)
})

#####################
# title: ipredknnB
# description: interface to ipredknn {ipred} 
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# hg <- ipredknnB(golubMerge[100:200,], "ALL.AML", train)
# note: would be great if we could get prob and class predictions
#####################

setGeneric("ipredknnB", function(exprObj, classifLab, trainInd, na.action, k=5, metric="euclidean", ...){
		standardGeneric("ipredknnB")
})

setMethod("ipredknnB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY"), 
		function(exprObj, classifLab, trainInd, na.action, k, metric, ...){
				
		if(missing(na.action)){ na.action <- NULL }
		cl <- pData(exprObj)[[classifLab]][trainInd]		
		trainDat <- data.frame(y = cl, t(exprs(exprObj)[,trainInd]))
		testDat <- data.frame(t(exprs(exprObj)[,-trainInd]))
		dis <- dist(testDat, method=metric)
library(ipred)
		tmp <- ipredknn(y~., data=trainDat, na.action=na.action, k=k, ...)
		out <- predict(tmp, newdata=testDat, type="class")
		prob <- predict(tmp, newdata=testDat, type="prob")
                new("classifOutput", method="ipredknn",
                        predLabels=newPredClass(as.character(out)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
                        predScores=newQualScore(prob),
                        RObject=tmp, call=match.call(), distMat=dis)
})

#####################
# title: sldaB
# description: interface to slda {ipred} 
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classif3Output"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# hg <- sldaB(golubMerge[100:200,], "ALL.AML", train)
#####################

setGeneric("sldaB", function(exprObj, classifLab, trainInd, subset, na.action=na.rpart, metric="euclidean", ...){
		standardGeneric("sldaB")
})

setMethod("sldaB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY"), 
		function(exprObj, classifLab, trainInd, subset, na.action, metric, ...){

		if(missing(subset)){ subset <- NULL }
		cl <- pData(exprObj)[[classifLab]][trainInd]		
		trainDat <- data.frame(y=cl, t(exprs(exprObj)[,trainInd]))			
		dat <- data.frame(t(exprs(exprObj)[,trainInd]))
		testDat <- data.frame(t(exprs(exprObj)[,-trainInd]))
		dis <- dist(testDat, method=metric)

library(ipred)
		tmp <- slda(y~., data=trainDat, na.action=na.action, ...)
		out <- predict(tmp, newdata=testDat)
                new("classifOutput", method="slda",
                        predLabels=newPredClass(as.character(out$class)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
                        predScores=newProbMat(out$posterior),
                        RObject=tmp, call=match.call(), distMat=dis)
})

#####################
# title: inbaggB
# description: interface to inbagg {ipred} 
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	trainInd	vector of indices for the columns to be 
#			included in the training set
# 	intLab 		character string or vector of character strings 
#			representing names of the intermediate variables
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# a <- inbaggB(golubMerge[100:110,], "ALL.AML", train, "PS")
#####################
#
#setGeneric("inbaggB", function(exprObj, classifLab, trainInd, intLab, pFUN, cFUN, metric="euclidean", ...){
#		standardGeneric("inbaggB")
#})
#
#setMethod("inbaggB", c("ExpressionSet", "character", "integer", "character", "ANY", "ANY", "ANY", "ANY"), 
#		function(exprObj, classifLab, trainInd, intLab, pFUN, cFUN, metric, ...){
#
##		if(missing(pFUN)){ pFUN <- list(list(model=lm)) }
#		if(missing(pFUN)){ pFUN <- NULL }
#		if(missing(cFUN)){ cFUN <- NULL }
#
#		cl <- pData(exprObj)[[classifLab]]
#		
#		if(length(intLab) > 1){ 
#			intDat <- pData(exprObj)[[intLab[1]]]
#			for( v in intLab[-1] ){
#				intDat <- cbind(intDat, pData(exprObj)[[v]])
#			}
#
#			intNam <- paste("i", ".", 1:length(intLab), sep="")
#			colnames(intDat) <- intNam
#			trainDat <- data.frame(intVar=intDat[trainInd,], y=cl[trainInd], t(exprs(exprObj)[,trainInd]))
#			testDat <- data.frame(intVar=intDat[-trainInd,], y=cl[-trainInd], t(exprs(exprObj)[,-trainInd]))
#
#			intEqu <- paste(colnames(trainDat)[1:length(intLab)], collapse="+")
#			equ <- paste("y", intEqu, ".", sep="~")
#			equ <- as.formula(equ)
#		}
#
#		else{
#			intDat <- pData(exprObj)[[intLab]]
#			trainDat <- data.frame(intVar=intDat[trainInd], y=cl[trainInd], t(exprs(exprObj)[,trainInd]))
#			testDat <- data.frame(intVar=intDat[-trainInd], y=cl[-trainInd], t(exprs(exprObj)[,-trainInd]))
#			
#			equ <- as.formula(y ~ intVar ~ .)
#		}
#
#		dis <- dist(t(exprs(exprObj)[,-trainInd]), method=metric)
#library(ipred)
#		tmp <- inbagg(equ, pFun=pFun, cFun=cFun, data=trainDat,  ...)
#		out <- predict(tmp, newdata=testDat)
#                new("classifOutput", method="inbagg",
#                        predLabels=newPredClass(as.character(out)),
#			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
#                        predScores=newProbMat(out$posterior),
#                        RObject=tmp, call=match.call(), distMat=dis)
#})
#
######################
## title: inclassB
## description: interface to inclass {ipred} 
## arguments:
##	exprObj		ExpressionSet
##	classifLab	character string specifying what covariate data 
##			to use for classification
##	trainInd	
## 	intLab 		single label or a vector of labels
##			representing names of the factors for intermediate variables
##	metric		for distance matrix 
## value:
## 	object of class "classifPred"
## note:
## 	cFUN argument requires a function object which assigns
##	the response labels using the intermediate variable(s).
##	This function should have a single input argument "newdata".
##	Internally inclass applies this cFUN function to new data 
##	that is stored as a data frame in such a way that the 
##	intermediate variables occupy the last columns of the data
##	frame.
##	The example below uses a single intermediate variable ("PS" 
##	values) and samples with PS values > 0.75 are
##	classified as ALL (this is all made up, it's intended to illustrate
##	the function usage), otherwise AML. 
## example:
## train <- c(sample(1:47, 23), sample(48:72, 12))
## psclassify <- function(newdata){
##		xx <- ifelse((newdata[,ncol(newdata)] > 0.75), "ALL", "AML")
##		as.factor(xx)
## }
## a <- inclassB(golubMerge[100:110,], "ALL.AML", train, "PS", cFUN=psclassify)
######################
#
#setGeneric("inclassB", function(exprObj, classifLab, trainInd, intLab, pFUN, cFUN, metric="euclidean", ...){
#		standardGeneric("inclassB")
#}) 
#
#setMethod("inclassB", c("ExpressionSet", "character", "integer", "character", "ANY", "ANY", "ANY", "ANY"), 
#			function(exprObj, classifLab, trainInd, intLab, pFUN, cFUN, metric, ...){
#
#		if(missing(pFUN)){ pFUN <- list(list(model=lm)) }
#	
#		cl <- pData(exprObj)[[classifLab]]
#	
#		if(length(intLab) > 1){ 
#
#			intDat <- pData(exprObj)[[intLab[1]]]
#			for( v in intLab[-1] ){
#				intDat <- cbind(intDat, pData(exprObj)[[v]])
#			}
#
#			intNam <- paste("i", ".", 1:length(intLab), sep="")
#			colnames(intDat) <- intNam
#
#			trainDat <- data.frame(intVar=intDat[trainInd,], y=cl[trainInd], t(exprs(exprObj)[,trainInd]))
#			testDat <- data.frame(intVar=intDat[-trainInd,], y=cl[-trainInd], t(exprs(exprObj)[,-trainInd]))
#	
#			intEqu <- paste(colnames(trainDat)[1:length(intLab)], collapse="+")
#			equ <- paste("y", intEqu, ".", sep="~")
#			equ <- as.formula(equ)
#		}
#
#		else{
#			intDat <- pData(exprObj)[[intLab]]
#			trainDat <- data.frame(intVar=intDat[trainInd], y=cl[trainInd], t(exprs(exprObj)[,trainInd]))
#			testDat <- data.frame(intVar=intDat[-trainInd], y=cl[-trainInd], t(exprs(exprObj)[,-trainInd]))
#			equ <- as.formula(y ~ intVar ~ .)
#		}
#
#		dis <- dist(t(exprs(exprObj)[,-trainInd]), method=metric)
#		out <- ipred::inclass(equ, pFUN=pFUN, cFUN=cFUN, data=trainDat, ...)
#		new("classifPred", sampLabels=predict(out, testDat, ...), distMat=dis, classifObj=out)
#})		

#####################
# title: cvB
# description: leave one out cross-validation classification
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	algofunc	function object that calls the classification algorithm 
#			(can be created by makeCVFunc)
# value:
# 	object of class "classifCV"
# example:
# eset <- golubMerge[100:110,] 
# cvtknn <- cvB(eset, "ALL.AML", makeCVFunc("knn", k=10) )
# cvtnb <- cvB(eset, "ALL.AML", makeCVFunc("naiveBayes") )
####################

setGeneric("cvB", function(exprObj, classifLab, algofunc, metric="euclidean", ...){
	standardGeneric("cvB")
})

setMethod("cvB", c("ExpressionSet", "character", "ANY", "ANY"), 
		function(exprObj, classifLab, algofunc, metric, ...){

	cl <- pData(exprObj)[[classifLab]]
	dat <- exprs(exprObj)
	dis <- dist(t(dat), method=metric)
	n <- ncol(dat)
	predCV <- cl

	for( i in 1:n ){
		predCV[i] <- algofunc(t(dat[,-i]), t(dat[,i]), cl[-i], ...)
	}

	tab <- table(predCV, cl)
	diag(tab) <- 0
	err <- paste(round(100*sum(tab)/length(cl),2), "%", sep="")
#	new("classifCV", err=err, sampLabels=predCV, distMat=dis)
                #out <- class::knn(trainDat, testDat, cl, k, l, prob, use.all)
                new("classifOutput", method="knn",
                        predLabels=newPredClass(as.character(predCV)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
#                        predScores=newQualScore(attr(out,"prob")),
                        RObject=err, call=match.call(), distMat=dis)
                                                                                

})

#####################
# title: makeCVFunc
# description: creates function object for input to cvB
# arguments:
#	algorithm	character string specifying the name of the 
#			classification algorithm to be used
#			must be either: 
#				knn, knn1, knn.cv, lvq1, lvq2, lvq3,
#				olvq1, naiveBayes, svm, lda,
#				qda, bagging, ipredknn,
#				slda, randomForest, rpart, nnet, pamr
#			(i.e. all classification algorithms in machLI
#			except for knn.cv {class}, inbagg {ipred}, 
#			inclass {ipred})
#	...		additional parameters specific to the 
#			classification algorithm
# value:
# 	function object
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# aa <- pamrB(golubMerge[100:200,], train, "ALL.AML")
####################

makeCVFunc <- function(algorithm, ...){

	if( algorithm == "knn" ){		
		resfunc <- function(train, test, lab){
				class::knn(train, test, lab, ...)
		}	
	}

	if( algorithm == "knn1" ){		
		resfunc <- function(train, test, lab){
				class::knn1(train, test, lab)
		}	
	}
			
	if( algorithm == "lvq1" ){		
		resfunc <- function(train, test, lab){
				initbk <- class::lvqinit(train, lab, ...)
				trbk <- class::lvq1(train, lab, initbk, ...)
				class::lvqtest(trbk, test)
		}
	}

	if( algorithm == "lvq2" ){		
		resfunc <- function(train, test, lab){
				initbk <- class::lvqinit(train, lab, ...)
				trbk <- class::lvq2(train, lab, initbk, ...)
				class::lvqtest(trbk, test)
		}
	}

	if( algorithm == "lvq3" ){		
		resfunc <- function(train, test, lab){
				initbk <- class::lvqinit(train, lab, ...)
				trbk <- class::lvq3(train, lab, initbk, ...)
				class::lvqtest(trbk, test)
		}
	}

	if( algorithm == "olvq1" ){
		
		resfunc <- function(train, test, lab){
				initbk <- class::lvqinit(train, lab, ...)
				trbk <- class::olvq1(train, lab, initbk, ...)
				class::lvqtest(trbk, test)
		}
	}	

	if( algorithm == "naiveBayes" ){

		resfunc <- function(train, test, lab){
				df <- data.frame(y=lab, train)
				classifObj <- e1071::naiveBayes(y~., data=df, ...)
				predict(classifObj, test, ...)
		}	
	}

	if( algorithm == "svm" ){
		resfunc <- function(train, test, lab){
				classifObj <- e1071::svm(train, lab, ...)
				predict(classifObj, test, ...)
		}	
	}

	if( algorithm == "lda" ){
		resfunc <- function(train, test, lab){
				classifObj <- MASS::lda(train, grouping=lab, ...)
				predict(classifObj, test, ...)$class
		}
	}


	if( algorithm == "qda" ){
		resfunc <- function(train, test, lab){
				classifObj <- MASS::qda(train, grouping=lab, ...)
				predict(classifObj, test, ...)$class
		}
	}

	if( algorithm == "bagging" ){
		resfunc <- function(train, test, lab){
				df <- data.frame(y=lab, train)
				classifObj <- ipred::bagging(y~., data=df, ...)
				predict(classifObj, data.frame(test), type="class", ...)
		}	
	}

	if( algorithm == "ipredknn" ){

		resfunc <- function(train, test, lab){
				df <- data.frame(y=lab, train)
				classifObj <- ipred::ipredknn(y~., data=df, ...)
				ipred::predict.ipredknn(classifObj, data.frame(test), type="class", ...)
		}	
	}

	if( algorithm == "slda" ){

		resfunc <- function(train, test, lab){
				df <- data.frame(y=lab, train)
				classifObj <- ipred::slda(y~., data=df, ...)
				predict(classifObj, data.frame(test), ...)$class
		}	
	}

	if( algorithm == "randomForest" ){
		resfunc <- function(train, test, lab){
				classifObj <- randomForest::randomForest(train, y=lab, ...)
				predict(classifObj, test, ...)
		}	
	}

	if( algorithm == "rpart" ){
		resfunc <- function(train, test, lab){
				df <- data.frame(train, y=lab)
				classifObj <- rpart::rpart(y~., data=df, ...)
				predict(classifObj, data.frame(test), type="class")
		}
	}

	if( algorithm == "nnet" ){
		resfunc <- function(train, test, lab){
				df <- data.frame(train, y=lab)
				classifObj <- nnet::nnet(y~., data=df, ...)
				predict(classifObj, data.frame(test), type="class", ...)
		}	
	}

	if( algorithm == "pamr" ){
		resfunc <- function(train, test, lab, threshold=1){
				df <- list(x=t(train), y=lab)
				classifObj <- pamr::pamr.train(df, ...)		
				pamr::pamr.predict(classifObj, matrix(test, ncol=1), threshold, ...)
		}	
	}
	resfunc
}

#####################
# PACKAGE: rpart 
#####################
#
# title: rpartB
# description: interface to rpart {rpart} 
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# rOut <- rpartB(golubMerge[100:120,], "ALL.AML", train)
#####################

setGeneric("rpartB", function(exprObj, classifLab, trainInd, weights, subset, na.action, 
		method="class", model=TRUE, x=TRUE, y=TRUE, parms, control, cost, 
		metric="euclidean", ...){
		standardGeneric("rpartB")
})

setMethod("rpartB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", 
		"ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, classifLab, trainInd, weights, subset, 
			na.action, method, model, x, y, parms, control, cost, metric, ...){

			if(missing(subset)){ subset <- NULL }
			if(missing(control)){ control <- NULL }
			if(missing(parms)){ parms <- NULL }
      		
			cl <- pData(exprObj)[[classifLab]]
			trainDat <- data.frame(grouping=cl[trainInd], t(exprs(exprObj)[,trainInd]))
			testDat <- data.frame(t(exprs(exprObj)[,-trainInd]))

			if(missing(weights)){ weights <- rep(1, nrow(trainDat)) }		
			if(missing(cost)){ cost <- rep(1, (ncol(trainDat)-1) ) }

			dis <- dist(testDat, method=metric)

			if(missing(na.action)){ 
				out <- rpart::rpart(grouping ~., data=trainDat, na.action=rpart::na.rpart, 
							weights=weights, subset=subset, method=method, model=model, 
							x=x, y=y, parms=parms, control=control, cost=cost, ...)
			}
			else{
				out <- rpart::rpart(grouping ~., data=trainDat, na.action=na.action, 
							weights=weights, subset=subset, method=method, model=model, 
							x=x, y=y, parms=parms, control=control, cost=cost, ...)	
			}							
		preds <- predict(out, testDat, type="class")
                new("classifOutput", method="rpart",
                        predLabels=newPredClass(as.character(preds)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
#                        predScores=newQualScore(attr(out,"prob")),
                        RObject=out, call=match.call(), distMat=dis)
})

#####################
# PACKAGE: randomForest
#####################
# 
#####################
# title: randomForestB
# description: interface to randomForest {randomForest}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# rfOut <- randomForestB(golubMerge[100:200,], "ALL.AML", train)
# note: default for mtry, nodesize taken from Breiman's tips in pdf
####################

# randomForest

setGeneric("randomForestB", function(exprObj, classifLab, trainInd, xtest, 
			ytest, addclass = 0, ntree = 500, mtry, classwt, 
			cutoff, sampsize, nodesize, importance = FALSE, proximity = FALSE, 
			oob.prox = TRUE, outscale = FALSE, norm.votes = TRUE, do.trace = FALSE, 
			keep.forest = is.null(xtest), corr.bias=FALSE, metric="euclidean", ...){
			standardGeneric("randomForestB")
			})

setMethod("randomForestB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", "ANY", 
			"ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", 
			"ANY", "ANY"),
			function(exprObj, classifLab, trainInd, xtest, ytest, addclass, ntree, mtry, 
			classwt, cutoff, sampsize, nodesize, importance, proximity, oob.prox, outscale, 
			norm.votes, do.trace, keep.forest, corr.bias, metric, ...){

			trainDat <- t(exprs(exprObj)[,trainInd])
			cl <- pData(exprObj)[[classifLab]][trainInd]
			if(missing(xtest)){ xtest <- NULL }
			if(missing(ytest)){ ytest <- NULL }
			if(missing(mtry)){ mtry <- sqrt(ncol(trainDat)) }
			if(missing(classwt)){ classwt <- NULL }
			if(missing(nodesize)){ nodesize <- 1 }
			if(missing(sampsize)){ sampsize <- table(cl) }

			testDat <- t(exprs(exprObj)[ ,-trainInd])
			dis <- dist(testDat, method=metric)

			out <- randomForest::randomForest(trainDat, y=cl, xtest=xtest, ytest=ytest, addclass=addclass, 
						ntree=ntree, mtry= mtry,
						classwt=classwt, cutoff=cutoff, sampsize=sampsize, nodesize=nodesize,
						importance=importance, proximity=proximity, oob.prox=oob.prox, 
						outscale=outscale, norm.votes=norm.votes, do.trace=do.trace, 
						keep.forest=keep.forest, corr.bias=corr.bias, ...)

                preds <- predict(out, testDat)
                new("classifOutput", method="randomForest",
                        predLabels=newPredClass(as.character(preds)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
#                        predScores=newQualScore(attr(out,"prob")),
                        RObject=out, call=match.call(), distMat=dis)
})

setGeneric("gbmB", function(exprObj, classifLab, trainInd, 
 distribution="bernoulli", weights=NULL, 
 offset=NULL, var.monotone=NULL, 
 n.trees=100, interaction.depth=1, 
 n.minobsinnode=10, shrinkage=0.001, 
 bag.fraction=0.5, train.fraction=1, keep.data=TRUE, verbose=TRUE, metric="euclidean")
 standardGeneric("gbmB"))

setMethod("gbmB", c("ExpressionSet", "character", "integer", 
			"ANY", "ANY", "ANY", "ANY", "ANY", 
			"ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"), 
 function(exprObj, classifLab, trainInd, 
  distribution="bernoulli", weights=NULL, 
  offset=NULL, var.monotone=NULL, 
  n.trees=100, interaction.depth=1, 
  n.minobsinnode=10, shrinkage=0.001, 
  bag.fraction=0.5, train.fraction=1, keep.data=TRUE, verbose=FALSE,
  metric = "euclidean") {
require(gbm) # no namespace
		cl <- pData(exprObj)[[classifLab]][trainInd]				
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])
		dis <- dist(testDat, method=metric)
		if (is.null(weights)) weights <- rep(1, length(cl))
		out <- gbm.fit(x=trainDat, y=as.numeric(cl)-1,
		  distribution=distribution, w=weights, 
		  offset=offset, var.monotone=var.monotone, 
		  n.trees=n.trees, interaction.depth=interaction.depth, 
		  n.minobsinnode=n.minobsinnode, shrinkage=shrinkage, 
		  bag.fraction=bag.fraction, 
		train.fraction=train.fraction, keep.data=keep.data, 
		verbose=verbose)
                ps <- predict( out, newdata= testDat, n.trees, type="response" )
                
                new("classifOutput", method="gbm", 
			predLabels=newPredClass(levels(cl)[(ps>0.5)+1]),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
#			predScores=newQualScore(attr(out,"prob")),
                        RObject=out, call=match.call(), distMat=dis)
})

# the API for logitboost has changed and this will need nontrivial revision
#setGeneric("logitboostB",
# function(exprObj, classifLab, trainInd, mfinal=100, presel=0, estimate=0, verbose=FALSE, metric="euclidean")
# standardGeneric("logitboostB"))
#setMethod("logitboostB", 
# c("ExpressionSet", "character", "integer", "numeric", "ANY", "ANY", "ANY", "ANY"),
# function(exprObj, classifLab, trainInd, mfinal=100, presel=0, estimate=0, verbose=FALSE, metric="euclidean") {
#require(boost)
##warning("version 1.1 of LogitBoost has bugs.  consult with authors of that package if you run into problems with this method.")
#		cl <- pData(exprObj)[[classifLab]][trainInd]				
#		trainDat <- t(exprs(exprObj)[,trainInd])
#		testDat <- t(exprs(exprObj)[,-trainInd])
#		dis <- dist(testDat, method=metric)
#                out <- logitboost(trainDat, as.numeric(as.factor(cl))-1, 
#			testDat, mfinal, presel=presel, 
#			estimate=estimate, verbose=verbose)
#                if (length(dim(out$probs))==3)
#                  predcat <- apply(apply(out$probs,c(1,3),mean),1,which.max)
#	 	else predcat <- 1*(apply(out$probs,1,mean)>.5)+1
#
#                new("classifOutput", method="logitboost", 
#			predLabels=newPredClass(levels(as.factor(cl))[predcat]),
#			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
##			predScores=newQualScore(attr(out,"prob")),
#                        RObject=out, call=match.call(), distMat=dis)
#})

## standardMLIPredicter <- function(obj, newdata) {
## Using class prototype instead
## }

MLIPredicter.plsda <- function(model, newdata, ...) {
  .predClass <- predict(model,newdata,type="class")
  .predProb <- predict(model,newdata,type="prob")  
  return(list(testPredictions=.predClass,
              testScores=.predProb))
}

MLIPredicter.svm <- function(model, newdata, ...) {
  .predClass <- predict(model, newdata,
                        decision.values=TRUE, probability=TRUE, ...)
  .predProb <- attr(.predClass,"probabilities")
  return(list(testPredictions=factor(.predClass),
              testScores=.predProb))
}

MLIPredicter.ksvm <- function(model, newdata, ...) {
  .predClass <- kernlab::predict(model, newdata, type="response", ...)
  .predProb <- kernlab::predict(model, newdata, type="probabilities", ...)
  return(list(testPredictions=factor(.predClass),
              testScores=.predProb))
}

MLIPredicter.knn <- function(model, newdata, ...) {
  .predClass <- class::knn(model$traindat, newdata,
                           model$traincl, prob=TRUE, ...)
  .predProb <- attr(.predClass, "prob")
  return(list(testPredictions=factor(.predClass),
              testScores=.predProb))
}

MLIPredicter.nnet <- function(model, newdata, ...) {
  .predClass <- predict(model, newdata, type="class")
  .predProb <- predict(model, newdata, type="raw")
  return(list(testPredictions=factor(.predClass),
              testScores=.predProb))
}

MLIPredicter.naiveBayes <- function(model, newdata, ...) {
  .predClass <- predict(model, newdata, type="class")
  .predProb <- predict(model, newdata, type="raw")
  return(list(testPredictions=.predClass,
              testScores=.predProb))
}

MLIPredicter.randomForest <- function(model, newdata, ...) {
  .predClass <- predict(model, newdata, type="response")
  .predProb <- predict(model, newdata, type="prob")
  attr(.predProb,"class") <- NULL
  return(list(testPredictions=.predClass,
              testScores=.predProb))
}

setClass("varImpStruct", representation(method="character",
 varnames="character"), contains="matrix")

if(!isGeneric("getVarImp"))setGeneric("getVarImp",
 function(object,fixNames)standardGeneric("getVarImp"))

#setMethod("getVarImp", c("classifOutput","logical"), function(object,fixNames) {
## watch out, people are using compound S3 classes c("randomForest.formula", "randomForest")
#	if (any(class(object@RObject) == "randomForest")) {
#		imp <- object@RObject$importance
#		return(new("varImpStruct", data.matrix(imp[,-1]), 
#			method="randomForest", varnames= row.names(imp)))
#		}
#	else if (any(class(object@RObject) == "gbm")) {
#		imp <- summary(object@RObject, plotit=FALSE)
#		return(new("varImpStruct", data.matrix(imp[,-1]), 
#                         method="gbm", varnames=as.character(imp[,1])))
#	        }
#	else stop("getVarImp defined only for randomForestB or gbmB output")
#})

setMethod("getVarImp", c("classifierOutput","missing"), function(object,fixNames) {
   getVarImp(object, TRUE)
})

setMethod("getVarImp", c("classifierOutput","logical"), function(object,fixNames) {
# watch out, people are using compound S3 classes c("randomForest.formula", "randomForest")
 	fixupNames = function(x) gsub("\\.", "-", gsub("^X", "", x))
	if (any(class(object@RObject) == "randomForest")) {
		imp <- object@RObject$importance
		dm = data.matrix(imp)
		if (fixNames) rownames(dm) = fixupNames(row.names(imp))
		return(new("varImpStruct", dm,
			method="randomForest", varnames= rownames(dm)))
		}
	else stop("getVarImp defined only for randomForestI-based classifierOutput")
})

setMethod("show", "varImpStruct", function(object) {
 cat("varImpStruct for method", object@method, "\n")
 cat("first five varnames:\n")
 print(object@varnames[1:5])
 cat("dims importance:\n")
 print(dim(object@.Data))
})


mapPSvec = function (vn, plat, toktype) 
{
        ans = unlist(lookUp(vn, plat, toktype))
        if (any(is.na(ans)))  # just pass psid if no mapping
            ans[is.na(ans)] = names(ans)[is.na(ans)]
        return(ans)
}


setMethod("plot", "varImpStruct", function(x, y, ..., n=20, plat, toktype, tmap) {
        vn <- x@varnames

# but the key thing is to get ifnotfound right below, once you have done these steps
	if (!missing(plat)) vn = mapPSvec(vn, plat, toktype)
        else if (!missing(tmap)) vn = tmap[vn]
	if (x@method=="randomForest") 
		{
		mda <- x@.Data[,"MeanDecreaseAccuracy"]
                omda <- order(-mda)[n:1]
		barplot(mda[omda], names=vn[omda], horiz=TRUE,
			xlab="Mean decrease in accuracy", ...)
		} })
           
setGeneric("report", function(x, n=10, plat, toktype) standardGeneric("report"))

setMethod("report", "varImpStruct", function(x, n=10, plat, toktype) {
        vn <- x@varnames

# but the key thing is to get ifnotfound right below, once you have done these steps
        if (!missing(plat))
		{
		vn = mapPSvec(vn, plat, toktype)
		}
	if (x@method=="gbm") 
		{
		return(data.frame(imp=x@.Data[n:1], names=vn[n:1]))
		}
	else if (x@method=="randomForest") 
		{
		mda <- x@.Data[,"MeanDecreaseAccuracy"]
                omda <- order(-mda)[seq_len(n)]
		return(data.frame(MnDecrAcc=mda[omda], names=vn[omda]))
		} })

# first comes the schema-based class collection, then
# the legacy classes for back-compatibility

## setClass("learnerSchema", representation(
## 	packageName="character",
## 	mlFunName="character",
## 	converter="function"), 
##           prototype=prototype(packageName="",
## 				mlFunName="",
## 				converter=function(obj, data, trainInd){}))

## L. Gatto <lg390@cam.ac.uk>, 1 Aug 2011
## new learnerSchema with predictor function
## - converters are defined in MLIConverters.R
## - predicters are defined in MLIPredicters.R
## This change requires to update the schema interfaces
## defined in schemaInterfaces.R by adding the
## predicter slot.
setClass("learnerSchema",
         representation(packageName="character",
                        mlFunName="character",
                        converter="function",
                        predicter="function"), 
         prototype=prototype(
           packageName="",
           mlFunName="",
           converter = function(obj, data, trainInd){},
           predicter = function(obj, newdata){
             .predClass <- predict(obj, newdata)
             ## no .predScores in standard predicter
             ## write specific ones to get prediction scores
             .predScores <- numeric()
             return(list(testPredictions=.predClass,
                         testScores=.predScores))
           }))

#setClass("clusteringSchema", representation(distMethod="character", 
#     agglomMethod="character", 
#     algorithm="character", extras="list"), contains="learnerSchema")

setClass("clusteringSchema", representation(
   package="character", mlFunName="character",
   distFun="function", converter="function"))


setClass("classifierOutput", representation(
        trainInd="numeric",
        testOutcomes="factor",
	testPredictions="factor",
	testScores="ANY",
	trainOutcomes="factor",
	trainPredictions="factor",
	trainScores="ANY",
        fsHistory="list",
	RObject="ANY",
	call="call",
	embeddedCV="logical",
        learnerSchema="learnerSchema"),
         prototype=prototype(testOutcomes=factor(),
           testPredictions=factor(),
           testScores=NULL,
           trainOutcomes=factor(),
           trainPredictions=factor(),
           trainScores=NULL,
           fsHistory=list(), 
           RObject=list(), 
           call=new("call"),
           embeddedCV=FALSE,
           learnerSchema=new("learnerSchema")))

#setClass("nonstandardLearnerSchema", representation(frontConverter="function",
#   hasNamespace="logical"), contains="learnerSchema")

setOldClass("silhouette")
#
setOldClass("prcomp")
#
setClass("prcompObj", contains="prcomp")
#
#setClass("clusteringOutput", representation(
#	partition="integer", silhouette="silhouette", distEnv="environment",
#	prcomp="prcompObj",
#	metric="character", call="call", learnerSchema="learnerSchema",
#        RObject="ANY"))

setClass("xvalSpec",
         representation(type="character",
                        niter="numeric", 
                        partitionFunc="function",
                        fsFun="function"))

# constructor defined here for now

xvalSpec <- function(type,
                     niter = 0,
                     partitionFunc = function(data, classLab,iternum){ (seq_len(nrow(data)))[-iternum] },
                     fsFun = function(formula, data) formula ) {
  new("xvalSpec", type=type, niter=niter, partitionFunc=partitionFunc, fsFun=fsFun)
}

# -- below find the legacy classes as of sep 9 2007

# virual classes are defined with specializations to
#   a) class labels (as in classification outputs) vs
#       group indices (as in clustering outputs)
#   b) probability matrices (as with nnet predict) vs
#       vector scores (as in knn voting proportions)


setClass("clusteringOutput", representation(
        partition="numeric", silhouette="silhouette", 
        prcomp="prcompObj", distFun="function", converter="function",
        call="call", learnerSchema="clusteringSchema",
        RObject="ANY"), prototype=prototype(
                  partition=numeric(0),
                  silhouette={x = 0; class(x)="silhouette"; x}, 
                  prcomp={x = 0; class(x)="prcomp"; new("prcompObj", x)},
                  distFun = dist, converter=function(){}, call=new("call"))
                  )   
setGeneric("RObject", function(x) standardGeneric("RObject"))
setMethod("RObject", "clusteringOutput", function(x)x@RObject)

setGeneric("MLearn", function(formula, data, .method, trainInd, ...) standardGeneric("MLearn"))

setMethod("MLearn",
          c("formula", "data.frame", "learnerSchema", "numeric" ),
          function( formula, data, .method, trainInd, ...) {
            ## find software
            pname = .method@packageName
            fname = .method@mlFunName
            requireNamespace(pname)
            ## create the requested function
            lfun = try(do.call("::", list(pname, fname)), silent=TRUE)
	    if (inherits(lfun, "try-error"))
                lfun = try(do.call(":::", list(pname, fname)), silent=TRUE) # deal with rdacvML
            if (inherits(lfun, "try-error")) stop(paste("cannot acquire learner function for function", fname, "in package", pname))
            ## build test and train subsets
            if (length(trainInd) != nrow(data))
              tedata = gdata::drop.levels(data[-trainInd,])
            else tedata = data  # needed for xvalSpec("NOTEST") with rdacvI (only?)
            trdata = gdata::drop.levels(data[trainInd,])
            ## execute on training data 
            ans = lfun( formula, trdata, ...)
            ## collect response subsets
            trFrame = try(model.frame(formula, trdata, na.action=na.fail))
            if (inherits(trFrame, "try-error")) stop("NA encountered in data.  Please rectify.")
            teFrame = try(model.frame(formula, tedata, na.action=na.fail))
            if (inherits(teFrame, "try-error")) stop("NA encountered in data.  Please rectify.")
            trout = model.response( trFrame )
            teout = model.response( teFrame )
            ## tell what was done
            thecall = match.call()
            ## convert the execute result into an MLint output container
            tmp = .method@converter( ans, data, trainInd )
            ## add some stuff to the converted representation
            if (!tmp@embeddedCV) {
              tmp@testOutcomes = factor(teout) # new 3/22/2020 factor()
              tmp@trainOutcomes = factor(trout)
            }
            else tmp@testOutcomes = factor(trout) # if CV is embedded, the 'training' is 'test'
            tmp@call = thecall
            tmp@learnerSchema = .method
            tmp@trainInd = trainInd
            tmp
          })

es2df = function(x,keep=NULL) {
#
# the keep parameter says which pData vars are kept in
#
   if (is.null(keep)) return(data.frame(t(exprs(x)),pData(x), stringsAsFactors = TRUE))
   else {
	print(keep)
        tmp = data.frame(t(exprs(x)),pData(x)[[keep]], stringsAsFactors = TRUE)
        names(tmp)[ncol(tmp)] = keep # the assumption is that there is a single response in formula
        return(tmp)
        }
}

se2df = function(x,keep=NULL,assayind=1L) {
#
# the keep parameter says which colData vars are kept in
#
   if (is.null(keep)) return(data.frame(t(assay(x, assayind, withDimnames=TRUE)),colData(x), stringsAsFactors = TRUE))
   else {
        tmp = data.frame(t(assay(x, assayind, withDimnames=TRUE)),colData(x)[[keep]], stringsAsFactors = TRUE)
        names(tmp)[ncol(tmp)] = keep  # the assumption is that there is a single response in formula
        return(tmp)
        }
}

setMethod("MLearn", c("formula", "ExpressionSet", "learnerSchema", "numeric" ),
  function(formula, data, .method, trainInd, ...) {
#
# the keep setting below says just keep the response variable
# from pData
#
        data = es2df(data, keep=as.character(as.list(formula)[[2]])) # [[2]] is the 'response' assumed to be a single column
	thecall = match.call()
        ans = MLearn( formula, data, .method, trainInd, ... )
 	ans@call = thecall
        ans@learnerSchema = .method
	ans
 })

setMethod("MLearn", c("formula", "SummarizedExperiment", "learnerSchema", "numeric" ),
  function(formula, data, .method, trainInd, ...) {
#
# the keep setting below says just keep the response variable
# from pData
#
        data = se2df(data, keep=as.character(as.list(formula)[[2]])) # [[2]] is the 'response' assumed to be a single column
	thecall = match.call()
        ans = MLearn( formula, data, .method, trainInd, ... )
 	ans@call = thecall
        ans@learnerSchema = .method
	ans
 })


##############################################################################
## TODO
## Methods below will be equivalent to MLearn(class~.,eset,svnI,1:nrow(eset)),
## i.e use all features in the data to generate the model and subsequently use
## that resulting classifierOutput's model to predict new data with the
## predict method.
##
## setMethod("MLearn",
##           c("formula", "data.frame", "learnerSchema", "missing" ),
##           function( formula, data, .method, trainInd, ...) { ... })
##
## setMethod("MLearn",
##           c("formula", "ExpressionSet", "learnerSchema", "missing" ),
##           function( formula, data, .method, trainInd, ...) { ... })
##
## Using 1:nrow(eset) seems to work for knnI, randomForestI, nnetI,
## but not for svmI, plsdaI:
##
## > aa <- MLearn(train~.,trainSet,svmI,1:142)
## Error in matrix(ret$dec, nrow = nrow(newdata), byrow = TRUE, dimnames = list(rowns,  : 
##   negative extents to matrix
## > traceback()
## 12: matrix(ret$dec, nrow = nrow(newdata), byrow = TRUE, dimnames = list(rowns, 
##         colns))
## 11: napredict.default(act, matrix(ret$dec, nrow = nrow(newdata), 
##         byrow = TRUE, dimnames = list(rowns, colns)))
## 10: napredict(act, matrix(ret$dec, nrow = nrow(newdata), byrow = TRUE, 
##         dimnames = list(rowns, colns)))
## 9: predict.svm(obj, teData, decision.values = TRUE, probability = TRUE)
## 8: predict(obj, teData, decision.values = TRUE, probability = TRUE)
## 7: .method@converter(ans, data, trainInd)
## 6: MLearn(formula, data, .method, trainInd, ...)
## 5: MLearn(formula, data, .method, trainInd, ...)
## 4: MLearn(formula, data, .method, trainInd, ...)
## 3: MLearn(formula, data, .method, trainInd, ...)
## 2: MLearn(train ~ ., trainSet, svmI, 1:142)
## 1: MLearn(train ~ ., trainSet, svmI, 1:142)
##
## This could be handled in the respective MLIConverters by checking if
## there is any test data left before calling predict.
##
## Other related point:missing values; svm ignores the NA's in a factor, and just
## does not use these features to train the classifier.
## In MLearn, stop("missing values in object") comes up (probably from model.frame).
##
##############################################################################

# this .method for MLearn is devoted essentially to cross-validation.  it structures
# a series of calls to MLearn[numeric trainInd] and collects the output, suitably
# ordered, into a classifierOutput structure, in contrast to the older xvalML

# it is an open question whether we should try to keep all the RObjects generated through
# the sequence of cross-validations.  i think we can as long as we are not in LOO

setMethod("MLearn",
          c("formula", "data.frame", "learnerSchema", "xvalSpec" ),
          function( formula, data, .method, trainInd, ...) {
            xvspec = trainInd # rationalize parameter name
            xvalMethod = xvspec@type
            if (!(xvspec@type %in% c("LOO", "LOG", "NOTEST")))
              stop("only supporting NOTEST (fit to all data), or LOO or LOG type xvalidation at this time")
            if (xvspec@type == "LOG" && is(xvspec@partitionFunc, "NULL"))
              stop("for xval type LOG, must supply partition function")
            thecall = match.call()
            tef = model.frame(formula, data)
            teo = model.response( tef )
            classLab = names(tef)[ respind <- attr( terms(formula,data=data), "response" ) ]
            N <- nrow(data)
            inds <- seq_len(N)
            if (xvspec@type == "NOTEST") {
              ans = MLearn(formula, data, .method, seq_len(N), ...)
              ans@call = thecall
              return(ans)
            }
            ## deal with sample selection
            if (xvalMethod == "LOO") {
              n <- length(inds)
              selnProc <- function(i) -i   # how to get the training set from inds
            } else { # FUN
              n <- xvspec@niter
              selnProc <- function(i) xvspec@partitionFunc( data, classLab, i )  # func defines training set directly
            }
            ## deal with feature selection
            ## check the supplied fsFun
            do.fs = FALSE
            if (is.function(xvspec@fsFun)) {
              do.fs = TRUE
              fsFun = xvspec@fsFun
              if (!all(names(formals(fsFun)) %in% c("formula", "data"))) {
                stop("xvspec@fsFun must have formals formula, data")
              }
              tst = fsFun(formula,data)
              if (!is( tst, "formula") ) {
                print("problem with fsFun in xvalSpec:")
                print(tst)
                stop("fsFun must return a formula; instead returned the object just printed.")
              }
            }

            xvalidator <- function(i, ...) {
              idx <- selnProc(i) # need to change sign when reordering...
              if (do.fs) fmla2use=fsFun(formula, data[inds[idx],])  # we are clobbering input formula
              else fmla2use=formula
              rhs_fmla = function (f) colnames(attr(terms(f, data=data), "factors"))
              try(list(test.idx = setdiff(inds,idx),
                       mlans = MLearn( fmla2use, data, .method=.method, trainInd=inds[idx], ...),
                       featInUse = rhs_fmla(fmla2use))) # package result -- test.idx kept for rearrangement
            }

            ##   xvalLoop = xvalLoop(NULL) # eventually will allow clusters
            out <-
              if (is.loaded("mc_fork", PACKAGE="parallel")) {
                mcLapply <- get("mclapply", envir=getNamespace("parallel"))
                mcLapply(seq_len(n), xvalidator, ...)
              } else {
                lapply( seq_len(n), xvalidator, ... )
              }  # thanks Martin Morgan!
            chkout = sapply(out, function(z) inherits(z, "try-error"))
            if (any(chkout)) stop("xvalidator iteration threw error")
            ## now want the test sets for the various iterations
            ords <- unlist( lapply( out, function(x) x[["test.idx"]] ) )
            featsUsed = list()
            if (do.fs) featsUsed = lapply(  out, function(x) x[["featInUse"]] )
            reord = match(inds, ords)
            ## getting and aggregating xval test scores and predictions (if available)
            teClassif <- unlist( sapply(out, function(x) testPredictions(x[["mlans"]])) )
            teScores <- lapply(out, function(x) testScores(x[["mlans"]]))
            if (is.vector(teScores[[1]])) {
              teScores <- unlist(teScores)              
              testscores <- teScores[reord]
            } else if (is.matrix(teScores[[1]])) {
              teScores <- do.call(rbind,teScores)
              testscores <- teScores[reord,]
            } else {
              message("Ignoring testScores of class ", class(teScores[[1]]),
                      ", expecting vector or matrix.")
              testscores <- NULL
            }
            testpred = factor(teClassif)[reord]
            ## ## train scores and predictions -- not sure if these should be
            ## ## returned as part of the classifierOutput
            ## trClassif <- unlist( sapply(out, function(x) trainPredictions(x[["mlans"]])) ) 
            ## trScores <- lapply(out, function(x) trainScores(x[["mlans"]]))
            ## if (is.vector(trScores[[1]])) {
            ##   trScores <- unlist(trScores)              
            ## } else if (is.matrix(trScores[[1]])) {
            ##   trScores <- do.call(rbind,trScores)
            ## } else {
            ##   warning("Ignoring trainScores of class ",class(trScores[[1]]),
            ##           ", expecting vector or matrix.")
            ##   trainscores <- NULL
            ## }
            ## trainpred = factor(teClassif)
            new("classifierOutput",
                testPredictions=testpred,
                testScores=testscores,
                ## trainScores=trainscores,
                ## trainPredictions=trainpred,
                testOutcomes=teo,
                call=thecall,
                RObject = out,
                fsHistory=featsUsed,
                learnerSchema=.method)
          })


setMethod("MLearn",
          c("formula", "ExpressionSet", "learnerSchema", "xvalSpec" ),
          function( formula, data, .method, trainInd, ...) {
            thecall = match.call()
            data = es2df(data, keep=as.character(as.list(formula)[[2]]))
            ans = MLearn(formula, data, .method, trainInd, ...)
            ans@call = thecall
            ans@learnerSchema = .method
            ans
          })

#
# code to provide planar displays of classifier predictions
#
# currently assumes use of two raw expression vectors to define
# the plane
#

setGeneric("getGrid", function(x) standardGeneric("getGrid"))

setMethod("getGrid", "ExpressionSet", function(x) {
    lims <- apply(exprs(x), 1, range)
    if (ncol(lims) > 2) 
        warning("grid based only on first 2 genes")
    nn <- colnames(lims)
    v1 <- seq(lims[1, 1], lims[2, 1], len = 200)
    v2 <- seq(lims[1, 2], lims[2, 2], len = 200)
    og <- expand.grid(v1, v2)
    names(og) <- make.names(nn)
    og
})

setMethod("getGrid", "data.frame", function(x) {
    lims <- apply(x, 2, range)
    if (ncol(lims) > 2) 
        warning("grid based only on first 2 genes")
    nn <- colnames(lims)
    v1 <- seq(lims[1, 1], lims[2, 1], len = 200)
    v2 <- seq(lims[1, 2], lims[2, 2], len = 200)
    og <- expand.grid(v1, v2)
    names(og) <- make.names(nn)
    og
})



setGeneric("planarPlot", function(clo, eset, classifLab ) standardGeneric("planarPlot"))

setMethod("planarPlot", c("classifierOutput", "ExpressionSet", "character"), 
	function(clo, eset, classifLab) {
 requireNamespace("RColorBrewer")
 pal <- RColorBrewer::brewer.pal("Set2", n=8)
 ff <- getGrid(eset)
 if (clo@learnerSchema@mlFunName %in% c("nnet", "rpart"))
    ps <- predict( RObject(clo), newdata=ff, type="class")
 else if (clo@learnerSchema@mlFunName == "randomForest")
    {
    names(ff) <- rownames(exprs(eset))
    ps <- predict( RObject(clo), newdata=ff )
    }
 else
    ps <- predict( RObject(clo), newdata=ff )
 if (clo@learnerSchema@mlFunName %in% c("lda", "qda")) ps <- ps[[1]]
 plot( ff[,1], ff[,2], col=pal[as.numeric(factor(ps))], pch=19,
 xlab = names(ff)[1], ylab=names(ff)[2] )
 #text( exprs(eset)[1,], exprs(eset)[2,], lab=pData(eset)[[classifLab]])
})

#setMethod("planarPlot", c("classifOutput", "data.frame", "character"), 
#	function(clo, eset, classifLab) {
# require(RColorBrewer)
# pal <- brewer.pal("Set2", n=8)
# ff <- getGrid(eset)
# if (clo@method %in% c("nnet", "rpart"))
#    ps <- predict( clo@RObject, newdata=ff, type="class")
# else if (clo@method == "randomForest")
#    {
#    names(ff) <- rownames(exprs(eset))
#    ps <- predict( clo@RObject, newdata=ff )
#    }
# else
#    ps <- predict( clo@RObject, newdata=ff )
# if (clo@method %in% c("lda", "qda")) ps <- ps[[1]]
# plot( ff[,1], ff[,2], col=pal[as.numeric(factor(ps))], pch=19,
# xlab = names(ff)[1], ylab=names(ff)[2] )
# #text( exprs(eset)[1,], exprs(eset)[2,], lab=pData(eset)[[classifLab]])
#})

#####################
# PACKAGE: cluster
#####################
#
#####################
# title: agnesB
# description: interface to agnes {cluster} 
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data to use for classification
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# agOut <- agnesB(golubMerge[100:200,], "ALL.AML")
#####################

setGeneric("agnesB", function(exprObj, k, height=0, stand=FALSE, method="average",
		keep.diss=TRUE, keep.data=TRUE, metric="euclidean", ...){
		standardGeneric("agnesB")
})

setMethod("agnesB", c("ExpressionSet", "numeric", "ANY", 
                "ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, k, height, stand, method, keep.diss, keep.data, metric, ...){

		dat <- t(exprs(exprObj))
		dis <- dist(dat, method=metric)
#		row.names(dat) <- pData(exprObj)[[classifLab]]
		
		out <- cluster::agnes(dat, metric=metric, stand=stand, method=method, 
					keep.diss=keep.diss, keep.data=keep.data)
		tmp <- wrapClust(out, k, height, dis)

		new("clustOutput", method="agnes",
			RObject=out, call=match.call(),
			distMat=dis,
			clustIndices=tmp$clinds, clustScores=tmp$clsco)
})

#####################
# title: claraB
# description: interface to clara {cluster}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# clObj <- claraB(golubMerge[100:200,], "ALL.AML", 2)
#####################

setGeneric("claraB", function(exprObj, k, height=0, stand=FALSE, 
		samples=5, sampsize, trace=0, keep.data=TRUE, keepdata, rngR=FALSE, metric="euclidean"){
		standardGeneric("claraB")
})

setMethod("claraB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", 
		"ANY", "ANY"), function(exprObj, k, height, stand, samples, sampsize,
		trace, keep.data, keepdata, rngR, metric){

		if(missing(sampsize)){ sampsize <- 40 + 2*k }
		if (height > 0 ) warning("ignoring height parameter")

		dat <- t(exprs(exprObj))
		dis <- dist(dat, method=metric)
		out <- cluster::clara(dat, k=k, metric=metric, stand=stand, samples=samples, 							sampsize=sampsize, trace=trace, keep.data=keep.data, keepdata=keepdata, rngR= rngR)	
                clinds <- newGroupIndex(out$clustering)
                clsco <- newSilhouetteVec(cluster::silhouette( clinds, dis )[,3])
		new("clustOutput", method="clara",
			RObject=out, call=match.call(),
			distMat=dis,
			clustIndices=clinds, clustScores=clsco)
})

#####################
# title: dianaB
# description: interface to diana {cluster}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data to use for classification
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# diOut <- dianaB(golubMerge[100:200,], "ALL.AML")
#####################

setGeneric("dianaB", function(exprObj, k, height=0, diss, stand=FALSE, 
		keep.diss, keep.data=TRUE, metric="euclidean"){
		standardGeneric("dianaB")
})

setMethod("dianaB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, k, height, diss, stand, keep.diss, keep.data, metric){

		dat <- t(exprs(exprObj))
		dis <- dist(dat, method=metric)

		out <- cluster::diana(dat, diss=FALSE, metric=metric, 
					stand=stand, keep.diss=TRUE,
					keep.data=keep.data)
		tmp <- wrapClust( out, k, height, dis)

		new("clustOutput", method="diana",
			RObject=out, call=match.call(),
			distMat=dis,
			clustIndices=tmp$clinds, clustScores=tmp$clsco)
})

#####################
# title: fannyB
# description: interface to fanny {cluster}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# faOut <- fannyB(golubMerge[100:200,], "ALL.AML", 2)
#####################

setGeneric("fannyB", function(exprObj, k, height=0, diss, stand=FALSE, metric="euclidean"){
		standardGeneric("fannyB")
}) 

setMethod("fannyB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, k, height, diss, stand, metric){
		if (height > 0) warning("ignoring height parameter")

		if(missing(diss)){ diss <- F }

		dat <- t(exprs(exprObj))
		dis <- dist(dat, method=metric)
		out <- cluster::fanny(dat, k=k, diss=diss, metric=metric, stand=stand)

		clinds <- newGroupIndex(out$clustering)
                clsco <- newSilhouetteVec(cluster::silhouette( clinds, dis )[,3])
		new("clustOutput", method="fanny",
			RObject=out, call=match.call(),
			distMat=dis,
			clustIndices=clinds, clustScores=clsco)
})

#####################
# title: pamB
# description: interface to pam {cluster}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# paOut <- pamB(golubMerge[100:200,], "ALL.AML", 2)
#####################

setGeneric("pamB", function(exprObj, k, height=0, diss, stand=FALSE, 
		keep.diss=TRUE, keep.data=TRUE, metric="euclidean"){
		standardGeneric("pamB")
})

setMethod("pamB", c("ExpressionSet", "numeric", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, k, height, diss, stand, keep.diss, keep.data, metric){

		
		dat <- t(exprs(exprObj))
		dis <- dist(dat, method=metric)
		if (height > 0 ) warning("ignoring height parameter")
		out <- cluster::pam(dat, k=k, diss=FALSE, metric=metric, stand=stand, keep.diss=keep.diss, 
					keep.data=keep.data)
		clinds <- newGroupIndex(out$clustering)
                clsco <- newSilhouetteVec(cluster::silhouette( clinds, dis )[,3])
		new("clustOutput", method="pam",
			RObject=out, call=match.call(),
			distMat=dis,
			clustIndices=clinds, clustScores=clsco)
})
			
#
# UNTIL THERE IS A CLEAR METHOD FOR DICHOTOMIZING AN EXPRSET,
# MONA WILL HAVE TO BE RUN RAW

#####################
# title: monaB
# description: interface to mona {cluster}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# x <- matrix(sample(c(1,2), 7272, replace=T), ncol=72, nrow=101)
# colnames(x) <- golubMerge$"ALL.AML"
# g2Merge <- golubMerge[100:200,]
# exprs(g2Merge) <- x
# mOut <- monaB(g2Merge, "ALL.AML")
# note: artificial example since data needs to be binary
#####################

#setGeneric("monaB", function(exprObj, classifLab, metric="euclidean"){
#		standardGeneric("monaB")
#})
#
#setMethod("monaB", c("ExpressionSet", "character", "ANY"), 
#		function(exprObj, classifLab, metric){
#
#		dat <- t(exprs(exprObj))
#		dis <- dist(dat, method=metric)
#		row.names(dat) <- pData(exprObj)[[classifLab]]
#		out <- cluster::mona(dat)
#
#		new("classifPred", sampLabels=pData(exprObj)[[classifLab]], distMat=dis, classifObj=out)
##})

#####################
# PACKAGE: pamr
#####################
# 
#####################
# title: pamrB
# description: interface to pamr {pamr}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# pOut <- pamrB(golubMerge[100:200,], "ALL.AML", train)
####################

setGeneric("pamrB", function(exprObj, classifLab, trainInd, thresholdp=1, threshold, 
			n.threshold = 30, scale.sd = TRUE, threshold.scale, se.scale, 
			offset.percent = 50, prior, remove.zeros = TRUE, sign.contrast="both", 
			metric="euclidean"){
			standardGeneric("pamrB")
})
		
setMethod("pamrB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", "ANY", 
			"ANY", "ANY", "ANY", "ANY", "ANY", "ANY"),
			function(exprObj, classifLab, trainInd, thresholdp, threshold, n.threshold, 
			scale.sd, threshold.scale, se.scale, offset.percent, prior, remove.zeros, 
			sign.contrast="both", metric){
			
			if(missing(threshold)){ threshold <- NULL }
			if(missing(prior)){ prior <- NULL }
			if(missing(threshold.scale)){ threshold.scale <- NULL }
			if(missing(se.scale)){ se.scale <- NULL }

			cl <- pData(exprObj)[[classifLab]][trainInd]
			trainDat <- list(x=exprs(exprObj)[,trainInd], y = cl)
			testDat <- exprs(exprObj)[,-trainInd]
				
			dis <- dist(t(exprs(exprObj)[,-trainInd]), method=metric)
			
require(pamr)
			out <- pamr.train(trainDat, threshold=threshold, n.threshold=n.threshold, 
			scale.sd=scale.sd, threshold.scale=threshold.scale, se.scale=se.scale,
			offset.percent=offset.percent, prior=prior, remove.zeros=remove.zeros, 
			sign.contrast=sign.contrast)
			res <- pamr.predict(out, testDat, thresholdp)
                new("classifOutput", method="pamr",
                        predLabels=newPredClass(as.character(res)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
                        predScores=newProbArray(out$prob),
                        RObject=out, call=match.call(), distMat=dis)

})

#####################
# PACKAGE: MASS
#####################
#
#####################
# title: ldaB
# description: interface to lda {MASS}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classif3Output"
# example:
# train <- c(sample(1:47, 21), sample(48:72, 12))
# lOut <- ldaB(golubMerge[100:200,], "ALL.AML", train)
####################

setGeneric("ldaB", function(exprObj, classifLab, trainInd, prior, tol=1.0e-4, 
		method, CV=FALSE, nu, metric="euclidean", ...){
		standardGeneric("ldaB")
})

setMethod("ldaB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, prior, tol, method, CV, nu, metric, ...){

		if(missing(method)){ method <- NULL }
		if(missing(nu)){ nu <- NULL }
		cl <- pData(exprObj)[[classifLab]][trainInd]
		if(missing(prior)){ prior <- as.numeric(table(cl))/length(cl) }
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])
		dis <- dist(testDat, method=metric)
		out <- MASS::lda(trainDat, grouping=cl, prior=prior, tol=tol, method=method, 
				CV=CV, nu=nu, ...)
		res <- predict(out, testDat, ...)
                new("classifOutput", method="lda",
                        predLabels=newPredClass(as.character(res$class)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
                        predScores=newProbMat(res$posterior),
                        RObject=out, call=match.call(), distMat=dis)
})

#####################
# title: qdaB
# description: interface to qda {MASS}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classif3Output"
# example:
# train <- c(sample(1:47, 21), sample(48:72, 12))
# qOut <- qdaB(golubMerge[100:200,], "ALL.AML", train)
# note: example is not executable - "some group is too small for qda"
####################

setGeneric("qdaB", function(exprObj, classifLab, trainInd, prior, tol=1.0e-4, method, CV=FALSE, nu, 
		metric="euclidean", ...){
		standardGeneric("qdaB")
})

setMethod("qdaB", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, prior, tol, method, CV, nu, metric, ...){
		if(missing(method)){ method <- NULL }
		if(missing(nu)){ nu <- NULL }
		cl <- pData(exprObj)[[classifLab]][trainInd]
		if(missing(prior)){ prior <- as.numeric(table(cl))/length(cl) }
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])
		dis <- dist(testDat, method=metric)
		out <- MASS::qda(trainDat, cl, prior=prior, tol=tol, method=method,
				CV=CV, nu=nu, ...)
		res <- predict(out, testDat, ...)
                new("classifOutput", method="qda",
                        predLabels=newPredClass(as.character(res$class)),
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
                        predScores=newProbMat(res$posterior),
                        RObject=out, call=match.call(), distMat=dis)
})

#####################
# title: isoMDSB
# description: interface to isoMDS {MASS}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# iOut <- isoMDSB(golubMerge[100:200,], "ALL.AML", k=1)
####################

setGeneric("isoMDSB", function(exprObj, classifLab, y, k=2, maxit=50, trace=TRUE, 
		tol=1e-3, p=2, metric="euclidean"){
		standardGeneric("isoMDSB")
})

#setMethod("isoMDSB", c("ExpressionSet", "character", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"),
#		function(exprObj, classifLab, y, k, maxit, trace, tol, p, metric){
#
#		cl <- pData(exprObj)[[classifLab]]
#		dat <- exprs(exprObj)
#		colnames(dat) <- cl
#		dmat <- dist(t(dat), method=metric)
#
#		if(missing(y)){ y <- cmdscale(dmat, k) }
#
#		out <- MASS::isoMDS(dmat, y=y, k=k, maxit=maxit, trace=trace, tol=tol, p=p)				
#		res <- predict(out, testDat, ...)
#                new("classifOutput", method="qda",
#                        predLabels=newPredClass(as.character(res$class)),
#			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
#                        predScores=newProbMat(res$posterior),
#                        RObject=out, call=match.call(), distMat=dis)
#		new("classifPred", sampLabels=cl, distMat=dmat, classifObj=out)
#})

#####################
# title: sammonB
# description: interface to sammon {MASS}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# sOut <- sammonB(golubMerge[100:200,], "ALL.AML")
####################
#
#setGeneric("sammonB", function(exprObj, classifLab, y, k=2, niter=100, trace=TRUE, 
#		magic=0.2, tol=1e-4, metric="euclidean"){
#		standardGeneric("sammonB")
#})
#
#setMethod("sammonB", c("ExpressionSet", "character", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"),
#		function(exprObj, classifLab, y, k, niter, trace, magic, tol, metric){
#
#		cl <- pData(exprObj)[[classifLab]]
#		dat <- exprs(exprObj)
#		colnames(dat) <- cl
#		dmat <- dist(t(dat), method=metric)
#		if(missing(y)){ y <- cmdscale(dmat, k) }
#
#		out <- MASS::sammon(dmat, y=y, k=k, niter=niter, trace=trace,
#					magic=magic, tol=tol)
#		new("classifPred", sampLabels=cl, distMat=dmat, classifObj=out)
#})

partPlot <- function(x, p, doXax=TRUE, ...) {
  ## Not scaling kmeans' partitions p, only matrix x - L. Gatto 10 Nov 2012
  rzsco <- function(x) (x-median(x))/mad(x)
  x <- data.matrix(x)
  x <- apply(x, 2, rzsco)
  d <- cbind(as.numeric(p), x)
  d <- d[order(d[,1]),]
  image(t(d), axes=FALSE, xlab="part.; features", ylab="cases", ...)
  if (doXax) axis(1, at=seq(.01,.99,len=ncol(d)), c("part.", colnames(d)[-1]))
}

#####################
# title: silhouetteB
# description: interface to silhouette {cluster} 
# arguments:
#	out	output of any function in machLI
#		i.e. a classifOutput object (or any of its 
#		extensions)
# value:
# 	object of class "silhouette"
# example:
# train <- c(sample(1:47, 23), sample(48:72, 12))
# knnOut <- knnB(golubMerge[100:200,], "ALL.AML", train) 
# agOut <- agnesB(golubMerge[100:200,], "ALL.AML")
# sil.knn <- silhouetteB(knnOut)
# sil.ag <- silhouetteB(agOut)
# plot(sil.ag, main="Silhouette Plot for Agnes Clustering")	
# plot(sil.knn, main="Silhouette Plot for knn Classification")
#####################

setGeneric("silhouetteB", function(out, ...){
	standardGeneric("silhouetteB")
})

setMethod("silhouetteB", c("classifOutput"), 
	function(out, ...){
	
	lab <- out@predLabels@.Data

	if(is.factor(lab)){ 
		lab <- as.integer(lab)
	}
        else if (is(lab, "character"))
 		lab = as.integer(factor(lab))
	cluster::silhouette(lab, out@distMat, ...)
})

setMethod("silhouetteB", c("clustOutput"), 
	function(out, ...){
	
	lab <- out@clustIndices@.Data

	if(is.factor(lab)){ 
		lab <- as.integer(lab)
	}
        else if (is(lab, "character"))
 		lab = as.integer(factor(lab))
	cluster::silhouette(lab, out@distMat, ...)
})

## randomForestI = makeLearnerSchema("randomForest", "randomForest",
##     standardMLIConverter)
randomForestI = makeLearnerSchema("randomForest", "randomForest",
  MLIConverter.randomForest,
  MLIPredicter.randomForest)

knnI = function(k=1, l=0) {
  makeLearnerSchema("MLInterfaces", "knn2",
                    MLIConverter.knn(k, l),
                    MLIPredicter.knn)}


knn.cvI = function(k=1, l=0) {
  makeLearnerSchema("MLInterfaces", "knn.cv2",
                    MLIConverter.knncv(k, l))}

dldaI = makeLearnerSchema("MLInterfaces", "dlda2",
    MLIConverter.dlda)

rpartI = makeLearnerSchema("rpart", "rpart",
  MLIConverter.rpart) # get posterior

ldaI = makeLearnerSchema("MASS", "lda",
  MLIConverterListEl.class)

## svmI = makeLearnerSchema("e1071", "svm",
##     MLIConverter.svm)
svmI <- makeLearnerSchema("MLInterfaces", "svm2",
                          MLIConverter.svm,
                          MLIPredicter.svm)

ldaI.predParms = function(method) { # use this one with argument picking method
  makeLearnerSchema("MASS", "lda", # for predict.lda
                    MLIConverter.ldaPredMeth(method))
}

qdaI = makeLearnerSchema("MASS", "qda",
  MLIConverterListEl.class)

glmI.logistic = function(threshold) { # could build ROC
  makeLearnerSchema("stats", "glm", 
                     MLIConverter.logistic(threshold))}

RABI = makeLearnerSchema("MLInterfaces", "rab",
  MLIConverter.RAB)

lvqI = makeLearnerSchema("MLInterfaces", "lvq",
  MLIConverter.dlda)

naiveBayesI = makeLearnerSchema("e1071", "naiveBayes",
  MLIConverter.naiveBayes,
  MLIPredicter.naiveBayes)

# to do as of 12 Sep 2007 -- inclass, inbagg [ need good cFUN examples before going there ]
# pamr, gbm, logitBoost

## ksvmI = makeLearnerSchema("kernlab", "ksvm",
##   standardMLIConverter)
ksvmI <- makeLearnerSchema("MLInterfaces", "ksvm2",
                           MLIConverter.ksvm,
                           MLIPredicter.ksvm)

adaI = makeLearnerSchema("ada", "ada",
  standardMLIConverter)

#hclustI = function(distMethod, agglomMethod) {
#    if (missing(distMethod)) stop("distMethod must be explicitly supplied")
#    if (missing(agglomMethod)) stop("agglomMethod must be explicitly supplied")
#    makeClusteringSchema( "stats", 
#        "hclust", distMethod, hclustConverter, agglomMethod) }
#
#kmeansI = function(algorithm, distMethod="identity") {
#    if (missing(algorithm)) stop("algorithm must be explicitly supplied")
#    makeClusteringSchema( "stats", 
#        "kmeans", distMethod=distMethod, algorithm=algorithm, 
#         converter=kmeansConverter) }
#
#pamI = function(distMethod) {
#    if (missing(distMethod)) stop("distMethod must be explicitly supplied")
#    makeClusteringSchema( "cluster", 
##        "pam", distMethod, pamConverter) }

#logitboostI = makeLearnerSchema("MLInterfaces", "logitboost2",
#    standardMLIConverter)

BgbmI = function(n.trees.pred=1000, thresh=.5) {
  makeLearnerSchema("MLInterfaces", "gbm2", 
                    MLIConverter.Bgbm(n.trees.pred,thresh))}

blackboostI = makeLearnerSchema("mboost", "blackboost",
  MLIConverter.blackboost)

                    
nnetI = makeLearnerSchema("nnet", "nnet",
    MLIConverter.nnet,
    MLIPredicter.nnet)

baggingI = makeLearnerSchema("ipred", "bagging",
  standardMLIConverter)

#rdacvI = makeLearnerSchema("MLInterfaces", "rdacvML",
#  standardMLIConverter)
#
#rdaI = makeLearnerSchema("MLInterfaces", "rdaML",
#  standardMLIConverter)

sldaI = makeLearnerSchema("ipred", "slda",
  MLIConverter.slda)

# to do as of 12 Sep 2007 -- inclass, inbagg [ need good cFUN examples before going there ]
# pamr, gbm, logitBoost


#hclustI = function(distMethod, agglomMethod) {
#    if (missing(distMethod)) stop("distMethod must be explicitly supplied")
#    if (missing(agglomMethod)) stop("agglomMethod must be explicitly supplied")
#    makeClusteringSchema( "stats", 
#        "hclust", distMethod, hclustConverter, agglomMethod) }
#
#kmeansI = function(algorithm, distMethod="identity") {
#    if (missing(algorithm)) stop("algorithm must be explicitly supplied")
#    makeClusteringSchema( "stats", 
#        "kmeans", distMethod=distMethod, algorithm=algorithm, 
#         converter=kmeansConverter) }
#
#pamI = function(distMethod) {
#    if (missing(distMethod)) stop("distMethod must be explicitly supplied")
#    makeClusteringSchema( "cluster", 
##        "pam", distMethod, pamConverter) }

#logitboostI = makeLearnerSchema("MLInterfaces", "logitboost2",
#    standardMLIConverter)

plsdaI <- makeLearnerSchema("MLInterfaces",
                            "plsda2",
                            MLIConverter.plsda,
                            MLIPredicter.plsda)

planarPlot2 = function (clo, eset, classifLab, ...) 
{
    requireNamespace("RColorBrewer")
    pal <- RColorBrewer::brewer.pal("Set2", n = 8)
    ff <- getGrid(eset)
    if (clo@learnerSchema@mlFunName %in% c("nnet", "rpart")) 
        ps <- predict(RObject(clo), newdata = ff, type = "class")
    else if (clo@learnerSchema@mlFunName %in% c("dlda2"))
        #ps <- MLInterfaces:::predict.dlda2(RObject(clo), newdata = ff)
        ps <- predict.dlda2(RObject(clo), newdata = ff)
    else if (clo@learnerSchema@mlFunName %in% c("ada"))
        ps <- ada:::predict.ada(RObject(clo), newdata = ff, type="vector")
    else if (clo@learnerSchema@mlFunName %in% c("lda"))
        ps <- MASS:::predict.lda(RObject(clo), newdata = ff)
    else if (clo@learnerSchema@mlFunName %in% c("knn2"))
        #ps <- MLInterfaces:::predict.knn2(RObject(clo), newdata = ff)
        ps <- predict.knn2(RObject(clo), newdata = ff)
    else if (clo@learnerSchema@mlFunName %in% c("svm2"))
        ps <- e1071:::predict.svm(RObject(clo), newdata = ff)
    else if (clo@learnerSchema@mlFunName == "randomForest") {
        names(ff) <- rownames(exprs(eset))
        ps <- predict(RObject(clo), newdata = ff)
    }
    #else ps <- MLInterfaces:::predict(RObject(clo), newdata = ff)
    else ps <- predict(RObject(clo), newdata = ff)
    if (clo@learnerSchema@mlFunName %in% c("lda", "qda")) 
        ps <- ps[[1]]
    plot(ff[, 1], ff[, 2], col = pal[as.numeric(factor(ps))], 
        pch = 19, xlab = names(ff)[1], ylab = names(ff)[2], ...)
    legend(min(ff[, 1]) + 0.2, max(ff[, 2]) - 0.5, legend = unique(ps), 
        col = pal[unique(as.numeric(factor(ps)))], pch = 19, bty="n")
#    legend(min(ff[, 1]) + 0.2, max(ff[, 2]) - 0.5, legend = unique(ps), 
#        col = 1, pch = 1)
}
mlearnWidget = function(eset, infmla) {
  learnerTags = c("LDA", "DLDA", "SLDA", "rpart", "randomForest",
                   "knn1", "nnet(size, decay)", "adaboost")
  valMethTags = c("random half", "NOTEST", "5-fold xval",
                   "10-fold xval", "5f xvalFS topvar(.75)")
 shinyApp(ui = fluidPage(
  fluidRow( column(6, textOutput("title", container=h1)),
            column(2, actionButton("btnSend", "Stop widget"))),
  fluidRow(
   column(2,  selectInput("learner", label = "Learning method:",
               choices = learnerTags,
               selected = "randomForest")),

   column(2,  selectInput("valmeth", label = "Validation method:",
               choices = valMethTags,
               selected="NOTEST")),
   column(2,  numericInput("nfeat", label = "N features (decr. in MAD):", 100, min = 2, max = 10000)),
   column(2,  numericInput("nnetdecayOrCP", label = "decay/cp", .01, min = .001, max = .5)),
   column(1,  numericInput("nnetsize", label = "size (nnet)", 3, min = 1, max = 10)),
   column(2,  numericInput("seed", label = "seed", 31415, min = 100, max = 100000))
          ),
  fluidRow(column(4, textOutput("space")), column(5, textOutput("miscl"))),
  fluidRow(column(4, htmlOutput("summRob")), column(5, tableOutput("confu"))),
  fluidRow(column(6, plotOutput("plotz")), column(6, plotOutput("pplot")))
 ), server= function(input, output, session) {
   mod = reactive({ 
     lr = switch( input$learner,
            "LDA" = ldaI,
            "DLDA" = dldaI,
            "SLDA" = sldaI,
            "rpart" = rpartI,
            "randomForest" = randomForestI,
            "knn1" = knnI(),
            "nnet(size, decay)" = nnetI,
            "adaboost" = adaI, 
            "bagging" = baggingI )
     extras = switch( input$learner,
            "LDA" = NULL,
            "DLDA" = NULL,
            "SLDA" = NULL,
            "rpart" = list(cp=input$nnetdecayOrCP),
            "randomForest" = list(importance=TRUE),
            "knn1" = NULL,
            "nnet(size, decay)" = list(size=input$nnetsize, decay=input$nnetdecayOrCP, MaxNWts=10000) )
     xv = switch(input$valmeth, "random half" = sample(seq_len(ncol(eset)), size=ceiling(ncol(eset)/2)),
                      "NOTEST" = xvalSpec("NOTEST"),
                      "5-fold xval"=xvalSpec("LOG", 5, balKfold.xvspec(5)),
                      "10-fold xval"=xvalSpec("LOG", 10, balKfold.xvspec(10)),
                      "5f xvalFS topvar(.75)"=xvalSpec("LOG", 5, balKfold.xvspec(5),
                             fsFun=fs.topVariance(.75)))
     list(learner=lr, xvmeth=xv, extras=extras)
     })
   nf = reactive({ input$nfeat })
   output$space = renderText( "RObject excerpt:  " )
   output$title = renderText("MLearn widget")

totext = function(x) {
    on.exit({
        sink(NULL)
    })
    tf = tempfile()
    sink(tf)
    print(x)
    hwriter::hwrite(matrix(readLines(tf), ncol=1))
}

tize = function (x) 
{
#
# purpose is to form an HTML rendering of part of the
# RObject(mloutput) as printed to console
#
    on.exit({
        sink(NULL)
    })
    tf = tempfile()
    sink(tf)
    print(RObject(x))
    rl = readLines(tf)
    hwriter::hwrite(matrix(rl[seq_len(min(10, length(rl)))], ncol=1), byrow=TRUE)
}

   ans = reactive({ 
     argl = c(list(
               formula= infmla,
               data=eset[seq_len(nf()),], .method=mod()$learner, 
               trainInd=mod()$xv ), mod()$extras )
     set.seed(input$seed)
     do.call(MLearn, argl ) })
   output$summRob = renderText( tize(ans() ) )
   output$confu = renderTable({ options(digits=3); 
            if (input$learner == "randomForest") 
                   return(RObject(ans())$confu)
            else if (input$valmeth == "NOTEST") 
                    return(confuMat(ans(), "train"))
            confuMat(ans())})
   output$plotz = renderPlot( {
                   par(las=2, mar=c(4,7,2,2))
                   if (input$learner == "randomForest" & 
                         input$valmeth %in% c("NOTEST", "random half"))
                      plot(getVarImp( ans(), TRUE ), n=10, plat=annotation(eset),
                            toktype = "SYMBOL" )
                   else if (input$learner == "rpart" & input$valmeth == "NOTEST") {
                      par(mfrow=c(1,2))
#                      library(rpart)
                      requireNamespace("rpart")
                      plotcp(RObject( ans() ) )
                      plot(RObject( ans() ) )
                      text(RObject( ans() ) )
                      }
                   #else plot(1,1)
                   } )
   output$pplot = renderPlot( {
          if (nchar(abstract(eset))==0) {
              et2 = eset[c("204685_s_at", "206409_at"),]
               argl = c(list(
               formula= infmla,
               data=et2, .method=mod()$learner, 
               trainInd=sample(seq_len(ncol(et2)), size=ceiling(ncol(et2)/2) )), mod()$extras )
             set.seed(input$seed)
             ans2 = do.call(MLearn, argl ) 
              rownames(et2) = paste0("X", featureNames(et2))
              planarPlot2(ans2, et2, "Tissue", main = "TIAM1 vs ATP2B2 (train half)" ) 
              }
          else {
#    PROBEID  SYMBOL
#1 1007_s_at    DDR1
#2 1007_s_at MIR4640
#> AnnotationDbi::select(hgu95av2.db, keys="IFNG", keytype="SYMBOL", columns="PROBEID")
#  SYMBOL   PROBEID
#1   IFNG   1021_at
#2   IFNG 1611_s_at
#3   IFNG  40702_at
              et2 = eset[c("1007_s_at", "1021_at"),]
               argl = c(list(
               formula= infmla,
               data=et2, .method=mod()$learner, 
               trainInd=sample(seq_len(ncol(et2)), size=ceiling(ncol(et2)/2)) ), mod()$extras )
             set.seed(input$seed)
             ans2 = do.call(MLearn, argl ) 
              rownames(et2) = paste0("X", featureNames(et2))
              planarPlot2(ans2, et2, "Tissue", main = "IFNG vs DDR1 (train half)" ) 
              }

           })
   output$miscl = renderText({ 
            if (input$learner == "randomForest" & input$valmeth %in% c("NOTEST", "random half")) {
                    mat = RObject(ans())$confu
                    mat = mat[,-ncol(mat)]
                    }
            else if (input$valmeth == "NOTEST") {
                    mat = confuMat(ans(), "train")
                    }
            else mat = confuMat(ans())
            sm = sum(mat)
            off = sm-sum(diag(mat))
            paste("est. miscl. rate = ", round(off/sm,3))
            })
    observe({
                    if(input$btnSend > 0)
                        isolate({
                           stopApp(returnValue=0)
                        })
           })

})}

setOldClass("prcomp")
setOldClass("silhouette")
setClass("prcompObj", contains="prcomp")

#setClass("clusteringOutput", representation(
#        partition="numeric", silhouette="silhouette", 
#        prcomp="prcompObj", distFun="function", converter="function",
#        call="call", learnerSchema="clusteringSchema",
#        RObject="ANY"), prototype=prototype(
#                  partition=numeric(0),
#                  silhouette={x = 0; class(x)="silhouette"; x},
#                  prcomp={x = 0; class(x)="prcomp"; new("prcompObj", x)},
#                  distFun = dist, converter=function(){}, call=new("call"))
#                  )

#setGeneric("RObject", function(x) standardGeneric("RObject"))
setMethod("RObject", "clusteringOutput", function(x) x@RObject)

#setGeneric("MLearnC", 
#   function(formula, data, schema, ...)
#     standardGeneric("MLearnC"))

#setClass("clusteringSchema", representation(
#   package="character", mlFunName="character",
#   distFun="function", converter="function"))

setMethod("show", "clusteringSchema", function(object) {
  cat("MLInterfaces clusteringSchema for calling\n")
  cat(object@mlFunName, "in package", object@package, ";\n")
  cat("use getDist or getConverter on this schema object to see specifics.\n")
})
setGeneric("getDist", function(x)standardGeneric("getDist"))
setGeneric("getConverter", function(x)standardGeneric("getConverter"))
setMethod("getDist", "clusteringSchema", function(x) x@distFun)
setMethod("getConverter", "clusteringSchema", function(x) x@converter)

## require(cluster)



setMethod("show", "clusteringOutput", function(object) {
 cat("clusteringOutput: partition table\n")
 print(table(object@partition))
 cat("The call that created this object was:\n")
 print(object@call)
})


setMethod("plot", "clusteringOutput", function(x, y, ...) {
  opar = par(no.readonly=TRUE)
  on.exit(par(opar))
  par(mfrow=c(2,2))
  NO_PLOT_METHOD = c("kmeans")
  if (x@learnerSchema@mlFunName %in% NO_PLOT_METHOD) {
    if (missing(y)) stop("second arg must be matrix with feature data on all records")
    partPlot(y, x@partition, las=2, ...)
  }
  else if (x@learnerSchema@mlFunName == "pam") {
    plot(RObject(x), which=1, ...)
  } 
  else if (x@learnerSchema@mlFunName == "hclust") {
    stats:::plot.hclust(RObject(x), ...)
  } 
  else {
    plot(RObject(x), ...)
  }
  plot(x@silhouette, main="silhouette")
  plot(x@prcomp, main="PCA screeplot")
  plot(x@prcomp$x[,1], x@prcomp$x[,2], col=x@partition,
       xlab="PC1", ylab="PC2", main="PCA colored by partition")
})



hclustConverter = function(tpl) function(obj, dstruct) {
#
# tasks of the converter: generate a clusteringOutput instance
# with entities unique to the clustering algorithm, principally the RObject,
# the partition
#
# in this case we need a closure to pass selections for cutree
#
   tpl[[length(tpl)+1]] = obj
   names(tpl)[length(tpl)] = "tree"
   part = do.call(get("cutree", "package:stats"), tpl)
   new("clusteringOutput", RObject=obj, partition=part)
}

kmeansConverter = function(obj, dstruct) {
#
# tasks of the converter: generate a clusteringOutput instance
# with entities unique to the clustering algorithm, principally the RObject,
# the partition
#
   new("clusteringOutput", RObject=obj, partition=obj$clus)
}

pamConverter = function(obj, dstruct) {
#
# tasks of the converter: generate a clusteringOutput instance
# with entities unique to the clustering algorithm, principally the RObject,
# the partition
#
   new("clusteringOutput", RObject=obj, partition=obj$clustering)
}

hclustI = function(distFun, cutParm) {
   if (missing(distFun)) stop("distFun must be supplied as a function")
   if (!is.list(cutParm)) stop("cutParm must be a list with element name in c('h', 'k')")
   new("clusteringSchema",
      package="stats", mlFunName="hclust",
         distFun=distFun, converter=hclustConverter(cutParm))
}

kmeansI = 
   new("clusteringSchema",
      package="stats", mlFunName="kmeans",
         distFun=function(x)x, converter=kmeansConverter)

pamI = function(distFun) {
   if (missing(distFun)) stop("distFun must be supplied as a function")
   new("clusteringSchema",
      package="cluster", mlFunName="pam",
         distFun=distFun, converter=pamConverter)
}

setMethod("MLearn", c("formula", "data.frame",
   "clusteringSchema", "ANY"),
   function(formula, data, .method, trainInd, ...) {
   lfun = do.call("::", list(pkg=.method@package, name=.method@mlFunName))
#
# formula work
#
  dframe = try(model.frame(formula, data, na.action=na.fail))
  if (inherits(dframe, "try-error"))
     stop("problem in model.frame -- could be NA in data.  must stop.")
  rawdata = data = data.matrix(dframe)
  resp = model.response(dframe)
  if (!is.null(resp)) {
    kpcol = attr(attr(dframe, "terms"), "term.labels")
    data = data[, kpcol]
    rawdata = rawdata[, kpcol]
    }
#
# end formula work
#
   dstruc = .method@distFun(data)  # distFun could be identity
   ans = lfun( dstruc, ... )
   CLOb = .method@converter(ans, dstruc) # clusteringOutput
   if (!inherits(data, "dist")) dstruc = dist(data) # force euclidean for now
   CLOb@silhouette = cluster::silhouette(CLOb@partition, dstruc)
   CLOb@prcomp = new("prcompObj", prcomp(data))
   CLOb@learnerSchema = .method
   CLOb@call = match.call()
   CLOb
})
     
#library(MASS)
#data(crabs)
#
#cl1 = MLearn(~CW+RW+CL+FL+BD, data=crabs, hclustI(distFun=dist, cutParm=list(k=4)))
#cl2 = MLearn(~CW+RW+CL+FL+BD, data=crabs, kmeansI, centers=5, algorithm="Hartigan-Wong")

plspinHcube = function(insbwidth=4) {
# learner candidates -- bound up with extras for parameters etc.
  learnerTags = c("LDA", "DLDA", "rpart(cp)", "randomForest",
                   "knn1", "nnet(size, decay)") #, "blackboost")
#
#  message("This only works if threejs 0.2.2 is installed.  go to github.")
  shinyApp(ui = fluidPage(
   fluidRow( column(10, 
      textOutput("title", container=h1)) ),
   #fluidRow( column(2, 
   sidebarLayout(
    sidebarPanel(width=insbwidth,
#
# 3 boxes for data setup
        p(strong("Data setup for mlbench Hypercube:")),
        div(style="display:inline-block",numericInput(inputId="Npoints", label="# points", value = 
                         800, min=200, max=1200, step=200)), #),
        div(style="display:inline-block",numericInput(inputId="cubedim", label="cube dim.", value = 
                         3, min=2, max=6, step=1)), #),
        div(style="display:inline-block",      numericInput("vertSd", 
                         label="SD@vrtx",
                         value = .1, min=.05, max=2, step=.05)),
# box for learner method
        div(style="display:block"),
        div(style="display:inline-block",
             selectInput("learner", label = "Learning method:",
               choices = learnerTags,
               selected = "LDA")),
# box for misclassification rate
        div(style="display:block"),
        div(style="display:inline-block",
             strong(em(textOutput("mcl")))), 
        div(style="display:block"),
        br(),
# axis selections (need dim > 3)
        div(style="display:inline-block",
             numericInput("dim1", label = "pc for x",
               value = 1, min=1, max=8, step=1)), #),
        div(style="display:inline-block",
             numericInput("dim2", label = "pc for y",
               value = 2, min=2, max=8, step=1)), #),
        div(style="display:inline-block",
             numericInput("dim3", label = "pc for z",
               value = 3, min=3, max=8, step=1)), # end sidebarPanel  #),
        br(),
# for rendering options
        div(style="display:inline-block",
              selectInput("ngpts",
                         label="grid edge size   ",
                         choices=as.character(4:20),
                         selected="10")),
        div(style="display:inline-block",
             selectInput("renderer", label = "Rendering method:",
               choices = c("auto", "canvas"),
               selected = "auto")), #),
             numericInput("cp", label = "rpart cp:",
               value = .01, min=.01, max=20, step=.01), #),
# two boxes for tuning
             numericInput("nnsize", label = "nnet size:",
               value = 2, min=1, max=10, step=1), #),
             numericInput("nndecay", label = "nnet decay:",
               value = .01, min=0, max=2, step=.01)), #),
#   fluidRow( column(10, 
       mainPanel(
         scatterplotThreeOutput("spinner", height="600px") ) ) ), 
  server = function(input, output, session) {
    requireNamespace("mlbench")
#
# deal with current selections on learner
#
    mod = reactive({
     lr = switch( input$learner,
            "LDA" = ldaI,
            "DLDA" = dldaI,
            "rpart(cp)" = rpartI,
            "randomForest" = randomForestI,
            "knn1" = knnI(),
            "nnet(size, decay)" = nnetI,
#            "blackboost" = blackboostI,
            "bagging" = baggingI )
     extras = switch( input$learner,
            "LDA" = NULL,
            "DLDA" = NULL,
#            "blackboost" = list(family=Multinomial()),
            "rpart(cp)" = list(cp=input$cp),
            "randomForest" = list(importance=TRUE),
            "knn1" = NULL,
            "nnet(size, decay)" = list(size=input$nnsize, decay=input$nndecay, MaxNWts=10000) )
     predExtras = switch( input$learner,
#            "blackboost" = list(type="class"), 
            "nnet(size, decay)" = list(type="class"), 
            "rpart(cp)" = list(type="class"), NULL )

     wrapper = switch( input$learner,
            LDA = function(x) x$class, force )
     list(learner=lr, extras=extras, predExtras=predExtras, predWrapper=wrapper)
     })
#
# build display
#
     ans = reactive({
#
# build dataframe using selections on data parameters
#
       data = mlbench.hypercube(n=input$Npoints, d=as.numeric(input$cubedim), sd=input$vertSd)
       data = data.frame(cl=data$classes, data$x)
# training indices
       tinds = sample(seq_len(nrow(data)),size=floor(nrow(data)/2),replace=FALSE)
# model call -- need to ensure that 'extras' go into ... for projectLearnerToGrid
       argl = c(list(
                formula=cl~., data=data, learnerSchema=mod()$learner, 
                  trainInd = tinds, ngpts=as.numeric(input$ngpts), 
                  predExtras=mod()$predExtras,
                  predWrapper = mod()$predWrapper), mod()$extras )
       argl = argl[ which(sapply(argl, length)>0) ]
       cur = do.call( projectLearnerToGrid, argl )
       cmat = confuMat(cur@fittedLearner)
       ok = sum(diag(cmat))
       err = sum(cmat) - ok
       output$mcl = renderText( paste0("Test miscl. proportion (random half) = ", round(err/sum(cmat), 2) ) )
       proj = cur@gridFeatsProjectedToTrainingPCs
       if (input$cubedim == 2) proj = cbind(proj,0)
       projtest = cur@testFeatsProjectedToTrainingPCs
       if (input$cubedim == 2) projtest = cbind(projtest,0)
  
       nclass = length(unique(cur@gridPredictions))
#       thecolors = palette(rainbow(nclass))[cur@gridPredictions]
     #  print(table(cur@gridPredictions))
     #  print(class(cur@gridPredictions))
       thecolors = colorRampPalette(RColorBrewer::brewer.pal(8,"Set2"))(nclass)[as.numeric(cur@gridPredictions)]
       labs = as.character(cur@gridPredictions)
       obj = scatterplot3js( x = proj[,as.numeric(input$dim1)], 
               y = proj[,as.numeric(input$dim2)], 
               z = proj[,as.numeric(input$dim3)], 
               color=thecolors, renderer=input$renderer, labels=as.character(labs) )
#       obj$points3d( x = projtest[,as.numeric(input$dim1)], 
#               y = projtest[,as.numeric(input$dim2)], 
#               z = projtest[,as.numeric(input$dim3)], 
#               color="black" , size=2)
       list(obj=obj, prmat=projtest[, c(as.numeric(input$dim1), as.numeric(input$dim2), as.numeric(input$dim3))],
                                  testlabs = as.character(cur@testLabels))
      })
#     scatterplot3js(x, y, z, pch="o") %>%
#        points3d(x + 0.1, y + 0.1, z, color="red", pch=paste("point", 1:5))

      output$spinner = renderScatterplotThree(  (ans()$obj) %>% points3d(ans()$prmat, labels=ans()$testlabs, color="black" ) )
})
}


plspinDF = function(dataframe, insbwidth=4) {
  stopifnot("cl" %in% colnames(dataframe))
# learner candidates -- bound up with extras for parameters etc.
  learnerTags = c("LDA", "DLDA", "rpart(cp)", "randomForest",
                   "knn1", "nnet(size, decay)") #, "blackboost")
#
  shinyApp(ui = fluidPage(
   fluidRow( column(10, 
      textOutput("title", container=h1)) ),
   #fluidRow( column(2, 
   sidebarLayout(
    sidebarPanel(width=insbwidth,
#
# 3 boxes for data setup
        p(strong(paste0("Data setup for ", deparse(substitute(dataframe))))),
        div(style="display:inline-block",numericInput(inputId="Npoints", label="# points", value = 
                         min(c(300, nrow(dataframe)), min=100, max=nrow(dataframe), step=100))), #),
        div(style="display:inline-block",numericInput(inputId="Nfeat", label="N feat.", value = 
                         3, min=2, max=ncol(dataframe)-1, step=1)), #),
# box for learner method
        div(style="display:block"),
        div(style="display:inline-block",
             selectInput("learner", label = "Learning method:",
               choices = learnerTags,
               selected = "LDA")),
# box for misclassification rate
        div(style="display:block"),
        div(style="display:inline-block",
             strong(em(textOutput("mcl")))), 
        div(style="display:block"),
        br(),
# axis selections (need dim > 3)
        div(style="display:inline-block",
             numericInput("dim1", label = "pc for x",
               value = 1, min=1, max=8, step=1)), #),
        div(style="display:inline-block",
             numericInput("dim2", label = "pc for y",
               value = 2, min=2, max=8, step=1)), #),
        div(style="display:inline-block",
             numericInput("dim3", label = "pc for z",
               value = 3, min=3, max=8, step=1)), # end sidebarPanel  #),
        br(),
# for rendering options
        div(style="display:inline-block",
              selectInput("ngpts",
                         label="grid edge size   ",
                         choices=as.character(4:20),
                         selected="10")),
        div(style="display:inline-block",
             selectInput("renderer", label = "Rendering method:",
               choices = c("auto", "canvas"),
               selected = "auto")), #),
             numericInput("cp", label = "rpart cp:",
               value = .01, min=.01, max=20, step=.01), #),
# two boxes for tuning
             numericInput("nnsize", label = "nnet size:",
               value = 2, min=1, max=10, step=1), #),
             numericInput("nndecay", label = "nnet decay:",
               value = .01, min=0, max=2, step=.01)), #),
#   fluidRow( column(10, 
       mainPanel(
         scatterplotThreeOutput("spinner", height="600px") ) ) ), 
  server = function(input, output, session) {
    requireNamespace("mlbench")
#
# deal with current selections on learner
#
    mod = reactive({
     lr = switch( input$learner,
            "LDA" = ldaI,
            "DLDA" = dldaI,
            "rpart(cp)" = rpartI,
            "randomForest" = randomForestI,
            "knn1" = knnI(),
            "nnet(size, decay)" = nnetI,
#            "blackboost" = blackboostI,
            "bagging" = baggingI )
     extras = switch( input$learner,
            "LDA" = NULL,
            "DLDA" = NULL,
#            "blackboost" = list(family=Multinomial()),
            "rpart(cp)" = list(cp=input$cp),
            "randomForest" = list(importance=TRUE),
            "knn1" = NULL,
            "nnet(size, decay)" = list(size=input$nnsize, decay=input$nndecay, MaxNWts=10000) )
     predExtras = switch( input$learner,
#            "blackboost" = list(type="class"), 
            "nnet(size, decay)" = list(type="class"), 
            "rpart(cp)" = list(type="class"), NULL )

     wrapper = switch( input$learner,
            LDA = function(x) x$class, force )
     list(learner=lr, extras=extras, predExtras=predExtras, predWrapper=wrapper)
     })
#
# build display
#
     ans = reactive({
#
# build dataframe using selections on data parameters
#
       fnames = names(dataframe)
       clid = which(fnames=="cl")
       data = dataframe[seq_len(input$Npoints), unique(fnames[c(seq_len(input$Nfeat), clid)])]
       nrec = nrow(data)
# training indices
       tinds = sample(seq_len(nrow(data)),size=floor(nrow(data)/2),replace=FALSE)
# model call -- need to ensure that 'extras' go into ... for projectLearnerToGrid
       argl = c(list(
                formula=cl~., data=data, learnerSchema=mod()$learner, 
                  trainInd = tinds, ngpts=as.numeric(input$ngpts), 
                  predExtras=mod()$predExtras,
                  predWrapper = mod()$predWrapper), mod()$extras )
       argl = argl[ which(sapply(argl, length)>0) ]
       cur = do.call( projectLearnerToGrid, argl )
       cmat = confuMat(cur@fittedLearner)
       ok = sum(diag(cmat))
       err = sum(cmat) - ok
       output$mcl = renderText( paste0("Test miscl. proportion (random half) = ", round(err/sum(cmat), 2) ) )
       proj = cur@gridFeatsProjectedToTrainingPCs
       projtest = cur@testFeatsProjectedToTrainingPCs
  
       nclass = length(unique(cur@gridPredictions))
#       thecolors = palette(rainbow(nclass))[cur@gridPredictions]
     #  print(table(cur@gridPredictions))
     #  print(class(cur@gridPredictions))
       thecolors = colorRampPalette(RColorBrewer::brewer.pal(8,"Set2"))(nclass)[as.numeric(cur@gridPredictions)]
       labs = as.character(cur@gridPredictions)
       obj = scatterplot3js( x = proj[,as.numeric(input$dim1)], 
               y = proj[,as.numeric(input$dim2)], 
               z = proj[,as.numeric(input$dim3)], 
               color=thecolors, renderer=input$renderer, labels=as.character(labs) )
#       obj$points3d( x = projtest[,as.numeric(input$dim1)], 
#               y = projtest[,as.numeric(input$dim2)], 
#               z = projtest[,as.numeric(input$dim3)], 
#               color="black" , size=2)
       list(obj=obj, prmat=projtest[, c(as.numeric(input$dim1), as.numeric(input$dim2), as.numeric(input$dim3))],
                                  testlabs = as.character(cur@testLabels))
      })
      output$spinner = renderScatterplotThree(  (ans()$obj) %>% points3d(ans()$prmat, labels=ans()$testlabs, color="black" ) )
})
}

# -- localBridge.R -- defines functions in namespaces with 
#    predict methods and formula interfaces when needed
#    currently handles knn, lvq, dlda, RAB (latter fully defined here)
# -- RAB -- renamed to rab to allow old RAB to work

rab = function(formula, data, maxiter=200, maxdepth=1) {
 if (as.character(as.list(formula)[[3]])[1] == ".") stop("please state the formula explicitly, no \".\"")
 theCall = match.call()
 out = list()
 tmpy = model.response(model.frame(formula, data=data))
 if (!is.factor(tmpy)) stop("response vbl must be factor with levels -1, 1")
 tmpy = as.character(tmpy)
 numy = as.numeric(tmpy)
 if (!all(tmpy %in% c("-1","1"))) stop("response must be coded -1, 1")
 N = nrow(data)
 w = rep(1/N, N)
 data = data.frame(data, w=w)
 print("real adaboost iterations:")
 for (i in seq_len(maxiter)) {
    cat(i)
    data$w = w
    tr = rpart(formula, data=data, maxdepth=maxdepth, weights=w)
    p = rpart:::predict.rpart(tr)[,2]
    p[p < .000001] = .000001
    p[p > .999999] = .999999
    f = .5*log(p/(1-p))
    w = w*exp(-numy*f)
    w = w/sum(w)
    out[[i]] = list(tree=tr, weight=w)
    }
res = list(ans=out, formula=formula, call=theCall)
class(res) = "RAB"
res
}

predict.RAB = function( object, ...) {
 logit = function(x) {
     x[x < .000001] = .000001
     x[x > .999999] = .999999
     log(x/(1-x))
     }
 argl = list(...)
 if (length(argl) > 0) {
   newdata = argl[["newdata"]]
   ans = lapply(object$ans, function(x) rpart:::predict.rpart(x$tree, newdata)) # why??
 }
 else ans = lapply(object$ans, function(x) rpart:::predict.rpart(x$tree))
 if (length(dim(ans[[1]])) == 2) newf = lapply(ans, function(x) .5*logit(x[,2]))
 else newf = lapply(ans, function(x) .5*logit(x[2]))
 addf = newf[[1]]
 for (i in 2:length(newf)) addf = addf+newf[[i]]
 factor(ifelse(addf>0, 1, -1))
}


# -- knn

knn2 = function (formula, data, ...) 
{
    mf = model.frame(formula, data)
    cl = model.response(mf)
    x = mf[, -1]
    ans = class::knn(x, x, cl, prob=TRUE, ...)
    ans = list(traindat = x, ans = ans, traincl = cl)
    class(ans) = "knn2"
    ans
}

predict.knn2 = function(object, newdata, ...) {
 class::knn( object$traindat, newdata, object$traincl , prob=TRUE, ... )
}

# -- knn.cv

knn.cv2 = function (formula, data, ...) 
{
    mf = model.frame(formula, data)
    cl = model.response(mf)
    x = mf[, -1]
    ans = class::knn.cv( x, cl, prob=TRUE, ...)
    ans = list(traindat = x, ans = ans, traincl = cl)
    class(ans) = "knn.cv2"
    ans
}

predict.knn.cv2 = function(object, newdata, ...) {
 class::knn.cv( newdata, object$traincl , prob=TRUE, ... )
}

# -- lvq

lvq = function(formula, data, ...) {
 mf = model.frame(formula, data)
 cl = model.response(mf)
 x = mf[,-1]
 cb1 = class::lvqinit(x, cl, ...)
 cb1 = class::olvq1(x, cl, cb1 )
 ans = list(traindat=x, ans=cb1, traincl=cl)
 class(ans) = "lvq"
 ans
}


predict.lvq = function(object, newdata, ...) {
 class::lvqtest(object$ans, newdata)
} 

# -- dlda

dlda2 = function (formula, data, ...) 
{
    mf = model.frame(formula, data)
    cl = model.response(mf)
    x = mf[, -1]
    ## require(sfsmisc)
# deal with global visibility
    ans = sfsmisc::diagDA(x, as.numeric(cl), x, ...) # not a list any more!
    ans = list(traindat = x, ans = ans, traincl = cl)
    class(ans) = "dlda2"
    ans
}

predict.dlda2 = function(object, newdata, ...) {
## require(sfsmisc)
# deal with global visibility
 sfsmisc::diagDA( object$traindat, as.numeric(object$traincl), newdata, ... )
}

# # -- rdacvML -- bridges to rda::rda.cv which requires a run of rda
# 
# rdaCV = function( formula, data, ... ) {
#  if (!requireNamespace("rda")) stop("install package rda to use this function")
#  passed = list(...)
#  if ("genelist" %in% names(passed)) stop("please don't supply genelist parameter.")
#  # data input to rda needs to be GxN
#  x = model.matrix(formula, data)
#  if ("(Intercept)" %in% colnames(x))
#    x = x[, -which(colnames(x) %in% "(Intercept)")]
#  x = t(x)
#  mf = model.frame(formula, data)
#  resp = as.numeric(factor(model.response(mf)))
#  run1 = rda::rda( x, resp, ... )
#  rda::rda.cv( run1, x, resp )
# }
# 
# rdaFixed = function( formula, data, alpha, delta, ... ) {
#  if (!requireNamespace("rda")) stop("install package rda to use this function")
#  passed = list(...)
#  if ("genelist" %in% names(passed)) stop("please don't supply genelist parameter.")
#  # data input to rda needs to be GxN
#  x = model.matrix(formula, data)
#  if ("(Intercept)" %in% colnames(x))
#    x = x[, -which(colnames(x) %in% "(Intercept)")]
#  x = t(x)
#  featureNames = rownames(x)
#  mf = model.frame(formula, data)
#  resp = as.numeric(resp.fac <- factor(model.response(mf)))
#  finalFit=rda::rda( x, resp, genelist=TRUE, alpha=alpha, delta=delta, ... )
#  list(finalFit=finalFit, x=x, resp.num=resp, resp.fac=resp.fac, featureNames=featureNames,
#     keptFeatures=featureNames[ which(apply(finalFit$gene.list,3,function(x)x)==1) ])
# }
# 
# rdacvML = function(formula, data, ...) {
#  if (!requireNamespace("rda")) stop("install package rda to use this function")
#  run1 = rdaCV( formula, data, ... )
#  perf.1se = cverrs(run1)$one.se.pos
#  del2keep = which.max(perf.1se[,2])
#  parms2keep = perf.1se[del2keep,]
#  alp = run1$alpha[parms2keep[1]]
#  del = run1$delta[parms2keep[2]]
#  fit = rdaFixed( formula, data, alpha=alp, delta=del, ... )
#  class(fit) = "rdacvML"
#  attr(fit, "xvalAns") = run1
#  fit
# }
# 
# rdaML = function(formula, data, ...) {
#  if (!requireNamespace("rda")) stop("install package rda to use this function")
#  dots = list(...)
#  nd = names(dots)
#  if (!(all(c("alpha", "delta") %in% nd))) stop("alpha and delta must be supplied with rdaI")
#  fit = rdaFixed( formula, data, ... )
#  class(fit) = "rdaML"
#  fit
# }
# 
# print.rdaML = function(x, ...) {
#  cat("rdaML S3 instance. components:\n")
#  print(names(x))
# }
# 
# print.rdacvML = function(x, ...) {
#  cat("rdacvML S3 instance. components:\n")
#  print(names(x))
#  cat("---\n")
#  cat("elements of finalFit:\n")
#  print(names(x$finalFit))
#  cat("---\n") 
#  cat("the rda.cv result is in the xvalAns attribute of the main object.\n")
# }
# 
# rda.xvalAns = function(cfo) {
#  if (!is(cfo, "classifierOutput")) stop("works for classifierOutput instance from MLearn/rdacvI")
#  attr( RObject(cfo), "xvalAns" )
# }
# 
# plotXvalRDA = function(cfo, ...) {
#  if (!is(cfo, "classifierOutput")) stop("works for classifierOutput instance from MLearn/rdacvI")
#  plot( rda.xvalAns(cfo), ... )
# }
# 
# predict.rdacvML = function(object, newdata, ...) {
#  if (!requireNamespace("rda")) stop("install package rda to use this function")
#  newd = data.matrix(newdata)
#  fnames = rownames(object$x)
#  newd = newd[, fnames]
#  if (any(dim(newd) == 0))
#      inds =predict(object$finalFit, object$x, object$resp.num, xnew=object$x)
#  else inds = try(predict(object$finalFit, object$x, object$resp.num, xnew=t(newd)))
#  factor(levels(object$resp.fac)[inds])
# }
# 
# predict.rdaML = function(object, newdata, ...) {
#  if (!requireNamespace("rda")) stop("install package rda to use this function")
#  newd = data.matrix(newdata)
#  fnames = rownames(object$x)
#  newd = newd[, fnames]
#  if (any(dim(newd) == 0))
#      inds =predict(object$finalFit, object$x, object$resp.num, xnew=object$x)
#  else inds = try(predict(object$finalFit, object$x, object$resp.num, xnew=t(newd)))
#  factor(levels(object$resp.fac)[inds])
# }
# 
# 

cverrs = function (x, type = c("both", "error", "gene"), nice = FALSE, 
    ...) 
{
    if (class(x) != "rdacv") {
        stop("You must supply a cross-validation object.")
    }
    else {
        minerr <- min(x$cv.err)/x$n
        one.se <- ceiling((sqrt(minerr * (1 - minerr)/x$n) * 
            1.645 + minerr) * x$n)
        pos <- which(x$cv.err == one.se, TRUE)
        minpos <- which(x$cv.err == min(x$cv.err), TRUE)
        tmperr <- x$cv.err
        dimnames(tmperr) <- list(x$alpha, x$delta)
        tmpgene <- x$ngene
        dimnames(tmpgene) <- list(x$alpha, x$delta)
        return(list(one.se.pos = pos, min.cv.pos = minpos))
    }
}

# -- logitboost
#logitboost2 = function (formula, data, ...) 
#{
#    require(boost, quietly=TRUE)
#    mf = model.frame(formula, data)
#    cl = model.response(mf)
#    cll = levels(cl)
#    cl = 1*(cl==levels(cl)[1])
#    x = data.matrix(mf[, -1])
#    ans = boost::logitboost(x, cl, x, ...)
#    ans = list(traindat = data.matrix(x), ans = ans, traincl = cl,
#       cll=cll)
#    class(ans) = "logitboost2"
#    ans
#}

#predict.logitboost2 = function(object, newdata, ...) {
# require(boost, quietly=TRUE)
# cllev = object$cll
# vars = colnames(object$traindat)
# newdata = newdata[,vars,drop=FALSE]
# app = boost::logitboost( object$traindat, object$traincl,  data.matrix(newdata), ... )
# tmp = apply(app, 1, function(x)1*(mean(x>=.5)>=.5))
# factor(ifelse(tmp==1, cllev[1], cllev[2]))
#}

## gbm -- the problem here is that it cannot use a factor as dependent
## variable, and only returns numeric predictions -- unusual for classification procedures

# our solution -- continue to require user to supply a factor reponse variable
# but coerce it to 0-1 setting first level of response to zero and second to one
# then call gbm

gbm2 = function(formula, data, ...) {
 requireNamespace("gbm") #, quietly=TRUE)
 mf = model.frame(formula, data)
 resp = model.response(mf)
 if (!is(resp, "factor")) stop("dependent variable must be a factor in MLearn")
 if (length(levels(resp)) !=2 ) stop("dependent variable must have two levels")
 nresp = as.numeric(resp == levels(resp)[2])
 fwn = formula
 fwn[[2]] = as.name("nresp")
 newf = as.formula(fwn)
 data$nresp = nresp
 ans = gbm( newf, data=data, ... )
 class(ans) = "gbm2"
 ans
}
 
# now we need a suitable prediction method.  we know predict.gbm will only return
#  a numeric vector.  so just hand it back as a factor; to make sense of it
#  need to use as.numeric(as.character())

predict.gbm2 = function(object, newdata, ...) {
 requireNamespace("gbm") #, quietly=TRUE)
 ans = predict.gbm(object, newdata, ...)
 factor(ans)
}

svm2 <- function (formula, 
                  data, ## training data (prepared in MLearn)
                  probability=TRUE, ## to use probabilities as test|trainScores
                  ...   ## other args for svm
                  ) {
  e1071::svm(formula, data, probability=probability, ...)
}

ksvm2 <- function (formula, 
                  data, ## training data (prepared in MLearn)
                  prob.model=TRUE, ## to use probabilities as test|trainScores
                  ...   ## other args for ksvm
                  ) {
  kernlab::ksvm(formula, data, prob.model=prob.model, ...)
}

plsda2 <- function (formula, 
                    data, ## training data (prepared in MLearn)
                    probMethod="Bayes", ## using bayes rule to form posterior probs (default in caret::plsda is 'softmax')
                    ncomp=2,    ## as in caret::plsda
                    prior=NULL, ## as in caret::plsda
                    ...   ## other args for plsr
                    ) {
  mf <- model.frame(formula, data)
  cl <- factor(model.response(mf))
#  x <- mf[, -1]
  ans <- caret::plsda(x, cl,
                      probMethod=probMethod,
                      ncomp=ncomp,
                      prior=prior, ...)    
  ##class(ans) <- "plsda2" ## only required to define a plsda2.predict method
  return(ans)
}

standardMLIConverter = function(obj, data, trainInd) {
# use when the predict method directly returns factor-like predictions
# otherwise, need to define a special converter
   teData = data[-trainInd,]
   trData = data[trainInd,]
   tepr = predict(obj, teData)
   trpr = predict(obj, trData)
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput", testPredictions=factor(tepr),
       trainPredictions=factor(trpr), RObject=obj)
   }

MLIConverter.knn = function(k=1, l=0) function(obj, data, trainInd) {
   kpn = names(obj$traindat)
   teData = data[-trainInd,kpn] # key distinction -- typical predict methods allow
   trData = data[trainInd,kpn]  # variables in newdata to be superset of those in formula, not knn
   tepr = predict(obj, teData, k, l) # our special predict.knn2
   trpr = predict(obj, trData, k, l)
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput",
       testPredictions=factor(tepr),
       testScores=attr(tepr, "prob"),
       trainPredictions=factor(trpr),
       trainScores=attr(trpr, "prob"),
       RObject=obj)
 }

MLIConverter.dlda = function(obj, data, trainInd) {
   kpn = names(obj$traindat)
   outcoLev = levels(obj$traincl) # fragile
   teData = data[-trainInd,kpn] # key distinction -- typical predict methods allow
   trData = data[trainInd,kpn]  # variables in newdata to be superset of those in formula, not knn
   tepr = outcoLev[predict(obj, teData)]
   trpr = outcoLev[predict(obj, trData)]
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput", testPredictions=factor(tepr),
       trainPredictions=factor(trpr), RObject=obj)
   }

MLIConverterPredType.class = function(obj, data, trainInd) {
   teData = data[-trainInd,]
   trData = data[trainInd,]
   tepr = predict(obj, teData, type="class")
   trpr = predict(obj, trData, type="class")
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput", testPredictions=factor(tepr),
       trainPredictions=factor(trpr), RObject=obj)
   }

MLIConverterListEl.class = function(obj, data, trainInd) {
   teData = data[-trainInd,]
   trData = data[trainInd,]
   tepr = predict(obj, teData)$class
   trpr = predict(obj, trData)$class
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput", testPredictions=factor(tepr),
       trainPredictions=factor(trpr), RObject=obj)
   }

MLIConverter.svm = function(obj, data, trainInd) { # decision.values parm needed
#    browser()
  teData = data[-trainInd,]
  trData = data[trainInd,]
  ##tepr = predict(obj, teData, decision.values=FALSE)
  ##trpr = predict(obj, trData, decision.values=FALSE)
  ## From ?svn: The center and scale values are returned and used for later predictions.
  tepr = predict(obj, teData, decision.values=TRUE, probability=TRUE)
  trpr = predict(obj, trData, decision.values=TRUE, probability=TRUE)
  ## names(tepr) = rownames(teData)
  ## names(trpr) = rownames(trData)
  new("classifierOutput",
      testPredictions =factor(tepr[seq_len(length(tepr))]),
      trainPredictions=factor(trpr[seq_len(length(trpr))]),
      testScores=attr(tepr,"probabilities"),
      trainScores=attr(trpr,"probabilities"),
      RObject=obj)
}

MLIConverter.ksvm <- function(obj, data, trainInd) {
  teData <- data[-trainInd,]
  trData <- data[trainInd,]
  requireNamespace("kernlab")
  teprob <- kernlab::predict(obj, teData, type="probabilities")
  rownames(teprob) <- rownames(teData)
  trprob <- kernlab::predict(obj, trData, type="probabilities")
  rownames(trprob) <- rownames(trData)
  tepred <- kernlab::predict(obj, teData, type="response")
  trpred <- kernlab::predict(obj, trData, type="response")
  new("classifierOutput",
      testPredictions =factor(tepred),
      trainPredictions=factor(trpred),
      testScores=teprob,
      trainScores=trprob,
      RObject=obj)
}

MLIConverter.ldaPredMeth = function(method) function(obj, data, trainInd) { # get binding for method to predict
   teData = data[-trainInd,]                                              # at call time
   trData = data[trainInd,]
   tepr = predict(obj, teData, method=method)$class
   trpr = predict(obj, trData, method=method)$class
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput", testPredictions=factor(tepr),
       trainPredictions=factor(trpr), RObject=obj)
   }

MLIConverter.logistic = function(threshold) function(obj, data, trainInd) {
   teData = data[-trainInd,]
   trData = data[trainInd,]
   tepr = 1*(predict(obj, teData, type="response") > threshold)
   trpr = 1*(predict(obj, trData, type="response") > threshold)
# from Jason Vertrees, to restore codes for levels of response
    dDf <- model.frame(obj, data)
    dRs <- model.response(dDf)
#    # Why not try the following?
#    # This just makes a decision -- as we do above that everything on one
#    # side of the threshold is class1 else class2.  Is this valid?
   tepr <- as.factor(levels(dRs)[as.integer(tepr)+1])
   trpr <- as.factor(levels(dRs)[as.integer(trpr)+1])
   tesco = predict(obj, teData, type="response")
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   names(tesco) = rownames(teData)
   new("classifierOutput", testPredictions=factor(tepr), testScores=tesco,
       trainPredictions=factor(trpr), RObject=obj)
   }

MLIConverter.rpart = function(obj, data, trainInd) { # decision.values parm needed
   teData = data[-trainInd,]
   trData = data[trainInd,]
   tepr = predict(obj, teData, type="class")
   trpr = predict(obj, trData, type="class")
   teprob = predict(obj, teData, type="prob")
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   names(teprob) = rownames(teData)
   new("classifierOutput", testPredictions=factor(tepr), testScores=teprob, testOutcomes=factor(),
       trainPredictions=factor(trpr), RObject=obj)
   }


MLIConverter.nnet = function(obj, data, trainInd) {
   teData = data[-trainInd,]
   trData = data[trainInd,]
   tepr = predict(obj, teData, type="class")
   trpr = predict(obj, trData, type="class")
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput",
       testPredictions=factor(tepr),
       testScores=predict(obj,teData),
       trainScores=predict(obj,trData),
       trainPredictions=factor(trpr),
       RObject=obj)
   }

MLIConverter.RAB = function(obj, data, trainInd) {
# use when the predict method directly returns factor-like predictions
# otherwise, need to define a special converter
   teData = data[-trainInd,]
   trData = data[trainInd,]
   tepr = predict(obj, newdata=teData)
   trpr = predict(obj, newdata=trData)
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput", testPredictions=factor(tepr),
       trainPredictions=factor(trpr), RObject=obj)
   }

MLIConverter.naiveBayes = function(obj, data, trainInd) {
   kpn = names(obj$tables)
   teData = data[-trainInd,kpn,drop=FALSE] # key distinction -- typical predict methods allow
   trData = data[trainInd,kpn,drop=FALSE]  # variables in newdata to be superset of those in formula, not allowed here
   tepr = predict(obj, teData, type="class")
   trpr = predict(obj, trData, type="class")
   tesc <- predict(obj, teData, type="raw")
   trsc <- predict(obj, trData, type="raw")
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput",
       testPredictions=factor(tepr),
       trainPredictions=factor(trpr),
       trainScores=trsc,
       testScores=tesc,
       RObject=obj)
   }

MLIConverter.selftesting = function(obj, data, trainInd) {
   tepr = predict(obj, data)
   names(tepr) = rownames(data)
   new("classifierOutput", testPredictions=factor(tepr),
       trainPredictions=factor(tepr), RObject=obj)
   }

MLIConverter.slda = function(obj, data, trainInd) { # decision.values parm needed
   teData = data[-trainInd,]
   trData = data[trainInd,]
   teprFull = predict(obj, teData)
   trprFull = predict(obj, trData)
   tepr = teprFull$class
   trpr = trprFull$class
   teprob = predict(obj, teData, type="prob")
   trprob = predict(obj, trData, type="prob")
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   names(teprob[[1]]) = rownames(teData)
   rownames(teprob[[2]]) = rownames(teData)
   names(teprob[[3]]) = rownames(teData)
   names(trprob[[1]]) = rownames(trData)
   rownames(trprob[[2]]) = rownames(trData)
   names(trprob[[3]]) = rownames(trData)
   new("classifierOutput", testPredictions=factor(tepr), testScores=teprob[[2]],
       trainPredictions=factor(tepr), trainScores=trprob[[2]], RObject=obj)
   }

MLIConverter.knncv = function(k=1, l=0) function(obj, data, trainInd) {
#
# it is assumed that there is no train/test distinction --
# the CV is embedded LOO, so all predictions are test predictions
#
   kpn = names(obj$traindat)  # name is somewhat misleading but OK
   trData = data[trainInd,kpn]  # must be sure trData just has vbls in fmla
   trpr = predict(obj, trData, k, l)
   names(trpr) = rownames(trData)
   new("classifierOutput", testPredictions=factor(trpr), testScores=attr(trpr, "prob"),
       trainPredictions=factor(), RObject=obj, embeddedCV=TRUE)
   }

## for unsupervised case all converters are of form
## obj [RObject], dstruct [distance structure or raw data for kmeans],
## ... for functions requiring additional data, like cutree, which takes
## k or h
#
#hclustConverter = function(obj, dstruct, ...) {
#   part = stats::cutree(obj, ...)
#   sil = silhouette(part, dstruct)
#   new("clusteringOutput", partition=part, silhouette=sil, RObject=obj)
#}
#
#kmeansConverter = function(obj, dstruct, ...) {
#   part = obj$clust
#   sil = silhouette(part, dist(dstruct))
#   new("clusteringOutput", partition=part, silhouette=sil, RObject=obj)
#}
#
#pamConverter = function(obj, dstruct, ...) {
#   part = obj$clustering
#   sil = silhouette(part, dist(dstruct))
#   new("clusteringOutput", partition=part, silhouette=sil, RObject=obj)
#}

MLIConverter.Bgbm = function(n.trees.pred=1000, thresh=.5) function(obj, data, trainInd) {
   anac = function(x) as.numeric(as.character(x))
   teData = data[-trainInd,] # key distinction -- typical predict methods allow
   trData = data[trainInd,]  # variables in newdata to be superset of those in formula, not gbm
   tepr = predict(obj, teData, n.trees=n.trees.pred) # our special predict.gbm2
   trpr = predict(obj, trData, n.trees=n.trees.pred)
   tesco = anac(tepr)
   tepr = anac(tepr) > thresh
   trpr = anac(trpr) > thresh
   names(tepr) = rownames(teData)
   names(trpr) = rownames(trData)
   new("classifierOutput", testPredictions=factor(tepr), testScores=tesco,
       trainPredictions=factor(trpr), RObject=obj)
   }

MLIConverter.blackboost = function (obj, data, trainInd)
{
    teData = data[-trainInd, ]
    trData = data[trainInd, ]
    tepr = predict(obj, teData, type="class")
    trpr = predict(obj, trData, type="class")
    names(tepr) = rownames(teData)
    names(trpr) = rownames(trData)
    new("classifierOutput", testPredictions = factor(tepr), trainPredictions = factor(trpr),
        RObject = obj)
}

MLIConverter.randomForest = function (obj, data, trainInd) {
    teData = data[-trainInd, ]
    trData = data[trainInd, ]
    tepr = predict(obj, teData, type="response")
    tesco = predict(obj, teData, type="prob")
    trpr = predict(obj, trData, type="response")
    trsco = predict(obj, trData, type="prob")
    names(tepr) = rownames(teData)
    names(trpr) = rownames(trData)
    new("classifierOutput",
        testPredictions = factor(tepr),
        testScores = tesco,
        trainPredictions = factor(trpr),
        trainScores = trsco,
        RObject = obj)
}


MLIConverter.plsda <- function(obj, data, trainInd) {
  rhs <- colnames(obj$model$x)
  trData <- data[ trainInd,rhs]
  teData <- data[-trainInd,rhs]
  tePredProb <- predict(obj,teData,type="prob")
  if (inherits(tePredProb, "array") & dim(tePredProb)[3] == 1)
    tePredProb <- tePredProb[, , 1]
  tePredClass <- predict(obj,teData,type="class")
  names(tePredClass) <- rownames(teData)
  trPredProb <- predict(obj,trData,type="prob")
  if (inherits(trPredProb, "array") & dim(trPredProb)[3] == 1)
    trPredProb <- trPredProb[, , 1]
  trPredClass <- predict(obj,trData,type="class")
  names(trPredClass) <- rownames(trData)
  new("classifierOutput",
      testPredictions = tePredClass,
      testScores = tePredProb,
      trainPredictions = trPredClass,
      trainScores = trPredProb,
      RObject = obj)
}

##PLEASE PUT THE CLASSES FIRST!!!! THEN THE METHODS
#
# the class structure has been changed.  labels and scores
# are fundamental and can have different structures for
# different procedures.  so
# virual classes are defined with specializations to
#   a) class labels (as in classification outputs) vs
#       group indices (as in clustering outputs)
#   b) probability matrices (as with nnet predict) vs
#       vector scores (as in knn voting proportions)
#
#


setOldClass("dist")
setClass("MLLabel", "VIRTUAL")
setClass("predClass", contains=c("MLLabel", "character", "factor"),
	prototype=prototype(""))
setClass("groupIndex", contains=c("MLLabel", "integer"),
	prototype=prototype(integer(0)))
newPredClass <- function(x) new("predClass", x)
newGroupIndex <- function(x) new("groupIndex", x)

setClass("MLScore", "VIRTUAL")
setClass("probMat", contains=c("MLScore", "matrix"))
setClass("probArray", contains=c("MLScore", "array"))
setClass("membMat", contains=c("MLScore", "matrix"))
setClass("qualScore", contains=c("MLScore", "numeric"))
setClass("silhouetteVec", contains=c("MLScore", "numeric"))
newProbMat <- function(x) if(length(x)>0)new("probMat", x) else new("probMat")
newProbArray <- function(x) if(length(x)>0)new("probArray", x) else new("probArray")
newMembMat <- function(x) if(length(x)>0)new("membMat", x) else new("membMat")
newQualScore <- function(x) if(length(x)>0)new("qualScore", x) else new("qualScore")
newSilhouetteVec <- function(x) if(length(x)>0)new("silhouetteVec", x) else new("silhouetteVec")

setClass("MLOutput", representation(method="character",
			RObject="ANY", call="call", distMat="dist"), "VIRTUAL")

setClass("classifOutput", representation(
	predLabels="MLLabel", predScores="MLScore", predLabelsTr="MLLabel",
	trainInds="integer", allClass="character"), contains="MLOutput",
		prototype=prototype(method="", RObject=NULL,
			call=new("call"), distMat=dist(0), 
			allClass=character(0), trainInds=integer(0),
			predLabels=newPredClass(character(0)),
			predLabelsTr=newPredClass(character(0)),
			predScores=newQualScore(numeric(0))))

setClass("clustOutput", representation(
	clustIndices="MLLabel", clustScores="MLScore"), contains="MLOutput",
		prototype=prototype(method="", RObject=NULL,
			call=new("call"), distMat=dist(0),
			clustIndices=newGroupIndex(integer(0)),
			clustScores=newSilhouetteVec(numeric(0))))

########################################################

setMethod("show", "probMat", function(object) {
	if (length(object)>0) {
		cat("summary of class membership probabilities:\n")
		print(apply(object,2,summary))
	}
})
setMethod("show", "probArray", function(object) {
	cat("dimensions of (threshold-based) class membership probabilities:\n")
	print(dim(object))
})
setMethod("show", "membMat", function(object) {
	cat("summary of cluster membership scores:\n")
	print(apply(object,2,summary))
})
setMethod("show", "qualScore", function(object) {
   if (length(object)>0)
	{
	cat("summary of class assignment quality scores:\n")
	print(summary(object))
        }
   else invisible(NULL)
})
setMethod("show", "silhouetteVec", function(object) {
	cat("summary of clustering silhouette values:\n")
	print(summary(object))
})

#
# the base output representation class now just knows
# about the MLLabel and MLScore output classes,
# but now retains call, fitted model object, and dist
#
setGeneric("RObject", function(obj) standardGeneric("RObject"))
setMethod("RObject", "MLOutput", function(obj) obj@RObject)
setGeneric("distMat", function(obj) standardGeneric("distMat"))
setMethod("distMat", "MLOutput", function(obj) obj@distMat)



setMethod("show", "MLOutput", function(object) {
	cat("MLOutput instance, method=", object@method, "\n")
	if (object@method == "nnet")
		print(object@RObject)
	if (length(object@call)>0) {cat("Call:\n "); print (object@call)}
        if (is(object, "classifOutput") && length(object@predLabels)>0) {
		cat("predicted class distribution:")
		print(table(object@predLabels))
		show(object@predScores)
	}
        else if (is(object, "clustOutput") && length(object@clustIndices)>0) {
		cat("predicted cluster size distribution:")
		print(table(object@clustIndices))
		show(object@clustScores)
	}
})

setGeneric("predLabels", function(obj) standardGeneric("predLabels"))
setMethod("predLabels", "MLOutput", function(obj) obj@predLabels@.Data)
setGeneric("predLabelsTr", function(obj) standardGeneric("predLabelsTr"))
setMethod("predLabelsTr", "MLOutput", function(obj) obj@predLabelsTr@.Data)
setGeneric("predLabels", function(obj) standardGeneric("predLabels"))
setMethod("predLabels", "classifOutput", function(obj) obj@predLabels@.Data)
setGeneric("predLabelsTr", function(obj) standardGeneric("predLabelsTr"))
setMethod("predLabelsTr", "classifOutput", function(obj) obj@predLabelsTr@.Data)
setGeneric("allClass", function(obj) standardGeneric("allClass"))
setMethod("allClass", "classifOutput", function(obj) obj@allClass)
setGeneric("trainInds", function(obj) standardGeneric("trainInds"))
setMethod("trainInds", "classifOutput", function(obj) obj@trainInds)
setGeneric("confuMat", function(obj) standardGeneric("confuMat"))
setMethod("confuMat", "classifOutput", function(obj) 
table(given=allClass(obj)[-trainInds(obj)], predicted=predLabels(obj) ) )
setGeneric("confuMatTrain", function(obj) standardGeneric("confuMatTrain"))
setMethod("confuMatTrain", "classifOutput", function(obj) {
acal = function(x) as.character(as.list(x))
maker = acal(obj@call) # test for MLearn origin
if (maker[1] != "MLearn") stop("confuMatTrain only applicable to outputs of MLearn interface.  See help(MLearn).")
table(given=allClass(obj)[trainInds(obj)], predicted=predLabelsTr(obj) ) 
 })

setOldClass("knnP")
setOldClass("nnet.formula")
setOldClass("diana")
setOldClass("agnes")
setOldClass("pam")
setOldClass("rpart")
setOldClass("svm")
setOldClass("bclust")
setOldClass("fclust")
setOldClass("cshell")
setOldClass("ica")
setOldClass("lca")
setOldClass("naiveBayes")
setOldClass("pamr")
setOldClass("randomForest")
setOldClass("hclust")
setOldClass("kmeans")
setOldClass("prcomp")
setOldClass("classbagg")
setOldClass("bagging")
setOldClass("ipredknn")
setOldClass("slda")
setOldClass("lda")
setOldClass("qda")
setOldClass("nsc")
setOldClass("gbm")
setOldClass("logitboost")

knnP <- function(train, test, cl, k=1, l=0, prob=FALSE, use.all=TRUE) {
#
# idea here is to allow knn to work with predict method using new data.
# create a closure that knows about the training data, and later evaluate
# it on any conforming test data
#
# october 25 -- seem to need to use name newdata
# for this to work with generic prediction
#
 ans <- class::knn(train,test,cl,k,l,prob,use.all)
 nf <- function(train,cl,k,l,prob,use.all) function(newdata)
	 class::knn(train,newdata,cl,k,l,prob,use.all)
 attr(ans, "predfun") <- nf(train,cl,k,l,prob,use.all)
 class(ans) <- c("knnP", "factor")
 ans
}

predict.knnP <- function(object, ...) 
	attr(object, "predfun")(...)

print.knnP <- function(x, ...)
	{
	cat("instance of knnP [predictable knn object]\n")
	NextMethod()
	}

setGeneric("knnB", function(exprObj, classifLab, trainInd, 
		k=1, l=1, prob=TRUE, use.all=TRUE, metric="euclidean"){
			standardGeneric("knnB")
		})

setMethod("knnB", c("ExpressionSet", "character", "integer", 
			"ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, classifLab, trainInd, k, l, 
			prob, use.all, metric){

		cl <- pData(exprObj)[[classifLab]][trainInd]				
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])
		dis <- dist(testDat, method=metric)
		out <- knnP(trainDat, testDat, cl, k, l, prob, use.all)
                new("classifOutput", method="knn", 
			predLabels=newPredClass(as.character(out)), 
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
			predScores=newQualScore(attr(out,"prob")),
                        RObject=out, call=match.call(), distMat=dis)
                                                                                
})


#####################
# title: knn.cvB
# description: interface to knn.cv {class}
# arguments:
#	exprObj		ExpressionSet
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classif2Output"
# example:
# knn.cvOut <- knn.cvB(golubMerge[101:140,], "ALL.AML")
####################

#setGeneric("knn.cvB", function(exprObj, classifLab, trainInd=NULL, k=1, l=1, prob=TRUE, use.all=TRUE, metric="euclidean"){
#		standardGeneric("knn.cvB")
#})
#
#setMethod("knn.cvB", c("ExpressionSet", "character", "ANY", "ANY", "ANY", "ANY", "ANY"), 
#			function(exprObj, classifLab, trainInd=NULL, k, l, prob, use.all, metric){
#			if (!is.null(trainInd)) warning("disregarding trainInd for knn.cvB")
#			cl <- pData(exprObj)[[classifLab]]
#			dat <- t(exprs(exprObj))
#			dis <- dist(dat, method=metric)
#			out <- class::knn.cv(dat, cl, k, l, prob, use.all)
#                new("classifOutput", method="knn.cv", 
##			predLabels=newPredClass(as.character(out)), 
#			trainInds=integer(0), allClass=as.character(pData(exprObj)[[classifLab]]),
#			predScores=newQualScore(attr(out,"prob")),
#                        RObject=out, call=match.call(), distMat=dis)
#})

#####################
# title: knn1B
# description: interface to knn1 {class}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classif1Output"
# example:
# train <- c(sample(1:47, 21), sample(48:72, 12))
# knn1Out <- knn1B(golubMerge[100:200,], "ALL.AML", train)
####################

setGeneric("knn1B", function(exprObj, classifLab, trainInd, metric="euclidean"){
		standardGeneric("knn1B")
})

setMethod("knn1B", c("ExpressionSet", "character", "integer", "ANY"), 
		function(exprObj, trainInd, classifLab, metric){
				
		cl <- pData(exprObj)[[classifLab]][trainInd]
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])
		dis <- dist(testDat, method=metric)
		out <- class::knn1(trainDat, testDat, cl)
                new("classifOutput", method="knn1", 
			predLabels=newPredClass(as.character(out)), 
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
			predScores=newQualScore(attr(out,"prob")),
                        RObject=out, call=match.call(), distMat=dis)
})

#####################
# title: lvq1B
# description: interface to lvq1 {class}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 21), sample(48:72, 12))
# lvq1Out <- lvq1B(golubMerge[100:200,], "ALL.AML", train)
####################

setGeneric("lvq1B", function(exprObj, classifLab, trainInd, size, prior, k=5, niter, alpha=0.03, metric="euclidean"){
		standardGeneric("lvq1B")
})

setMethod("lvq1B", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"), 
		function(exprObj, classifLab, trainInd, size, prior, k, niter, alpha, metric){

		if(missing(size)){ size <- NULL }
		cl <- pData(exprObj)[[classifLab]][trainInd]
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])
		dis <- dist(testDat, method=metric)

		cbkInit <- class::lvqinit(trainDat, cl, size=size, prior=prior, k=k)
		if(missing(niter)){ niter <- 100 * nrow(cbkInit$x) } 
		cbkTrain <- class::lvq1(trainDat, cl, cbkInit, niter=niter)
		out <- class::lvqtest(cbkTrain, testDat)
                new("classifOutput", method="lvq1", 
			predLabels=newPredClass(as.character(out)), 
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
			#predScores=newQualScore(attr(out,"prob")),
                        RObject=cbkTrain, call=match.call(), distMat=dis)
})	

#####################
# title: lvq2B
# description: interface to lvq2 {class}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 21), sample(48:72, 12))
# lvq2Out <- lvq2B(golubMerge[100:200,], "ALL.AML", train)
####################

setGeneric("lvq2B", function(exprObj, classifLab, trainInd, size, 
		prior, k=5, niter, alpha=0.03, win=0.3, metric="euclidean"){
		standardGeneric("lvq2B")
})

setMethod("lvq2B", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", 
		"ANY", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, size, prior, k, 
			niter, alpha, win, metric){

		if(missing(size)){ size <- NULL }
		cl <- pData(exprObj)[[classifLab]][trainInd]
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])
		dis <- dist(testDat, method=metric)
		cbkInit <- class::lvqinit(trainDat, cl, size=size, 
					prior=prior, k=k)
		if(missing(niter)){ niter <- 100 * nrow(cbkInit$x) } 
		cbkTrain <- class::lvq2(trainDat, cl, cbkInit, niter=niter, 										alpha=alpha, win=win)
		out <- class::lvqtest(cbkTrain, testDat)
                new("classifOutput", method="lvq2", 
			predLabels=newPredClass(as.character(out)), 
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
			predScores=newQualScore(attr(out,"prob")),
                        RObject=cbkTrain, call=match.call(), distMat=dis)
	
})	

#####################
# title: lvq3B
# description: interface to lvq3 {class}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 21), sample(48:72, 12))
# lvq3Out <- lvq3B(golubMerge[100:200,], "ALL.AML", train)
####################

setGeneric("lvq3B", function(exprObj, classifLab, trainInd, size, prior, k=5, 
		niter, alpha=0.03, win=0.3, epsilon=0.1, metric="euclidean"){
		standardGeneric("lvq3B")
})

setMethod("lvq3B", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, size, prior, k, niter, alpha, win, epsilon, metric){

		if(missing(size)){ size <- NULL }
		cl <- pData(exprObj)[[classifLab]][trainInd]			
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])	
		dis <- dist(testDat, method=metric)
		cbkInit <- class::lvqinit(trainDat, cl, size=size, prior=prior, k=k)
		if(missing(niter)){ niter <- 100 * nrow(cbkInit$x) } 
		cbkTrain <- class::lvq3(trainDat, cl, cbkInit, niter=niter, alpha=alpha, 
					win=win, epsilon=epsilon)
		out <- class::lvqtest(cbkTrain, testDat)
                new("classifOutput", method="lvq3", 
			predLabels=newPredClass(as.character(out)), 
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
			predScores=newQualScore(attr(out,"prob")),
                        RObject=cbkTrain, call=match.call(), distMat=dis)
	
})	

#####################
# title: olvq1B
# description: interface to olvq1 {class}
# arguments:
#	exprObj		ExpressionSet
#	trainInd	vector of indices for the columns to be 
#			included in the training set
#	classifLab	character string specifying what covariate data 
#			to use for classification
#	metric		for distance matrix 
# value:
# 	object of class "classifPred"
# example:
# train <- c(sample(1:47, 21), sample(48:72, 12))
# olvq1Out <- olvq1B(golubMerge[100:200,], "ALL.AML", train)
####################

setGeneric("olvq1B", function(exprObj, classifLab, trainInd, size, prior, k=5, niter, alpha=0.03, metric="euclidean"){
		standardGeneric("olvq1B")
})

setMethod("olvq1B", c("ExpressionSet", "character", "integer", "ANY", "ANY", "ANY", "ANY", "ANY", "ANY"),
		function(exprObj, classifLab, trainInd, size, prior, k, niter, alpha, metric){

		if(missing(size)){ size <- NULL }
		cl <- pData(exprObj)[[classifLab]][trainInd]
		trainDat <- t(exprs(exprObj)[,trainInd])
		testDat <- t(exprs(exprObj)[,-trainInd])
		dis <- dist(testDat, method=metric)
		cbkInit <- class::lvqinit(trainDat, cl, size=size, prior=prior)
		if(missing(niter)){ niter <- 100 * nrow(cbkInit$x) } 
		cbkTrain <- class::olvq1(trainDat, cl, cbkInit, niter=niter, alpha=alpha)
		out <- class::lvqtest(cbkTrain, testDat)
                new("classifOutput", method="olvq1", 
			predLabels=newPredClass(as.character(out)), 
			trainInds=trainInd, allClass=as.character(pData(exprObj)[[classifLab]]),
			predScores=newQualScore(attr(out,"prob")),
                        RObject=cbkTrain, call=match.call(), distMat=dis)

})	

#####################
# title: SOMB
# description: interface to SOM {class}
# arguments:
#	exprObj		ExpressionSet
#	kx		x dimension
#	ky		y dimension
# 	topo		grid topology 
#	classifLab	character string specifying what covariate data 
#			to use for classification
# value:
# 	object of class "classifPred"
#	where sampLabels are the labels of the original sample
# example:
# somOut <- SOMB(golubMerge[100:200,], "ALL.AML", 2, 2)
####################

setGeneric("SOMB", function(exprObj, classifLab, kx=3, ky=3, topo="hexagonal", rlen=10000, 
		alpha=seq(0.05, 0, len=rlen), 
		radii=seq(4, 1, len = rlen), init, metric="euclidean"){
		standardGeneric("SOMB")
})

# a special container is provided for SOMB in somInterfaces.R

setMethod("show", "classifierOutput", function(object) {
 cat("MLInterfaces classification output container\n")
 cat("The call was:\n")
 print(object@call)
 if (length(testPredictions(object))>0) {
    sl = sort(levels(testPredictions(object)))
    cat("Predicted outcome distribution for test set:\n")
    print(table(testPredictions(object))[sl])  # aesthetic for brixen 2011
 }
 if (length(tsco <- object@testScores)>0) {
  cat("Summary of scores on test set (use testScores() method for details):\n") 
  if (is(tsco, "numeric")) print(summary(tsco))
  else if (is(tsco, "matrix")) print(apply(tsco,2,mean))
  }
 if (length(object@fsHistory)>0) cat("history of feature selection in cross-validation available; use fsHistory()\n")
})

#setGeneric("RObject", function(x) standardGeneric("RObject"))
setMethod("RObject", "classifierOutput", function(x) x@RObject)

setGeneric("trainInd", function(x) standardGeneric("trainInd"))
setMethod("trainInd", "classifierOutput", function(x) x@trainInd)

setGeneric("testScores", function(x) standardGeneric("testScores"))
setMethod("testScores", "classifierOutput", function(x) x@testScores)

setGeneric("trainScores", function(x) standardGeneric("trainScores"))
setMethod("trainScores", "classifierOutput", function(x) x@trainScores)


## recall, precision and macroF1 methods - L. Gatto <lg390@cam.ac.uk>, 30 July 2011
setGeneric("recall", function(obj, type,...) standardGeneric("recall"))
setGeneric("precision", function(obj, type,...) standardGeneric("precision"))
setGeneric("macroF1", function(obj, type,...) standardGeneric("macroF1"))

setGeneric("sensitivity",
           function(obj, type,...) {
             if (class(obj) == "table") {
               recall(obj, ...)
             } else {
               recall(obj, type, ...)
             }
           })


setMethod("recall",
          c("classifierOutput","missing"),
          function(obj, type, ...) return(.recall(confuMat(obj, "test", ...))))

setMethod("recall",
          c("classifierOutput","character"),
          function(obj, type, ...) return(.recall(confuMat(obj, type, ...))))

setMethod("recall",
          c("classifierOutput","numeric"),
          function(obj, type) return(.recall(confuMat(obj, "test", type))))

setMethod("precision",
          c("classifierOutput","missing"),
          function(obj, type, ...) return(.precision(confuMat(obj, "test", ...))))

setMethod("precision",
          c("classifierOutput","character"),
          function(obj, type, ...) return(.precision(confuMat(obj, type, ...))))

setMethod("precision",
          c("classifierOutput","numeric"),
          function(obj, type) return(.precision(confuMat(obj, "test", type))))

setMethod("macroF1",
          c("classifierOutput","missing"),
          function(obj, type, ...) {
            p <- precision(obj, "test", ...)
            r <- recall(obj, "test", ...)
            return(.macroF1(p,r))
          })

setMethod("macroF1",
          c("classifierOutput","character"),
          function(obj, type, ...) {
            p <- precision(obj, type, ...)
            r <- recall(obj, type, ...)
            return(.macroF1(p,r))
          })

setMethod("macroF1",
          c("classifierOutput","numeric"),
          function(obj, type) {
            p <- precision(obj, "test", type)
            r <- recall(obj, "test", type)
            return(.macroF1(p,r))
          })



# threshold-related code added by L. Gatto 2011 Brixen
setGeneric("confuMat", function(obj,type,...) standardGeneric("confuMat"))
setMethod("confuMat", c("classifierOutput","missing"), function(obj,type, ...) {
    confuMat(obj, "test", ...) })

setMethod("confuMat", c("classifierOutput","numeric"), function(obj,type) {
  confuMat(obj, "test", type) }) ## 'type' is 't' here

setMethod("confuMat", c("classifierOutput","character"), 
          function (obj, type, t) {  ## revised brixen 2011 to give better output table column order
            ## we are banking hard on the use of factors to represent response and
            ## predictions
            if (type == "test") {
              if (missing(t)) predictions <- testPredictions(obj)
              else predictions <- testPredictions(obj,t)
              giv = obj@testOutcomes
            } else if (type == "train") {
              if (missing(t)) predictions <- trainPredictions(obj)
              else predictions <- trainPredictions(obj,t)
              giv = obj@trainOutcomes
            } else stop("non-missing type must be either 'test' or 'train'")
            templ = table(given=giv, predicted=giv)
            templ = templ * 0
            if (all(is.na(levels(predictions))))
              return(cbind(templ,'NA'=table(giv)))
            if (length(giv) == 0) 
              stop("there is no test set in this classifier output")
            ans = table(given = giv, predicted = predictions)
            colnames(ans)[which(is.na(colnames(ans)))] <- 'NA' ## fixes 'strange' bug
            if (ncol(templ)!=ncol(ans)) {
              ## this is generally the case when some items have not been
              ## predicted with a score >= t and have been returned as NA
              ## predictions. Adding that column to the template.
           #   oldcolnames <- colnames(templ) # Feb 17 2020 -- otiose
           #   templ <-  cbind(templ,0)
           #   colnames(templ) <- c(oldcolnames,'NA')
              templ[rownames(ans),colnames(ans)] = ans
            }
            if (!isTRUE(all.equal(dim(ans), dim(templ)))) {
              used = colnames(ans)
              for (i in seq_len(ncol(ans))) templ[, used[i]] = ans[, used[i]]
              ans = templ
            }
            if (all(colnames(ans) %in% levels(giv))) return(ans[, levels(giv)])  # can reorder
            return(ans)
          })

#setGeneric("testPredictions", function(x) standardGeneric("testPredictions"))
#setMethod("testPredictions", "classifierOutput", function(x) x@testPredictions)

## modified by L. Gatto to allow setting a threshold and
## adjust the predictions dynamically
setGeneric("testPredictions", function(x,...) standardGeneric("testPredictions"))
setMethod("testPredictions", "classifierOutput", function(x,t) {
  tePredictions <- x@testPredictions
  if (missing(t)) {
    return(tePredictions)
  } else {
    teScores <- testScores(x)
    if (is.vector(teScores)) {
      tePredictions[teScores<t] <- NA
      return(factor(tePredictions,exclude=NULL))
    }
    ## assuming teScores is a matrix with
    ## columns named to classes
    if (!is.matrix(teScores)) {
      warning("testScores is not of class ",class(teScores),
              ", expecting vector or matrix - no threshold applied.")
      return(x@testPredictions)
    }
    teScores[teScores<t] <- -1
    clindex <- apply(teScores,1,function(x) {
      k <- names(which(max(x)==x))
      ## ties (?) or no value >= t - returning 'NA'
      ifelse((length(k)!=1 | is.null(k)),NA,k)
    })
    return(factor(clindex,exclude=NULL))
  }
})


#setGeneric("trainPredictions", function(x) standardGeneric("trainPredictions"))
#setMethod("trainPredictions", "classifierOutput", function(x) x@trainPredictions)

## modified by L. Gatto to allow setting a threshold and
## adjust the predictions dynamically
setGeneric("trainPredictions", function(x,...) standardGeneric("trainPredictions"))
setMethod("trainPredictions", "classifierOutput", function(x,t) {
  trPredictions <- x@trainPredictions
  if (missing(t)) {
    return(trPredictions)
  } else {
    trScores <- x@trainScores
    if (is.vector(trScores)) {
      trPredictions[trScores<t] <- NA
      return(factor(trPredictions,exclude=NULL))
    }
    ## assuming trScores is a matrix with
    ## columns named to classes
    if (!is.matrix(trScores)) {
      warning("testScores is of class ",class(trScores),
              ", expecting vector or matrix - no threshold applied.")
      return(x@trainPredictions)
    }
    trScores[trScores<t] <- -1
    clindex <- apply(trScores,1,function(x) {
      k <- names(which(max(x)==x))
      ## ties (?) or no value >= t - returning NA
      ifelse((length(k)!=1 | is.null(k)),NA,k)
    })
    return(factor(clindex,exclude=NULL))
  }
})


setGeneric("predictions", function(x,...) standardGeneric("predictions"))
setMethod("predictions", "classifierOutput", function(x,t) {
  trainInd <- x@trainInd
  if (missing(t))
    t <- 0
  trout <- as.character(x@trainOutcomes)
  tepred <- as.character(testPredictions(x,t))
  out <- rep(NA,length(trout)+length(tepred))
  out[trainInd] <- trout
  out[-trainInd] <- tepred
  return(factor(out))
})

setGeneric("predScore", function(x,...) standardGeneric("predScore"))
setMethod("predScore", "classifierOutput", function(x) {
  trainInd <- x@trainInd
  n <- length(x@trainOutcomes) + length(x@testOutcomes)
  out <- rep(1,n)
  trscores <- testScores(x)
  if (is.matrix(trscores)) {
    out[-trainInd] <- rowMax(trscores)
  } else {
    out[-trainInd] <- trscores
  }
  return(out)
})


setGeneric("predScores", function(x,...) standardGeneric("predScores"))
setMethod("predScores", "classifierOutput", function(x) {
  tescores <- testScores(x)
  if (!is.matrix(tescores)) {
    ans <- matrix(predScore(x), ncol = 1)
  } else {
    n <- nrow(tescores) + nrow(trainScores(x))
    trainOut <- as.character(x@trainOutcomes)
    testOut <- as.factor(as.character(x@testOutcomes)) # new march 22 2020 as.factor
    trainInd <- x@trainInd
    testInd <- (seq_len(n))[ -trainInd ]
    ans <-  matrix(0,
                   nrow = n,
                   ncol = ncol(tescores))
    ## tmp rownames - if NULL produces error
    ## when subsetting with rownames(ans)[testInd]
    rownames(ans) <- seq_len(nrow(ans))
    colnames(ans) <- colnames(tescores)
    rownames(ans)[testInd] <- rownames(tescores)
    rownames(ans)[trainInd] <- rownames(trainScores(x))
    ## updating test scores as returned by MLInterfaces::testScores
    stopifnot(length(testInd) == length(testOut))
    ans[testInd, ] <- tescores
    ## updating train scores - setting appropriate cell to 1
    ## why not initialise to 1?
    for (i in seq_len(length(trainInd)))
      ans[trainInd[i], trainOut[i]] <- 1
  }
  return(ans)
})


setGeneric("fsHistory", function(x) standardGeneric("fsHistory"))
setMethod("fsHistory", "classifierOutput", function(x) x@fsHistory)


predict.classifierOutput <- function(object, newdata, ...) {
  if (class(newdata)[1] == "ExpressionSet")
    newdata <- data.frame(t(exprs(newdata)))
  if (class(newdata)[1] == "matrix")
    newdata <- data.frame(newdata)
  model <- RObject(object)
  if (class(model)[1]=="list")
    stop("The 'classifierOutput' has", length(model),
         "models.", "Expecting only 1.")
  predict <- object@learnerSchema@predicter ## MLIPredicter
  ans <- predict(model, newdata, ...)
  ## ans is a list(testPredictions, testScores)
  ## testScores is numeric() and testPredictions should be
  ## factor(,levels=levels(trainPredictions))
  ## not sure if all original levels will always be included
  ## and possible downstream repercutions
  ## Will be more elaborated at a later stage
  return(ans)
}

hclustWidget = function(mat, featureName="feature", 
    title=paste0("hclustWidget for ", deparse(substitute(mat))),
     minfeats=2, auxdf=NULL) {
#
# software that defines interactive browser interface
# to approaches to clustering the rows of a matrix
#
#
# to use: library(MLInterfaces); run(hclustWidget(mat))
#
 shinyApp(ui = fluidPage(
  fluidRow( column(6, textOutput("title", container=h1)),
            column(2, actionButton("btnSend", "Stop widget"))),
  fluidRow(
   column(2,  numericInput("ngenes", label = paste0("N ", featureName, "s"), 
     minfeats, min = minfeats, max = ncol(mat))),
   column(2,  selectInput("distmeth", label = "Distance method:",
               choices = c("euclidean", "maximum", "manhattan",
               "binary"), selected = "euclidean")),

   column(2,  selectInput("fusemeth", label = "Agglomeration method:",
               choices = c("complete", "average", "ward.D2", "single",
                   "median", "centroid"), selected="complete")),
   column(2,  numericInput("numclus", label = "K:", 2, min = 1, max = nrow(mat)/2))
          ),
  fluidRow(column(7, plotOutput("tree"))),
  fluidRow(column(7, plotlyOutput("pcp"))) #ggvis::ggvisOutput("pcp")))
 ), server= function(input, output, session) {
    output$title <- renderText(title)
    output$tree <- renderPlot({
dm = dist(mat[,seq_len(input$ngenes)], method=input$distmeth)
sink(tempfile())
cb <- fpc::clusterboot(dm, clustermethod=fpc::hclustCBI, method=input$fusemeth, k=input$numclus, showplots=FALSE, scaling=FALSE)
sink(NULL)
      dend = hclust( dm, method=input$fusemeth )
      par(mar=c(3,3,3,1))
      plot(dend, main=paste0("Boot. Jacc. at k=", input$numclus, ": ",
        paste(round(cb$bootmean,2), collapse=", ")), xlab=" ")
    })
    output$pcp = renderPlotly({
      pc = prcomp(mat[,seq_len(input$ngenes)])$x
      dm = dist(mat[,seq_len(input$ngenes)], method=input$distmeth)
      dend = hclust( dm, method=input$fusemeth )
      ct = cutree(dend, k=input$numclus)
      pcdf = data.frame(PC1=pc[,1], PC2=pc[,2], 
         rowid=seq_len(nrow(pc)), assigned=factor(ct))
      t1 = ggplot(pcdf, aes(x=PC1, y=PC2, colour=assigned)) + geom_point(size=1.5)
      ggplotly(t1)
      })

#    P1 <- reactive({
#           all_values <- function(x) {
#             if(is.null(x)) return(NULL)
#             row <- pcdf[pcdf$rowid == x$rowid, ]
#             paste0(names(row), ": ", format(row), collapse = "<br />")
#           }
#
#      pc = prcomp(mat[,seq_len(input$ngenes)])$x
#      dm = dist(mat[,seq_len(input$ngenes)], method=input$distmeth)
#
#      dend = hclust( dm, method=input$fusemeth )
#      ct = cutree(dend, k=input$numclus)
#      pcdf = data.frame(PC1=pc[,1], PC2=pc[,2], #tiss=pData(tiss)$Tissue,
#         rowid=seq_len(nrow(pc)), assigned=factor(ct))
#      if (!is.null(auxdf)) {
#         if ((nrow(auxdf) == nrow(pcdf))) pcdf = cbind(pcdf, auxdf)
#           else message("nrow(auxdf) != nrow(mat), ignoring auxdf")
#         }
#      pcdf %>% ggvis::ggvis(~PC1, ~PC2, key := ~rowid, fill = ~assigned) %>% ggvis::layer_points() %>%
#               ggvis::add_tooltip(all_values, "hover") 
#      }) 
#      P1 %>% ggvis::bind_shiny("pcp")
      observe({
         if (input$btnSend > 0)
            isolate({
                stopApp(returnValue = 0)
                })
         })       
} )
}

test_that("svmI: y as factor/char", {
    e <- matrix(rnorm(100),
                ncol = 10)
    colnames(e) <- rownames(e) <- LETTERS[1:10]
    e <- ExpressionSet(e)
    e$k <- LETTERS[1:10]
    ## This fails with R-devel (4.0) prior version 1.67.10 with:
    ## Error in svm.default(x, y, scale = scale, ..., na.action
    ## = na.action) : Need numeric dependent variable for regression.
    cl1 <- MLearn(k ~ ., e, svmI, 1:5)
    e$k <- factor(e$k)
    cl2 <- MLearn(k ~ ., e, svmI, 1:5)
    expect_identical(cl1, cl2)
})

---
title: 'MLInterfaces 2.0 -- a new design'
author:
- name: "VJ Carey"
- name: "P. Atieno"
  affiliation: "Vignette translation from Sweave to Rmarkdown / HTML"
  package: MLInterfaces
  
vignette: >
  %\VignetteIndexEntry{MLInterfaces 2.0 -- a new design}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  BiocStyle::html_document
---


Introduction
============

MLearn, the workhorse method of MLInterfaces, has been streamlined to
support simpler development.

In 1.\*, MLearn included a substantial switch statement, and the
external learning function was identified by a string. Many massage
tasks were wrapped up in switch case elements devoted to each method.
MLearn returned instances of MLOutput, but these had complicated
subclasses.

MLearn now takes a signature <tt>c("formula", "data.frame", "learnerSchema", "numeric")</tt>, with the
expectation that extra parameters captured in \... go to the fitting
function. The complexity of dealing with expectations and return values
of different machine learning functions is handled primarily by the
learnerSchema instances. The basic realizations are that

-   most learning functions use the formula/data idiom, and additional
    parameters can go in \...

-   the problem of converting from the function's output structures
    (typically lists, but sometimes also objects with attributes) to the
    uniform structure delived by MLearn should be handled as generically
    as possible, but specialization will typically be needed

-   the conversion process can be handled in most cases using only the
    native R object returned by the learning function, the data, and the
    training index set.

-   some functions, like knn, are so idiosyncratic (lacking formula
    interface or predict method) that special software is needed to
    adapt MLearn to work with them

Thus we have defined a learnerSchema class, 

```{r setup, message=FALSE}
library(MLInterfaces) 
library(gbm)
getClass("learnerSchema") 
``` 
along
with a constructor used to define a family of schema objects that help
MLearn carry out specific tasks of learning.

Some examples
=============

We define interface schema instances with suffix \"I\".

randomForest has a simple converter: 

```{r lkrf}
randomForestI@converter
```

The job of the converter is to populate as much as the classifierOutput
instance as possible. For something like nnet, we can do more:

```{r lknn}
nnetI@converter 
```
We can get posterior class
probabilities.

To obtain the predictions necessary for confusionMatrix computation, we
may need the converter to know about parameters used in the fit. Here,
closures are used.

```{r lkknn}
knnI(k=3, l=2)@converter
```

So we can have the following calls: 

```{r show, message=FALSE}
library(MASS)
data(crabs)
kp = sample(1:200, size=120)
rf1 = MLearn(sp~CL+RW, data=crabs, randomForestI, kp, ntree=100)
rf1
RObject(rf1)
knn1 = MLearn(sp~CL+RW, data=crabs, knnI(k=3,l=2), kp)
knn1
```

Making new interfaces
=====================

A simple example: ada
---------------------

The <tt>ada</tt> method of the *ada* package has a formula interface and a
predict method. We can create a learnerSchema on the fly, and then use
it:

```{r mkadaI, message=FALSE}
adaI = makeLearnerSchema("ada", "ada", standardMLIConverter )
arun = MLearn(sp~CL+RW, data=crabs, adaI, kp )
confuMat(arun)
RObject(arun)
```
What is the standardMLIConverter? 

```{r lks}
standardMLIConverter
```
Dealing with gbm
----------------

The *gbm* package workhorse fitter is `gbm`. The formula input must have
a numeric response, and the predict method only returns a numeric
vector. There is also no namespace. We introduced a gbm2 function

```{r lkggg}
gbm2
```
that requires a two-level factor response and
recodes for use by gbm. It also returns an S3 object of newly defined
class gbm2, which only returns a factor. At this stage, we could use a
standard interface, but the prediction values will be unpleasant to work
with. Furthermore the predict method requires specification of
<tt>n.trees</tt>. So we pass a parameter <tt>n.trees.pred</tt>.

```{r tryg}
BgbmI
set.seed(1234)
gbrun = MLearn(sp~CL+RW+FL+CW+BD, data=crabs, BgbmI(n.trees.pred=25000,thresh=.5), kp, n.trees=25000, distribution="bernoulli", verbose=FALSE )
gbrun
confuMat(gbrun)
summary(testScores(gbrun))
```

Additional features
===================

The xvalSpec class allows us to specify types of cross-validation, and
to control carefully how partitions are formed. More details are
provided in the MLprac2\_2 vignette.

The MLearn approach to clustering and other forms of unsupervised learning
==========================================================================

A learner schema for a clustering method needs to specify clearly the
feature distance measure. We will experiment here. Our main requirements
are

-   ExpressionSets are the basic input objects

-   The typical formula interface would be `~.` but one can imagine
    cases where a factor from phenoData is specified as a 'response' to
    color items, and this will be allowed

-   a clusteringOutput class will need to be defined to contain the
    results, and it will propagate the result object from the native
    learning method.

% NOTE -- ONLY EDIT .Rnw!!!
% .tex file will get overwritten.
%
%\VignetteIndexEntry{MLInterfaces Computer Cluster}
%\VignetteDepends{golubEsets}
%\VignetteKeywords{Genomics}
%\VignettePackage{MLInterfaces}
%
% NOTE -- ONLY EDIT THE .Rnw FILE!!!  The .tex file is
% likely to be overwritten.

\documentclass{article}

\usepackage[colorlinks,linkcolor=blue]{hyperref}
\usepackage{graphicx}

\newcommand{\R}{\texttt{R}}
\newcommand{\code}[1]{\texttt{#1}}
\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Rfunarg}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}
 
\begin{document}

\title{Using \Rfunction{xval} and  clusters of computers for cross-validation}
\author{MT Morgan (\url{mtmorgan@fhcrc.org})}
\date{2 December, 2005}
\maketitle

<<echo=FALSE>>=
options(width=60)
@ 

\section{Introduction}

Cross-validation and other methods like the bootstrap can be `embarrassingly parallel'.
Embarrassingly parallel means that the same calculation is repeated independently for different data sets.
One way to decrease the execution time of embarrassingly parallel computations is to use a cluster of computers.
Each node in the cluster performs part of the computation, dividing the execution time by 1 over the number of nodes in the cluster.

This document illustrates how clusters can perform cross-validation calculations, using the \Rfunction{xval} method from the \Rpackage{MLInterfaces} package.
The document starts with a brief overview of what a cluster computation might look like, with some essential details swept `under the rug'; this is the `end-user' experience.
Delving deeper into the steps required for this experience is the `R programmer' experience.
This section outlines the implementation required (not provided in \Rpackage{MLInterfaces}!) for clustered computing, the likely performance gains, and directions for developing more effective parallelization strategies.
The section concludes with a summary of steps taken to make \Rfunction{xval} more amenable to clustered evaluation; these may be useful guides for exposing other functions to parallelization.

\section{Overview -- the `end user' experience}

A non-clustered cross-validation might involve the following \R{} commands, taken from the \Rfunction{xval} documentation examples:
<<init>>=
library(MLInterfaces)
library(golubEsets)
data(Golub_Merge)
smallG <- Golub_Merge[200:250,]
@ 
The first three statements load the \Rpackage{MLInterfaces} package and a data set.
The next line extracts a portion of the data set for use in the example.
We then perform a ``leave one out'' (LOO) cross-validation, and summarize the results in a table:
<<xval>>=
lk1 <- MLearn(ALL.AML~., smallG, knnI(k=1), xvalSpec("LOO"))
confuMat(lk1)
@ 

A clustered version of the same calculation requires that the user have a computer cluster available for \R{} to use.
The cluster has software libraries installed to allow communication between cluster nodes.
Common software packages include \code{MPI} and \code{PVM}.
\R{} also requires packages that allow communication between \R{} and the cluster software.
Available packages include \Rpackage{Rmpi} and \Rpackage{rpvm}; usually one installs the package corresponding to the cluster library available on the system.
Both \Rpackage{Rmpi} and \Rpackage{rpvm} provide a fairly `low-level' interface to the clusters.
A better starting point adds the package \Rpackage{snow} as  another layer on top of \Rpackage{Rmpi} or \Rpackage{pvm}.
\Rpackage{snow} makes it easy to start and stop clusters, and provides a uniform interface to key cluster functions.

Assuming a functioning cluster with appropriate \R{} packages, and with one caveat, the clustered cross-validation might start as before\ldots{}
<<clusterinit, eval=FALSE>>=
library(MLInterfaces)
library(golubEsets)
smallG <- Golub_Merge[200:250,]
@ 
Then load \Rpackage{snow}, start the cluster (e.g., with 8 nodes), and load \Rpackage{MLInterfaces} on each node\ldots{}
<<clusterstart, eval=FALSE>>=
library(snow)
cl <- makeCluster(8, "MPI")
clusterEvalQ(cl, library(MLInterfaces))
@ 
Finally, perform the calculation across the cluster\ldots{}
FOR THIS TO WORK WE WILL HAVE TO EXTEND xvalSpec TO DEAL WITH makeCluster OBJECTS.
<<clustercalc, eval=FALSE>>=
lk1 <- xval(smallG, "ALL.AML", knnB, xvalMethod="LOO", 
            group=as.integer(0), cluster = cl)
table(lk1,smallG$ALL.AML)
@ 
Notice that the only change to the actual \Rfunction{xval} call is the inclusion of the \code{cluster = cl} argument.
Easy!

\section{Caveats -- the `R programmer' experience}

NOTE THAT THIS MATERIAL HAS TO BE UPDATED TO DEAL WITH THE
MLearn/learnerSchema ARCHITECTURE THAT PREDATED THIS MATERIAL.

Now the caveat.
Someone has to tell \Rfunction{xval} how to do the calculation in clustered mode.
This is the job of the generic function \Rfunction{xvalLoop}.
We'll build up to a workable solution in this section.

Take a peak at the code inside the \Rfunction{xval} method (e.g., typing \code{getMethods(xval)} at the \R{} command prompt).
You will see \Rfunction{xvalLoop} appearing near the top, in a line reading \code{xvalLoop <- xvalLoop(cluster)}.
The function \Rfunction{xvalLoop} is a generic function, and it is called with the argument \code{cluster}.
Here's the definition of the default method of \Rfunction{xvalLoop} function:
<<eval=FALSE>>=
setMethod("xvalLoop", 
          signature( cluster = "ANY" ),
          function( cluster, ... ) lapply )
@ 
This code is executed when \code{cluster = NULL} (the default, when no \code{cluster} argument is provided).
By default, then, the \Rfunction{xvalLoop} function returns the \Rfunction{lapply} function.
The value of the \emph{variable} \code{xvalLoop} (i.e., on the left of \code{xvalLoop <- xvalLoop(cluster)} is then \Rfunction{lapply}.
A bit confusing, but hopefully not too confusing.

Look further into the \Rfunction{xval} code.
You'll see \code{xvalLoop} appearing again, toward the base of the method, as \code{out <- xvalLoop( 1:n, xvalidator, ... )}.
Since the value of \code{xvalLoop} is \code{lapply}, this is the same as \code{out <- lapply( 1:n, xvalidator, ... )}.

We would like our clustered version of \Rfunction{xval} to behave differently, specifically to use an \code{lapply}-like function that takes advantage of the computer cluster.
We do this by writing a method of \Rfunction{xvalLoop} that is specific to our type of cluster.
Suppose, as in the example above, we have an MPI cluster created with \Rpackage{snow}.
Some reading of the \Rpackage{snow} documentation leads to the \Rfunction{parLapply} function.
This behaves just like \Rfunction{lapply}, but distributes the tasks over cluster nodes.
In an ideal world, we would be able to write
<<eval=FALSE>>=
setOldClass( "spawnedMPIcluster" )
setMethod("xvalLoop",
          signature( cluster = "spawnedMPIcluster" ),
          function( cluster, ... ) parLapply )
@ 
Suppose we provided the argument \code{cluster = cl} to the \Rfunction{xval} function.
After \code{xvalLoop <- xvalLoop(cluster)}, the value of the variable \code{xvalLoop} is \code{parLapply}.
Later in \Rfunction{xval}, we would execute the equivalent of \code{out <- parLapply( 1:n, xvalidator, ... )}.
If only it were that easy!

There are two problems with the approach developed so far.
The first is that the arguments of \Rfunction{parLapply} are different from those of \Rfunction{lapply}.
Specifically, the first argument of \Rfunction{parLapply} is the cluster.

Here is one solution to this problem.
Create a `wrapper' for \Rfunction{parLapply} inside the \Rfunction{xvalLoop} method for \code{spawnedMPIcluster} that hides the cluster argument.
Return the wrapper function, rather than \Rfunction{parLapply}:
<<eval=FALSE>>=
setOldClass( "spawnedMPIcluster" )
setMethod("xvalLoop",
signature( cluster = "spawnedMPIcluster" ),
function( cluster, ... ) {
    relapply <- function(X, FUN, ...) {
        parLapply( cluster, X, FUN, ... )
    }
    relapply
})
@ 
Back in \Rfunction{xval}, the value of the variable \code{xvalLoop} is now \code{relapply}.
The crucial call later in \Rfunction{xval} will be \code{out <- relapply( 1:n, xvalidator, ... )}.
The function \Rfunction{relapply} is called with the arguments \code{1:n}, \code{xvalidator}, and \code{...}.
\Rfunction{relapply} then calls \Rfunction{parLapply} with the arguments \code{cluster} and the other arguments from the call to \Rfunction{relapply}.
The details of how \code{cluster} gets assigned the correct value involve the lexical scoping rules of \R{}, but what happens is that \code{cluster} takes on the value it had when the \Rfunction{xvalLoop} method was invoked -- the \Rfunction{relapply} function remembers the environment in which it was created, and the environment includes the variable \code{cluster}.

And now the second problem.
As it stands, only the computer executing \code{xval} knows about the various variables that have been defined, and are needed, for the cross-validation calls.
We have to share these variables with all cluster nodes contributing to the cross-validation.
\Rpackage{snow} allows us to export variables from one node to another.
This is a slow process, because in \Rpackage{snow} a new communication channel is established for each variable.
In addition, we would have to fully understand the \Rfunction{xval} method to know which variables needed to be exported under which circumstances.

Here is a solution that makes variable export quick while removing the need for detailed knowledge of which specific variables are required:
bundle all the `visible' variables into an environment, export the environment to each node, and unpack the environment at the receiving node.
This turns out to be a good solution, because virtually all the visible variables will be needed in the cross-validation.
The implementation of this solution is as follows:
<<eval=FALSE>>=
setMethod("xvalLoop", signature( cluster = "spawnedMPIcluster"),
function( cluster, ... ) {
    clusterExportEnv <- function (cl, env = .GlobalEnv)
    {
        unpackEnv <- function(env) {
            for ( name in ls(env) ) assign(name, get(name, env), .GlobalEnv )
            NULL
        }
        clusterCall(cl, unpackEnv, env)
    }
    relapply <- function(X, FUN, ...) {
        ## send all visible variables from the parent (i.e., xval) frame
        clusterExportEnv( cluster, parent.frame(1) )
        parLapply( cluster, X, FUN, ... )
    }
    relapply
})
@ 
The \Rfunction{clusterExportEnv} function is responsible for taking variables in an environment and sending them and a function to `unpack' the environment to each node.
\Rfunction{clusterCall} is defined in \Rpackage{snow}.

While tortuous in development from scratch, the end result and steps for creating new methods is straight-forward:
create an \Rfunction{xvalLoop} method for a clustered environment that (a) exports visible variables and (b) implements and returns a parallelized \Rfunction{lapply}-like function.

\subsection{Performance}

\begin{figure}[htbp]
  \centering
<<echo=FALSE,fig=TRUE>>=
res <- c(20.04,11.34, 9.23, 8.20, 7.87)
plot(res,ylab="Time (seconds)", xlab="Nodes", ylim=c(0,max(res)))
@ 
%%   \includegraphics{clusterResults}
  \caption{Execution time decreases asymptotically with number of nodes. The decreasing performance gain is primarily due to communication overhead.}
  \label{fig:clusterResults}
\end{figure}

After all this work, what do we get?
Without immediate access to a cluster, I ran \Rfunction{xval} on a collection of 64-bit x86 linux computers linked through standard ethernet switches.
There are a variety of users on each node, so they may not perform equivalently.
The code used is
<<eval=FALSE>>=
harness <- function( nodes, reps, data ) {
    if ( nodes > 1) {
        cl <- makeCluster(nodes, "MPI")
        clusterEvalQ(cl, library(MLInterfaces))
    } else cl <- NULL
    func <- function(x)
        res <- xval(data, "ALL.AML", knnB, xvalMethod = "LOO", 0:0, cluster = cl )
    func()                              # warm-up
    tm <- system.time( sapply( 1:reps, func ) )[3]
    if (nodes > 1) stopCluster(cl)
    tm
}
res <- sapply( 1:5, harness, 10, smallG )
@ 

Figure~\ref{fig:clusterResults} summarizes timings from 10 replicate calculations of the cross-validation used above.
The details of the results are likely to be quite system- and problem-dependent.
However, a general point emerges.

A basic framework for thinking about total execution time is to recognize two components: computation, and communication.
In an ideal world, computation time and node number are inversely related nodes, $t_{\textrm{comp}}\propto 1 /n$.
Communication time depends on how tasks are communicated to nodes.
In \Rpackage{snow}, communication increases linearly with node number, $t_{\textrm{comm}}\propto n$.
The combination of these times means that there is a node number that minimizes overall execution time.
Results in Figure~\ref{fig:clusterResults} suggest that the optimum cluster size for this problem is surprisingly small.

\subsection{Improvements}

This section sketches two ways to improve execution time.
A goal is to develop this more fully with worked examples.

\Rpackage{snow} and \Rfunction{clusterCall} communication scales linearly with node number.
This is because of the way \Rpackage{snow} implements cluster-wide calls.
Specifically, the `master' node (i.e., the node running \R{} through which interactions occur) communicates separately with each slave node.
Both \code{MPI} and \code{PVM} allow for more efficient models of communication, through \code{broadcast} operations that synchronize data across nodes in $\log n$ time.

The \code{broadcast} approach is likely to be important in large clusters, but in the example of the previous section the efficiency is not that great.
The underlying problem is the transfer of a large volume of data; actually, the optimum node number generally \emph{decreases} as the size of the data set increases.
One solution to this is somewhat counter-intuitive, at least to me.
The idea is for all nodes to independently read in data and execute all code up to the location where \code{xvalLoop} is used in \Rfunction{xval}.
The `slave' nodes then each execute a portion of the cross-validations, while the `master' node collates results from the slaves.
At the end of \code{xvalLoop} the master has a complete collection of results and continues on; the slaves have an incomplete set of results, and can be terminated.
The code is counter-intuitive because each node performs seemingly redundant calculations (the processing up to \code{xvalLoop}).
Communication times should be greatly reduced, though, because each communication involves just a short set of results rather than a potentially very large data set.
An assumption is that the clustered file system will cope well with near-simultaneous requests to initially read in data.

\subsection{Making \Rfunction{xval} cluster-friendly}

The implementation presented above required revision of the \Rfunction{xval} code.
The structure of the routine is: (1) check on supplied variables; (2) preliminary set-up; (3) a loop-like call where the `work' of the function occurs; and (4) processing of the result.
Many high-level \R{} routines have a similar structure.
The revisions aimed to more cleanly distinguish the overall structure, and in particular to isolate and refactor part (3).

A key step in the refactoring was to change a \code{for} loop into an \code{lapply}-like function call.
The reason that this is so important is that \code{for} loops allow side-effects to seep beyond the loop.
Side-effects are much more easily avoided in a function call.
Here is a simple illustration, where the `side-effect' in the \code{for} loop changes the value of \code{x}:
<<>>=
x <- 1:10
for (i in 1:10) x[i] <- i**2
x # x has been modified by the for loop

x <- 1:10
res <- lapply(1:10, function(i) x[i] <- i**2)
x # copy of x in lapply modified, not the global x
@ 
Avoiding side-effects is particularly important in a cluster, because side-effects are limited to the node on which the calculation occurs.
Usually this is not what is desired.

A final step in code revision is the hook, \code{xvalLoop}, provided for programmer access.
\code{xvalLoop} provides a division-of-labor between the \Rfunction{xval} expert and the clustered computing expert.
The \Rfunction{xval} expert needs only know that clustered computers can take advantage of \code{lapply}-like code.
The clustered computing expert need know little about \Rfunction{xval}, just that it has an \code{lapply}-like loop to be exploited.
Since \code{xvalLoop} is a generic function, the clustered computing expert can tailor methods to different types of clusters and even different algorithms.
The end user need know little about either \Rfunction{xval} or clustered computing; they just provide their cluster as an argument to \Rfunction{xval}.

\section{Conclusion}

This document provides a guide to users wanting to make use of \Rfunction{xval} on a computer cluster.
It also provides guidance for further parallelization of \code{xval}, and outlines how functions can be written to expose key components to parallelization.
An emphasis is the division of labor between specialized function writers, clustered computer experts, and end users.

\end{document}

---
title: 'A machine learning tutorial tutorial: applications of the Bioconductor MLInterfaces package to gene expression data'
author:
- name: "VJ Carey"
- name: "P. Atieno"
  affiliation: "Vignette translation from Sweave to Rmarkdown / HTML"
  package: MLInterfaces
  
vignette: >
  %\VignetteIndexEntry{A machine learning tutorial tutorial: applications of the Bioconductor MLInterfaces package to gene expression data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  BiocStyle::html_document
---

Overview
========

The term *machine learning* refers to a family of computational methods
for analyzing multivariate datasets. Each data point has a vector of
*features* in a shared *feature space*, and may have a *class label*
from some fixed finite set.

*Supervised learning* refers to processes that help articulate rules
that map *feature vectors* to *class labels*. The class labels are known
and function as supervisory information to guide rule construction.
*Unsupervised learning* refers to processes that discover structure in
collections of feature vectors. Typically the structure consists of a
grouping of objects into clusters.

This practical introduction to machine learning will begin with a survey
of a low-dimensional dataset to fix concepts, and will then address
problems coming from genomic data analysis, using RNA expression and
chromatin state data.

Some basic points to consider at the start:

-   Distinguish predictive modeling from inference on model parameters.
    Typical work in epidemiology focuses on estimation of relative
    risks, and random samples are not required. Typical work with
    machine learning tools targets estimation (and minimization) of the
    misclassification rate. Representative samples are required for this
    task.

-   "Two cultures": model fitters vs. algorithmic predictors. If
    statistical models are correct, parameter estimation based on the
    mass of data can yield optimal discriminators (e.g., LDA).
    Algorithmic discriminators tend to prefer to identify boundary cases
    and downweight the mass of data (e.g., boosting, svm).

-   Different learning tools have different capabilities. There is
    little *a priori* guidance on matching learning algorithms to
    aspects of problems. While it is convenient to sift through a
    variety of approaches, one must pay a price for the model search.

-   Data and model/learner visualization are important, but
    visualization of higher dimensional data structures is hard. Dynamic
    graphics can help; look at ggobi and Rggobi for this.

-   These notes provide very little mathematical background on the
    methods; see for example Ripley (*Pattern recognition and neural
    networks*, 1995), Duda, Hart, Stork (*Pattern classification*),
    Hastie, Tibshirani and Friedman (2003, *Elements of statistical
    learning*) for copious background.

Getting acquainted with machine learning via the crabs data
===========================================================

## Attaching and checking the data

The following steps bring the crabs data into scope and illustrate
aspects of its structure.

```{r intro1} 
library("MASS") 
data("crabs") 
dim(crabs)
crabs[1:4,] 
table(crabs$sex)
```

```{r figbwplot, echo=FALSE, fig.cap="\\label{fig:figbwplot} Boxplots of RW, the rear width in mm, stratified by species('B' or 'O' for blue or orange) and sex ('F' and 'M')."}
library("lattice")
print(bwplot(RW~sp|sex, data=crabs))
```

The plot is shown in Figure 1.

We will regard these data as providing five quantitative features
(FL, RW,   CL,   CW,  BD)^[You may consult the manual page of <tt>{crabs}</tt> 
for an explanation of these abbreviations.] and a pair of class labels (sex, sp=species).
We may regard this as a four class problem, or as two two class
problems.


## A simple classifier derived by human reasoning

Our first problem does not involve any computations.
If you want to write R code to solve the problem, do so,
but use prose first.

-  *Question 1*.  On the basis of the boxplots in Figure 1, comment on the prospects
for predicting species on the basis of RW.  State a
rule for computing the predictions.  Describe how to assess the
performance of your rule.


## Prediction via logistic regression

A simple approach to prediction involves logistic regression.
```{r dop}
m1 = glm(sp~RW, data=crabs, family=binomial)
summary(m1)
```

-   *Question 2*.  Write down the statistical model
corresponding to the R expression above.  How can we derive
a classifier from this model?

-   *Question 3*.  Perform the following
computations.  Discuss their interpretation.
What are the estimated error rates of the two
models?  Is the second model, on the subset, better?


```{r domo, results='hide', fig.show="hide"}
plot(predict(m1,type="response"), crabs$sp,)
table(predict(m1,type="response")>.5, crabs$sp)
m2 = update(m1, subset=(sex=="F"))
table(predict(m2,type="response")>.5, crabs$sp[crabs$sex=="F"])
```

## The cross-validation concept

Cross-validation is a technique that is widely used for
reducing bias in the estimation of predictive accuracy. If no precautions are taken,
bias can be caused by *overfitting* a classification algorithm to a particular
dataset; the algorithm learns the classification ''by heart'', but performs poorly 
when asked to generalise it to new, unseen examples.
Briefly, in cross-validation the dataset is deterministically partitioned into
a series of training and test sets.  The model is built
for each training set and evaluated on the test set.
The accuracy measures are averaged over this series
of fits.  Leave-one-out cross-validation consists of N
fits, with N training sets of size N-1 and N test sets
of size 1.

First let us use <tt>MLearn</tt> from the 
*MLInterfaces* package to fit a single logistic model.
<tt>MLearn</tt> requires you to specify an index set for training.
We use <tt>c(1:30, 51:80)</tt> to choose a training set of
size 60, balanced between two species (because we know the
ordering of records).  This procedure also requires you
to specify a probability threshold for classification.
We use a typical default of 0.5.  If the predicted probability
of being "O" exceeds 0.5, we classify to "O", otherwise to "B".

```{r doml1, message=FALSE}
library(MLInterfaces)
fcrabs = crabs[crabs$sex == "F", ] 
ml1 = MLearn( sp~RW, fcrabs,glmI.logistic(thresh=.5), c(1:30, 51:80), family=binomial) 
ml1
confuMat(ml1)
```

-   *Question 4.*  What does the report on <tt>ml1</tt> tell you about
    predictions with this model? Can you reconcile this with the results
    in model <tt>m2</tt>? [Hint -- non-randomness of the selection of the
    training set is a problem.]
    
-   *Question 5.*  Modify the MLearn call to obtain a predictor that is
    more successful on the test set.

Now we will illustrate cross-validation. First, we scramble the order of
records in the <tt>ExpressionSet</tt> so that sequentially formed groups are
approximately random samples.

```{r doscra}
set.seed(123) 
sfcrabs = fcrabs[ sample(nrow(fcrabs)), ]
```

We invoke the <tt>MLearn</tt> method in two ways -- first specifying a training
index set, then specifying a five-fold cross-validation. 

```{r domods}
sml1 = MLearn( sp~RW, sfcrabs, glmI.logistic(thresh=.5),c(1:30, 51:80),family=binomial)
confuMat(sml1)
smx1 = MLearn( sp~RW, sfcrabs, glmI.logistic(thresh=.5),xvalSpec("LOG", 5, function(data, clab, iternum) {which(rep(1:5, each=20) == iternum) }), family=binomial)
confuMat(smx1)
```

-   *Question 6.* Define clearly the difference between models sml1 and
    smx1 and state the misclassification rate estimates associated with
    each model.

## Exploratory multivariate analysis

### Scatterplots

-   *Question 7.* Interpret the following code, whose result is shown in
    Figure 2. Modify it to depict the pairwise
    configurations with different colors for crab genders.

```{r figdopa,fig=TRUE,width=7,height=7, fig.cap="\\label{fig:figdopa}Pairs plot of the 5 quantitative features of the crabs data.Points are colored by species."}
pairs(crabs[,-c(1:3)], col=ifelse(crabs$sp=="B", "blue", "orange"))
```


### Principal components; biplot

Principal components analysis transforms the multivariate
data *X* into a new coordinate system.  If the original variables
are X1, . . . , X~p~, then the variables in the new representation
are denoted PC1, . . . , PC~p~.  These new variables have
the properties that PC1 is the linear combination of the X1, . . . , X~p~
having maximal variance, PC2 is the variance-maximizing linear combination of
residuals of X after projecting into the hyperplane normal to PC1, and so on.
If most of the variation in X~n×p~ can be captured in a low dimensional linear subspace of the space
spanned by the columns of X, then the scatterplots of the first few
principal components give a good representation of the structure in the
data.

Formally, we can compute the PC using the singular value decomposition
of *X*, in which *X = U DV^2^*,  where *U~n×p~* and *V~p×p~*  are orthonormal, and *D* is a diagonal matrix of $p$
nonnegative singular values. The principal components transformation is
*XV = UD*, and if *D* is structured so that *D~ii~ ≥ D~jj~*
whenever *i > j*, then column *i* of *XV* is PCi. Note also that
*D~ii~* = √*n − 1* sd(PCi).

```{r dopc, fig.cap="\\label{fig:figdopa}Pairs plot of the crabs data in principal component coordinates"}
pc1 = prcomp( crabs[,-c(1:3)] )
pairs(pc1$x, col=ifelse(crabs$sp=="B", "blue", "orange"))
```


The plot is shown in Figure 3.

The biplot, Figure 4, shows the data in PC space and also shows the
relative contributions of the original variables in composing the
transformation.

```{r figdobi,fig=TRUE, fig.cap="\\label{fig:figdopa} Biplot of the principal component analysis of the crabs data."}
biplot(pc1, choices=2:3, col=c("#80808080", "red"))
```


### Clustering

A familiar technique for displaying multivariate data in high-throughput
biology is called the heatmap. In this display, samples are clustered as
columns, and features as rows. The clustering technique used by default
is R <tt>hclust</tt>. This procedure builds a clustering tree for the data as
follows. Distances are computed between each pair of feature vectors for
all *N* observations. The two closest pair is joined and regarded as a
new object, so there are *N-1* objects (clusters) at this point. This
process is repeated until 1 cluster is formed; the clustering tree shows
the process by which clusters are created via this agglomeration
process.

The most crucial choice when applying this method is the initial choice
of the distance metric between the features.

Once clusters are being formed, there are several ways to measure
distances between them, based on the initial between-feature distances.
Single-linkage clustering takes the distance between two clusters to be
the shortest distance between any two members of the different clusters;
average linkage averages all the distances between members;
complete-linkage uses hte maximum distance between any two members of
the different clusters. Other methods are also available in <tt>hclust</tt>.

Figure 5 shows cluster trees for samples and features. The default color choice is not
great, thus we specify own using the <tt>col</tt> argument. A tiled display at
the top, defined via the argument <tt>ColSideColors</tt> shows the species
codes for the samples. An important choice to be made when calling
<tt>heatmap</tt> is the value of the argument <tt>scale</tt>, whose default setting is
to scale the rows, but not the columns. 

```{r checkClaim,echo=FALSE}
stopifnot(eval(formals(heatmap)$scale)[1]=="row")
``` 

```{r figdohm,fig=TRUE,height=6.5,width=6.5, fig.cap="\\label{fig:figdopa}Heatmap plot of the crabs data, including dendrograms representing hierarchical clustering of the rows and columns."}
X = data.matrix(crabs[,-c(1:3)])
heatmap(t(X), ColSideColors=ifelse(crabs$sp=="O", "orange", "blue"), col =
colorRampPalette(c("blue", "white", "red"))(255)) 
```

Typically clustering is done in the absence of labels -- it is an
example of unsupervised machine learning. We can ask whether the
clustering provided is a 'good' one using the measurement of a quantity
called the *silhouette*. This is defined in R documentation as follows:

         For each observation i, the _silhouette width_ s(i) is defined as
         follows: 
          Put a(i) = average dissimilarity between i and all other points
         of the cluster to which i belongs (if i is the _only_ observation
         in its cluster, s(i) := 0 without further calculations). For all
         _other_ clusters C, put d(i,C) = average dissimilarity of i to all
         observations of C.  The smallest of these d(i,C) is b(i) := min_C
         d(i,C), and can be seen as the dissimilarity between i and its
         "neighbor" cluster, i.e., the nearest one to which it does _not_
         belong. Finally, 

                 s(i) := ( b(i) - a(i) ) / max( a(i), b(i) ).

We can compute the silhouette for any partition of a dataset, and can
use the hierarchical clustering result to define a partition as follows:

```{r docl}
cl = hclust(dist(X)) 
tr = cutree(cl,2)
table(tr)
```

```{r dos,fig=TRUE}
library(cluster) 
sil = silhouette( tr, dist(X) )
plot(sil) 
```

-   *Question 8.* In the preceding, we have used default `dist`, and
    default clustering algorithm for the heatmap. Investigate the impact
    of altering the choice of distance and clustering method on the
    clustering performance, both in relation to capacity to recover
    groups defined by species and in relation to the silhouette
    distribution.

-   *Question 9.* The PCA shows that the data configuration in PC2 and
    PC3 is at least bifurcated. Apply hierarchical and K-means
    clustering to the two-dimensional data in this subspace, and compare
    results with respect to capturing the species $\times$ gender
    labels, and with respect to silhouette values. For example, load the
    exprs slot of crES [see just below for the definition of this
    structure] with the PCA reexpression of the features, call the
    result pcrES, and then:

        > ff = kmeansB(pcrES[2:3,], k=4)
        > table(ff@clustIndices, crES$spsex)

## Supervised learning


In this section we will examine procedures for polychotomous prediction.
We want to be able to use the measurements to predict both species and
sex of the crab. Again we would like to use the MLInterfaces
infrastructure, so an ExpressionSet container will be useful.

```{r newes}
feat2 = t(data.matrix(crabs[, -c(1:3)])) 
pd2 =new("AnnotatedDataFrame", crabs[,1:2]) 
crES = new("ExpressionSet",exprs=feat2, phenoData=pd2)
crES$spsex = paste(crES$sp,crES$sex, sep=":")
table(crES$spsex)
```

We will permute the samples so that simple
selections for training set indices are random samples. 

```{r doper}
set.seed(1234) 
crES = crES[ , sample(1:200, size=200, replace=FALSE)]
```

### RPART

A classic procedure is recursive partitioning. 

```{r dotr, message=FALSE}
library(rpart)
tr1 = MLearn(spsex~., crES, rpartI, 1:140)
tr1
confuMat(tr1) 
```

The actual tree is 
```{r doplTree,fig=TRUE}
plot(RObject(tr1))
text(RObject(tr1)) 
```
This procedure includes a diagnostic tool called
the cost-complexity plot: 

```{r doccp,fig=TRUE}
plotcp(RObject(tr1)) 
```

### Random forests

A generalization of recursive partitioning is obtained by creating a
collection of trees by bootstrap-sampling cases and randomly sampling
from features available for splitting at nodes.

```{r dorf, message=FALSE}
set.seed(124) 
library(randomForest)
crES$spsex = factor(crES$spsex) # needed 3/2020 as fails with 'do regression?' error 
rf1 = MLearn(spsex~., crES, randomForestI, 1:140 )
rf1
cm = confuMat(rf1)
cm 
```

The single split error rate is estimated at 28%.

-   *Question 10.* What is the out-of-bag error rate for rf1? Obtain a
    cross-validated estimate of misclassification error using
    randomForest with an xvalSpec().

### Linear discriminants

```{r dold, message=FALSE}
ld1 = MLearn(spsex~., crES, ldaI, 1:140 ) 
ld1
confuMat(ld1)
xvld = MLearn( spsex~., crES, ldaI, xvalSpec("LOG", 5,balKfold.xvspec(5)))
confuMat(xvld)
```

-   *Question 11.* Use the balKfold function to generate an index set for
    partitions that is balanced with respect to class distribution.
    Check the balance and repeat the cross validation.

### Neural net

```{r, message=FALSE}
nn1 = MLearn(spsex~., crES, nnetI, 1:140, size=3, decay=.1)
nn1 
RObject(nn1) 
confuMat(nn1)
```

```{r doxx, message=FALSE}
xvnnBAD = MLearn( spsex~., crES, nnetI, xvalSpec("LOG", 5, function(data, clab,iternum) which( rep(1:5,each=40) == iternum ) ), size=3,decay=.1 )
xvnnGOOD = MLearn( spsex~., crES, nnetI, xvalSpec("LOG", 5,balKfold.xvspec(5) ), size=3, decay=.1 )
```


```{r lktann}
confuMat(xvnnBAD)
confuMat(xvnnGOOD)
```

### SVM

```{r dnn, message=FALSE} 
sv1 = MLearn(spsex~., crES, svmI, 1:140) 
sv1 
RObject(sv1)
confuMat(sv1) 
```

```{r doxxs, message=FALSE}
xvsv = MLearn( spsex~., crES,svmI, xvalSpec("LOG", 5, balKfold.xvspec(5)))
```

```{r lktasv}
confuMat(xvsv) 
```

# Learning with expression arrays

Here we will concentrate on ALL: acute lymphocytic leukemia, B-cell
type.

## Phenotype reduction

We will identify expression patterns that discriminate individuals with
BCR/ABL fusion in B-cell leukemia.

```{r setupALL,cache=TRUE}
library("ALL")
data("ALL") 
bALL = ALL[, substr(ALL$BT,1,1) == "B"]
fus = bALL[, bALL$mol.biol %in% c("BCR/ABL", "NEG")]
fus$mol.biol = factor(fus$mol.biol)
fus 
```           

## Nonspecific filtering

We can nonspecifically filter to 300 genes (to save computing time) with
largest measures of robust variation across all samples:

```{r getq}
mads = apply(exprs(fus),1,mad) 
fusk = fus[ mads > sort(mads,decr=TRUE)[300], ] 
fcol =ifelse(fusk$mol.biol=="NEG", "green", "red")
```

## Exploratory work

For exploratory data analysis, a heatmap is customary.

```{r dohALL,fig=TRUE}
heatmap(exprs(fusk), ColSideColors=fcol)
``` 
 
\includegraphics{fuskmap}

Principal components and a biplot may be more revealing.
How many principal components are likely to be important?

```{r dopcALL}
PCg = prcomp(t(exprs(fusk)))
```

```{r lkscre,fig=TRUE}
plot(PCg)
```

```{r lkprALL,fig=TRUE}
pairs(PCg$x[,1:5],col=fcol,pch=19)
```

```{r dobiALL,fig=TRUE}
biplot(PCg) 
```

-   *Question 12.* Modify the biplot so that instead of plotting sample
    ID, the symbol \"O\" is plotted for a NEG sample and \"+\" is
    plotted for a BCR/ABL sample.

```{=html}
<!-- -->
```
-   *Question 13.* Consider the following code

        chkT = function (x, eset=fusk) {
        t.test(exprs(eset)[x, eset$mol.b == "NEG"], exprs(eset)[x, eset$mol.b == 
            "BCR/ABL"]) }

    Use it in conjunction with the biplot to interpret expression
    patterns of genes that appear to be important in defining the PCs.

## Classifier construction

### Demonstrations

Diagonal LDA has a good reputation. Let's try it first, followed by
neural net and random forests. We will not attend to tuning the latter
two, defaults or guesses for key parameters are used.

```{r dld1,cache=TRUE, message=FALSE}
dld1 = MLearn( mol.biol~., fusk, dldaI, 1:40 )
```

```{r dld2}
dld1 
confuMat(dld1) 
```

```{r dld3,cache=TRUE}
nnALL = MLearn( mol.biol~., fusk, nnetI, 1:40, size=5, decay=.01, MaxNWts=2000 )
```

```{r dld4}
confuMat(nnALL)
```

```{r dld5,cache=TRUE}
rfALL = MLearn(
mol.biol~., fusk, randomForestI, 1:40 ) 
```

```{r dld6}
rfALL
confuMat(rfALL)
```

None of these are extremely impressive, but the problem may just be very
hard.

### Gene set appraisal

-   *Question 14.* We can assess the predictive capacity of a set of genes
    by restricting the ExpressionSet to that set and using the best
    classifier appropriate to the problem. We can also assess the
    incremental effect of combining gene sets, relative to using them
    separately.

    One collection of gene sets that is straightforward to use and
    interpret is provided by the keggorthology package (see also
    GSEABase). Here's how we can define the ExpressionSets for genes
    annotated by KEGG to Environmental (Genetic) Information Processing:
    
    ```{r getko, message=FALSE}
    library(keggorthology) 
    data(KOgraph) 
    adj(KOgraph,nodes(KOgraph)[1])
    EIP = getKOprobes("Environmental Information Processing")
    GIP = getKOprobes("Genetic Information Processing")
    length(intersect(EIP, GIP)) 
    EIPi = setdiff(EIP, GIP) 
    GIP = setdiff(GIP, EIP) 
    EIP = EIPi
    Efusk = fusk[ featureNames(fusk)  %in% EIP, ]
    Gfusk = fusk[ featureNames(fusk)  %in% EIP, ]
    ```
    Obtain and assess the predictive
    capacity of the genes annotated to \"Cell Growth and Death\".

```{=html}
<!-- -->
```
-   *Question 15.* How many of the genes identified by RDA as important
    for discriminating fusion are annotated to Genetic Information
    Processing in the KEGG orthology?

# Embedding features selection in cross-validation

We provide helper functions to conduct several kinds of feature
selection in cross-validation, see <tt>help(fs.absT)</tt>. Here we pick the top
30 features (ranked by absolute t statistic) for each cross-validation
partition.

```{r dofs, message=FALSE}
dldFS = MLearn( mol.biol~., fusk, dldaI, xvalSpec("LOG", 5, balKfold.xvspec(5), fs.absT(30) ))
dldFS 
confuMat(dld1)
confuMat(dldFS) 
```

Session information
===================

```{r lksess}
sessionInfo() 
```

%
% NOTE -- ONLY EDIT THE .Rnw FILE!!!  The .tex file is
% likely to be overwritten.
%
\documentclass[12pt]{article}

\usepackage{amsmath}
\usepackage[authoryear,round]{natbib}
\usepackage{hyperref}


\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}
\newcommand{\bi}{\begin{itemize}}
\newcommand{\ei}{\end{itemize}}


\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Rfunarg}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}

\textwidth=6.2in

\bibliographystyle{plainnat} 
 
\begin{document}
%\setkeys{Gin}{width=0.55\textwidth}

\title{BioC 2008 practical: Machine learning with genome-scale data}
\author{\copyright 2008 VJ Carey stvjc at channing.harvard.edu}
\maketitle

\tableofcontents

\section{Introduction}

The term \textit{machine learning} refers to a family of
computational methods for analyzing multivariate datasets.
Each data point has a vector of \textit{features} in a shared
\textit{feature space},
and may have a \textit{class label} from some fixed finite set.

\textit{Supervised learning} refers to processes
that help articulate rules that map \textit{feature vectors}
to \textit{class labels}.  The class labels are known and
function as supervisory information to guide rule construction.
\textit{Unsupervised learning} refers to processes
that discover structure in collections of feature
vectors.  Typically the structure consists of a grouping
of objects into clusters.

Some basic points to consider at the start:
\bi
\item Distinguish predictive modeling from inference
on model parameters.  Typical work in epidemiology focuses
on estimation of relative risks, and random samples are not
required.  Typical work with machine learning tools targets
estimation (and minimization) of the misclassification rate.
Representative samples are required for this task.
\item All prediction or clustering algorithms, like all modeling
procedures, rely on a choice of distance metric that permits
quantitative
evaluation of similarity and dissimilarity among objects.  The
choice can affect results and there is typically no \textit{a priori}
basis for selecting the distance function.  A one-minus-correlation
distance can be very different from euclidean distance for
a given pair of genes.
\item ``Two cultures'': model fitters vs. algorithmic predictors.
If statistical models are correct, parameter estimation based
on the mass of data can
yield optimal discriminators (e.g., LDA).  Algorithmic discriminators
tend to prefer
to identify boundary cases and downweight the mass of data (e.g., boosting,
svm).
\item Different learning tools have different capabilities.
There is little \textit{a priori} guidance on matching learning algorithms to
aspects of problems.  While it is convenient to sift through a variety
of approaches, one must pay a price for the model search.
\item Data and model/learner visualization are  important, but
visualization in higher dimensional data structures is hard.
Dynamic graphics can help; look at ggobi and Rggobi for this.
\item These notes provide very little mathematical background
on the methods; see for example Ripley (\textit{Pattern recognition and neural networks},
1995), Duda, Hart, Stork (\textit{Pattern classification}),
Hastie, Tibshirani and Friedman (2003,
\textit{Elements of statistical learning}) for extensive
background.
\ei

\section{Data structures}

The representation of genome-scale data has impacts on 
many aspects of data analysis.  For microarray measures
of mRNA abundance (expression arrays) we use the \texttt{ExpressionSet}
to unify data and metadata on a set of arrays.  
Let $G$ denote the number of genes probed on the array,
and $N$ denote the number of samples which will be assumed
independent (familial data structures not directly
considered).  The key points for an \texttt{ExpressionSet} instance \texttt{X}
are
\begin{itemize}
\item \texttt{exprs(X)} is a $G \times N$ \texttt{matrix} of expression values
(typically on the log scale)
\item \texttt{pData(X)} is a $N \times R$ \texttt{data.frame} of
sample-level variables
\item  \verb+X$v+ is an $N$-vector of values on the sample-level
variable named \texttt{v}
\item \texttt{X[G, S]} is a new \texttt{ExpressionSet} instance
with genes restricted according to predicate \texttt{G} and
samples restricted according to predicate \texttt{S}
\end{itemize}

Our first example
is the Chiaretti et al. dataset on acute lymphocytic leukemia.
<<d1,echo=FALSE>>=
if (!("package:ALL" %in% search())) library(ALL)
if (!(exists("ALL"))) data(ALL)
<<d2,eval=FALSE>>=
library(ALL)
data(ALL)
ALL
@
We will focus on the molecular classification of leukemia-type
within B-cell leukemias, and create a subset of B-cell ALL samples
that are either positive or negative for BCR/ABL gene fusion
<<lkta>>=
table(ALL$BT, ALL$mol.biol)
bALL = ALL[, substr(ALL$BT, 1, 1) == "B"]
fbALL = bALL[, bALL$mol.biol %in% c("BCR/ABL", "NEG")]
fbALL$mol.biol = factor(fbALL$mol.biol, levels=c("NEG", "BCR/ABL"))
fbALL$binFus = 1*(fbALL$mol.biol == "BCR/ABL")
@
In the last assignment, we make a 0-1 representation of the mol.biol
factor.

\section{Logistic regression and linear discriminant analysis}

A standard analysis of a problem
with a two-class outcome focuses on modeling the
probability of class membership.  With our
representation, we consider the probability that a
sample is positive for BCR/ABL fusion (this event
is denoted $F=1$, $F$ a binary random variable)  conditional on 
the level of expression of a selected gene.  A linear logistic
model takes the form
\[
\mbox{logit Pr}(F = 1|x) = \alpha + x\beta
\]

\subsection{Manual fit of a logistic regression}

This can be fit manually using R as follows.  We use the third
gene on the array as $x$.
<<dologi>>=
lr1 = glm(formula = fbALL$binFus ~ exprs(fbALL)[3, ], family = binomial)
summary(lr1)
@

\subsubsection*{Exercises}
\begin{itemize}
\item Visualize the class-specific distributions of the modeled gene.
\item What is the name of the gene used in this analysis?
\end{itemize}

\subsection{Using MLInterfaces}

\subsubsection{A simple application: single gene logistic regression}

Here we use a generic method that operates on \texttt{ExpressionSet}
instances and formulae to carry out the same logistic
regression analysis, but with cross-validation.  In this species
of cross-validation, the dataset is partitioned into five subsets,
each of which is formed to have approximately equal representation
of the outcome classes.

<<doml,keep.source=TRUE>>=
library(MLInterfaces)
lr2 = MLearn(mol.biol~., fbALL[3,], glmI.logistic(thresh=.5), 
   xvalSpec("LOG", 5, balKfold.xvspec(5)), 
   family=binomial)
lr2
@

Notice that the result of this call is not a table of
coefficients, but an object.  That object has the same
formal structure for any successful call to \texttt{MLearn}.

We can get the table of coefficients through the following:
<<lktab>>=
summary(RObject(RObject(lr2)[[1]]$mlans))
@

The access path to the coefficients 
is somewhat convoluted -- two levels of
storage must be traversed.  At the top level (interior
call to \texttt{RObject}, applied to \texttt{lr2}), we are looking
into the result of five cross-validation iterations.  We
pick the first using \texttt{[[1]]}.  This returns a 
list.  The element named \texttt{mlans} holds the table of
coefficients (actually the glm model fit), retrieved using
the outer call to \texttt{RObject}, rendered using \texttt{summary}.

The \texttt{MLearn} method is tailored to predictive applications.
In the use of logistic modeling, a threshold is specified in the
third argument to MLearn.  The predicted probability of fusion for each
sample is computed according to the fitted model and if it exceeds
the threshold parameter, the sample is predicted to be in the fusion
class; otherwise it is predicted to be negative for fusion.

The confusion matrix for the cross-validated
prediction exercise cross-tabulates
known class vs predicted class for all samples.  The proportion
of off-diagonal entries is an estimate of the misclassification rate.

\subsubsection*{Exercises}
\begin{itemize}
\item If we relax the threshold for classifying to fusion to 40\%,
what happens to the misclassification rate for cross-validated,
single-gene,
logistic regression-based prediction?
\end{itemize}

%lr3 = MLearn(mol.biol~., fbALL[3,], glmI.logistic(thresh=.40), 
%   xvalSpec("LOG", 5, balKfold.xvspec(5)), 
%   family=binomial)

\subsubsection{Prediction with many genes}

We will now illustrate linear discriminant analysis (LDA).
We use a collection of genes, denoted $x_i$ to characterize sample $i$,
and compute the multivariate mean for each class (denoted
$\mu_F$ and $\mu_N$ for fusion and negative respectively)
and the common covariance matrix $\Sigma$ for all the observations.
If $\pi_F$ and $\pi_N$ are the proportions of fusion and negative
samples in the dataset,
The classification procedure is to 
allocate the sample with gene `signature' $x_i$ to class $F$ when
\[
LD(x_i) = (\mu_F - \mu_N)^t \Sigma^{-1}(x_i - .5(\mu_F+\mu_N)) > \log(\pi_F/\pi_N).
\]

For this to be feasible on modest hardware, we need to filter the
genes in use.  We use genefilter's \texttt{nsFilter} procedure to
eliminate genes with relatively low variability across samples.
<<dof,keep.source=TRUE>>=
library(genefilter)
ffbALL = nsFilter(fbALL, var.func=var, var.cutoff=.9)
ffbALL[[2]] # check exclusion events
ffbALL = ffbALL[[1]] # keep only ExpressionSet
@

Now we construct a cross-validated linear discriminant analysis
using all filtered genes.
<<dold,cache=TRUE>>=
lda1 = MLearn(mol.biol~., ffbALL, ldaI, xvalSpec("LOG", 5, 
   balKfold.xvspec(5)))
<<lklddd>>=
mm = confuMat(lda1)
mcr = (sum(mm)-sum(diag(mm)))/sum(mm)
mcr
@

Is this a legitimate application?  Is \Sexpr{round(mcr,3)} a good
estimate of the misclassification rate of the procedure?  Perhaps
not, because feature selection was conducted outside the cross-validation
procedure.  The set of genes filtered away will differ from
iteration to iteration of the cross-validation.  This process
can be factored into our cross-validation using the \texttt{fsFun}
parameter of \texttt{xvalSpec}.  Ideally we would apply this
feature selection process to the full fbALL ExpressionSet but
on a small computer this seems to cause problems.  We illustrate
with only 2500 genes:

<<doxv,cache=TRUE>>=
lda2 = MLearn(mol.biol~., fbALL[1:2500,], ldaI, xvalSpec("LOG", 5, 
   balKfold.xvspec(5), fsFun=fs.topVariance(.9)))
<<lkcc>>=
lda2
confuMat(lda2)
length(fsHistory(lda2)[[1]])
@
\subsection{Summary}
\bi
\item ExpressionSets store assay and sample-level data from microarray
experiments;
\item Manual application of standard statistical modeling tools to
test specific gene effects is feasible, but variation in calling sequence
and return values reduces efficiency of application and interpretation;
\item MLInterfaces MLearn supports  direct application of supervised
learning methods to ExpressionSet instances
\bi
\item standard formula interface may refer to any phenoData variable for
response
\item learnerSchema instances select the algorithm to be used; we
looked at glmI.logistic and ldaI
\item cross-validation is supported through the xvalSpec object
\item algorithmic feature selection can be embedded in cross-validation
\ei
\item MLearn returns a structured object responding to \texttt{confuMat},
\texttt{RObject}, and, when relevant, \texttt{fsHistory}
\ei

\section{Some technical details of MLInterfaces}
\subsection{The signature of MLearn}
<<lkm>>=
showMethods("MLearn")
@

\subsection{Available learnerSchema instances}
<<lkls>>=
grep(".*I($|\\.)", ls("package:MLInterfaces"), value=TRUE)
@

You can add your own schemata for new learning functions.  See the
vignette MLint\_devel.

\subsection{Tuning}

You can set additional parameters in the ... argument place
to MLearn.  Eventually a tuningSpec object will be defined to
control this.

\section{Supervised learning: Additional illustrations}

\subsection{CART}

Decision trees are attractive models for certain investigations.
If the process under study has a hierarchical structure, so that
some features decompose the population at a high level, and others
operate within lower level components, a tree-structured model
may be useful.  Classification And Regression Trees (CART) denotes
a family of algorithms that aggressively sift through features
in a recursive series of splits of the data.  At the first stage,
all the data live in a root tree node.  All features are dichotomized
in all possible ways and the node is split using the feature
that leads to two nodes that are most pure in distribution of
the class label according to some
user-selected metric such as the Gini index or the deviance.
The process recurses in the new nodes.  The tree construction
proceeds until nodes reach some minimal size, and then it may be
pruned back.  Details can be found in Ripley, Pattern Recognition and
Neural Networks, 1995.

<<dorp,cache=TRUE>>=
rp1 = MLearn(mol.biol~., ffbALL, rpartI, xvalSpec("LOG", 5, 
   balKfold.xvspec(5)))
<<dodtrtr>>=
confuMat(rp1)
@

Each fit yields an extensive summary.
<<lks>>=
summary(RObject(RObject(rp1)[[1]]$mlans))
@

We have cross-validated and can inspect the tree for each iteration:
<<dofirp, fig=TRUE>>=
  tr1 = RObject(RObject(rp1)[[1]]$mlans)
  plot(tr1, uniform=TRUE, branch=.2, compress=TRUE, margin=.1, main=
    paste("xval tree", 1))
  text(tr1, all=TRUE, use.n=TRUE, fancy=TRUE, pretty=TRUE)
@

<<dofirp2, fig=TRUE>>=
  tr2 = RObject(RObject(rp1)[[2]]$mlans)
  plot(tr2, uniform=TRUE, branch=.2, compress=TRUE, margin=.1, main=
    paste("xval tree", 2))
  text(tr2, all=TRUE, use.n=TRUE, fancy=TRUE, pretty=TRUE)
@

\subsubsection*{Exercises}
\bi
\item The trees visualized here are not as informative as they
would be if gene symbols were used for probe sets.
Alter ffbALL so that the featureNames are symbols and generate
a better plot.

You could use code like
<<doadad,eval=FALSE>>=
X = featureNames(ffbALL)
library(hgu95av2.db)
SX = mget(X, hgu95av2SYMBOL)
any(duplicated(unlist(SX)))
featureNames(ffbALL) = SSX
rrp1 = MLearn(mol.biol~., ffbALL, rpartI, xvalSpec("LOG", 5,
   balKfold.xvspec(5)))
@

\item Create a deeper set of trees by specifying an option
defined in rpart.control.  For example, set minsplit=3.
Use \texttt{plotcp} on the resulting tree objects and interpret.
\ei

\subsection{Random forests and variable importance assessment}

Leo Breiman extended the tree structured modeling approach
by integrating random feature and case selection over
a long sequence of tree fits.  Voting over the tree sequence 
is used to create the classifier.

According to wikipedia,
``Each tree is constructed using the following algorithm:
\bi
\item
   Let the number of training cases be N, and the number of variables in the classifier be M.
\item
   We are told the number m of input variables to be used to determine the decision at a node of the tree; m should be much less than M.
\item
    Choose a training set for this tree by choosing N times with replacement from all N available training cases (i.e. take a bootstrap sample). Use the rest of the cases to estimate the error of the tree, by predicting their classes.
\item
    For each node of the tree, randomly choose m variables on which to base the decision at that node. Calculate the best split based on these m variables in the training set.

\item
    Each tree is fully grown and not pruned (as may be done in constructing a normal tree classifier).
\ei

This is easy to use with MLearn.  Because of the
internal resampling, we do not need to cross-validate (unless
we really want to).

<<sdass>>=
set.seed(12345)
<<dorf1,cache=TRUE>>=
rf1 = MLearn(mol.biol~., ffbALL, randomForestI, xvalSpec("NOTEST"),
  importance=TRUE)
<<lkrc>>=
confuMat(rf1, "train")
@

The variable importance measure can be rendered as follows:
<<doimp,fig=TRUE>>=
par(las=2, mar=c(5,9,5,5))
plot(getVarImp(rf1, TRUE), plat="hgu95av2", toktype="SYMBOL")
@

\subsubsection*{Exercises}
\bi
\item Generate a textual report on the relative importance
measures, using \texttt{getVarImp}.
\item Compare the top genes identified via randomForest
to those identified via limma.  Comment on the added
learning provided by the machine learning algorithm.
\ei

\subsection{Regularized discriminant analysis}

This is an interesting algorithm in which LDA
is generalized in two directions.  First, the covariance
matrix of the data is modeled as a linear combination of
an identity matrix and the sample covariance matrix.
Second, features are dropped according to their distance from
sample centroids.  See the 2007 Biostatistics paper of Guo and Tibshirani for
details.

The code distributed by Guo et al has internal cross-validation
by which parameters $\alpha \in [0,1]$ (weight on the sample covariance
matrix, to which $1 - \alpha \times I$ is added to get the
effective covariance to be used in discriminant computation) and
$\delta$ (parameter dictating how features are dropped depending
on their distance from data centroids) are selected.  We therefore
use RDA in two stages, first to inspect the results of internal
cross-validation, and then to compute the predictors for the
`optimal' $\alpha$ and $\delta$.  (There are typically a range
of attractive values for these parameters.)

<<doadasd>>=
set.seed(12345)
<<do1,cache=TRUE>>=
rda1 = MLearn(mol.biol~., ffbALL, rdacvI, xvalSpec("NOTEST"))
@
We now retrieve the summary of cross-validation results:
<<do2>>=
attr(RObject(rda1), "xvalAns")
@
We see that values of $\alpha$ around .11 and $\delta$ around .33
lead to small numbers of errors in cross-validation.  Thus:
<<do3>>=
rda2 = MLearn(mol.biol~., ffbALL, rdaI, xvalSpec("NOTEST"), alpha=.11, delta=.333)
confuMat(rda2, "train")
@
\subsubsection*{Exercises}
\bi
\item There is a problem with the rendering of the confusion
matrix above.  Describe how to avoid it.
\item Obtain the list of `retained genes' by inspecting the rda2 object.
Compare to limma top table.
\ei


\subsection{Support vector machine}

An important variation on LDA is the support vector machine (SVM)
algorithm.  The basic ideas can be gleaned from a paper by
Kristin Bennett to be distributed at the course.

<<dosv>>=
svm1 = MLearn(mol.biol~., ffbALL, svmI, 
  xvalSpec("LOG", 5, balKfold.xvspec(5)), kernel="linear")
confuMat(svm1)
@

\subsubsection*{Exercises}
\bi
\item Examine the \texttt{tune} infrastructure of package e1071
and consider whether a selection of parameters for tuning
the svm can improve performance in this case.  To use
tune you will have to extract response and predictor
data and convert to appropriate formats.
\ei

\subsection{Boosting}

Random forests uses an ensemble of trees to generate
predictions; boosting uses very simple trees generated
along a sequence of data reweighting steps.  At each iteration,
data that are easy to classify are downweighted.  We use the
implementation in adaboost package; there are others.

This seems to be a very intensive algorithm and we run it
for a very short while for feasibility.  You may examine the
effects of reducing the feature set.

<<doada,cache=TRUE>>=
ada1 = MLearn(mol.biol~., ffbALL, adaI, 1:40, type="discrete",
  iter=20)
confuMat(ada1)
@

\section{Unsupervised learning in brief}

Unsupervised learning occurs in the absence of class labels.
In essence, one is trying to learn both the class labels
and the rules for attaching them to objects yet unseen.

Cluster analysis is widely used, is propagated through
heatmap displays, and has substantial conceptual defects.
We will not discuss it unless there is extra time.

\subsection{PCA and biplots}

To discuss principal components and dimension reduction, we
use a simpler data set: the crabs data set in the MASS package.
Consider the following display:

<<doap,fig=TRUE>>=
pairs(crabs[,-c(1:3)], col=ifelse(crabs$sp=="B", "blue", "orange"))
@

Various crab body measurements are plotted against each other.
Clearly there are high correlations between certain variables
and it would be useful to focus on measures that are
independently informative on the relationship between
crab size and species.  Such independently informative
measures can be constructed using linear combinations of the
raw measurements.

\subsubsection{PCA defined and illustrated}

Principal components analysis transforms the multivariate
data X into a new coordinate system.  If the original variables
are X1, \ldots, Xp, then the variables in the new representation
are denoted PC1, \ldots, PCp.  These new variables have
the properties that PC1 is the linear combination of the X
having maximal variance, PC2 is the variance-maximizing linear combination of
residuals of X after projecting on PC1, and so on.
If most of the variation in $X_{n \times p}$ can be captured in
a low dimensional linear subspace of the space spanned
by the columns of $X$, scatterplots of
the first few principal
components will depict this.

Formally, we can compute the PC using the singular value decomposition of
$X$, in which $X = UDV^t$, where $U_{n \times p}$ and $V_{p \times p}$
are orthonormal, and $D$ is a diagonal matrix of $p$ nonnegative
singular values.  The principal components transformation is
$XV = UD$, and if $D$ is structured so that $D_{ii} \geq D_{jj}$ whenever
$i > j$, then column $i$ of $XV$ is PCi.  Note also that $D_{ii} =
\sqrt{n-1}\mbox{SD}$ PCi.

<<dopc>>=
library(MASS)
data(crabs)
pcs = prcomp( crabs[,-c(1:3)] )
<<lkscr,fig=TRUE>>=
plot(pcs)
<<lkpc, fig=TRUE>>=
pairs(pcs$x, col=ifelse(crabs$sp=="B", "blue", "orange"))
@

\subsubsection{Biplots: superimposing samples and variables after
dimension reduction}

The biplot shows the data in PC space and also shows the
relative contributions of the original variables in composing
the transformation.

<<dobi,fig=TRUE>>=
biplot(pcs, choices=2:3)
@


In addition to the sample representation in PC1-PC2,
we have a representation of the original variables
and their roles in defining the principal components
transformation.  The right-hand and top axes measure
the first and second components of the eigenvectors
corresponding to the original variables.

A formal definition of the biplot procedure is given in
Venables and Ripley, and is worth reviewing.  Rows of $X$ are
observations and columns are variables.  A rank-2 approximation
to $X$ is obtained via singular value decomposition, setting
all but the largest two singular values to zero.
Now
\[
X \approx [u_1 u_2] \left[ \begin{array}{cc}
  \lambda_1 & 0 \\
  0 & \lambda_2
 \end{array}
     \right] \left[
   \begin{array}{c} v_1^t \\ v_2^t \end{array} \right] = GH^t
\]
and various approaches can
be entertained for absorption of the eigenvalues $\lambda_i$ into $G$ and $H$.
A two-parameter system for doing this is
\[
G = n^{\alpha/2}
 [u_1 u_2] \left[ \begin{array}{cc}
  \lambda_1 & 0 \\
  0 & \lambda_2
 \end{array}
     \right]^{1-\theta}~,~~~
H = n^{\alpha/2}
 [v_1 v_2] \left[ \begin{array}{cc}
  \lambda_1 & 0 \\
  0 & \lambda_2
 \end{array}
     \right]^{\theta}.
\]
The ``principal component biplot'' sets $\alpha = \theta = 1$,
and consists in plotting rows of $G$ and $H$ with distinguished
symbols.  Euclidean distances between rows of $G$ represent
Mahalanobis distances between observations; inner products betwen
rows of $H$ represent covariances between variables.

\subsubsection*{Exercise}
Create a  biplot using the gene expression data from ALL,
focusing on genes found to be predictive by randomForests.
Interpret.

\end{document}

%
% NOTE -- ONLY EDIT THE .Rnw FILE!!!  The .tex file is
% likely to be overwritten.
%
\documentclass[12pt]{article}

\usepackage{amsmath}
\usepackage[authoryear,round]{natbib}
\usepackage{hyperref}


\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}


\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Rfunarg}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}

\textwidth=6.2in

\bibliographystyle{plainnat} 
 
\begin{document}
%\setkeys{Gin}{width=0.55\textwidth}

\title{Notes on non-syntactic names}
\author{VJ Carey}
\maketitle

\section{Objective}

We want to be able to handle non-syntactic names in formulae
with minimal added infrastructure.  Let's see an example.
<<getALL>>=
if (!("ALL" %in% search())) library(ALL)
if (!exists("ALL")) data(ALL)
lit = t(exprs(ALL)[1:5,])
lit[1:3,1:4]
dlit = data.frame(lit, neg=factor(ALL$mol.biol=="NEG"))
dlit[1:3,1:4]
dlit2 = data.frame(lit, neg=factor(ALL$mol.biol=="NEG"), check.names=FALSE)
dlit2[1:3,1:4]
@

\section{GLM and others that work without change}
<<dog>>=
library(randomForest)
library(MASS)
glm(neg~., data=dlit, fam=binomial)
glm(neg~., data=dlit2, fam=binomial) 
randomForest(neg~., data=dlit2, fam=binomial) 
lda(neg~., data=dlit2, fam=binomial) 
@

\section{RPART}
<<dor>>=
library(rpart)
rpart(neg~., data=dlit)
lk = try(rpart(neg~., data=dlit2))
lk
@
In rpart, we have

\begin{verbatim}
 lapply(m[attr(Terms, "term.labels")], tfun)
\end{verbatim}
and the backticks need to be removed for the selection in m.  In other words
defining
\begin{verbatim}
 cleanTick = function(x) gsub("`", "", x)
\end{verbatim}
and using
\begin{verbatim}
 lapply(m[cleanTick(attr(Terms, "term.labels"))], tfun)
\end{verbatim}
moves us along a bit.  We also need a change to rpart.matrix, at
\begin{verbatim}
    else x <- as.matrix(frame[cleanTick(predictors)])
\end{verbatim}

\section{NNET}
<<dnn>>=
library(nnet)
nnet(neg~., data=dlit, size=2)
lk = try(nnet(neg~., size=2, data=dlit2))
lk
@
if we modify
\begin{verbatim}
> .getXlevels
function (Terms, m) 
{
    xvars <- sapply(attr(Terms, "variables"), deparse, width.cutoff = 500)[-1]
    if ((yvar <- attr(Terms, "response")) > 0) 
        xvars <- cleanTick(xvars[-yvar]) # change here
    if (length(xvars) > 0) {
        xlev <- lapply(m[xvars], levels)
        xlev[!sapply(xlev, is.null)]
    }
    else NULL
}
\end{verbatim}
the function works.

\section{Standalone approach}

<<sta>>=
set.seed(123)
x = matrix(rnorm(40),nr=8)
colnames(x) = paste(1001:1005,"_at", sep="")
X = data.frame(x, check.names=FALSE)
glm(`1005_at`~., data=X)
library(MASS)
lda(I(`1005_at`>0)~., data=X)
library(nnet)
try(nnet(I(`1005_at`>0)~., data=X, size=2))
library(rpart)
try(rpart(I(`1005_at`>0)~., data=X))
@

\begin{verbatim}

traceback for nnet:

Error in `[.data.frame`(m, xvars) : undefined columns selected

Enter a frame number, or 0 to exit   

1: try(nnet(I(`1005_at` > 0) ~ ., data = X, size = 2))
2: nnet(I(`1005_at` > 0) ~ ., data = X, size = 2)
3: nnet.formula(I(`1005_at` > 0) ~ ., data = X, size = 2)
4: .getXlevels(Terms, m)
5: lapply(m[xvars], levels)
6: is.vector(X)
7: m[xvars]
8: `[.data.frame`(m, xvars)

traceback for rpart

Error in `[.data.frame`(frame, predictors) : 
        undefined columns selected

Enter a frame number, or 0 to exit   

1: try(rpart(I(`1005_at` > 0) ~ ., data = X))
2: rpart(I(`1005_at` > 0) ~ ., data = X)
3: rpart.matrix(m)
4: as.matrix(frame[predictors])
5: frame[predictors]
6: `[.data.frame`(frame, predictors)

\end{verbatim}

\begin{verbatim}
solution for nnet:

> .getXlevels2
function (Terms, m) 
{
    detick = function(x) gsub("`","",x)
    xvars <- sapply(attr(Terms, "variables"), deparse, width.cutoff = 500)[-1]
    if ((yvar <- attr(Terms, "response")) > 0) 
        xvars <- detick(xvars[-yvar])
    if (length(xvars) > 0) {
        xlev <- lapply(m[xvars], levels)
        xlev[!sapply(xlev, is.null)]
    }
    else NULL
}
\end{verbatim}



\end{document}

\name{classifierOutput-class}
\docType{class}
\alias{classifierOutput-class}
%\alias{confuMat,classifierOutput-method}
\alias{RObject,classifierOutput-method}
\alias{RObject}
\alias{trainInd,classifierOutput-method}
\alias{trainInd}
\alias{show,classifierOutput-method}
\alias{testScores,classifierOutput-method}
\alias{trainScores,classifierOutput-method}
\alias{predictions,classifierOutput-method}
\alias{predictions}
\alias{predScores,classifierOutput-method}
\alias{predScores}
\alias{predScore,classifierOutput-method}
\alias{predScore}
\alias{testPredictions,classifierOutput-method}
\alias{testPredictions}
\alias{trainPredictions}
\alias{trainPredictions,classifierOutput-method}
\alias{fsHistory,classifierOutput-method}
\alias{testScores}
\alias{trainScores}
\alias{testPredictions}
%\alias{fsHistory}

\title{Class "classifierOutput"}
\description{
This class summarizes the output values from different classifiers.}
\section{Objects from the Class}{
Objects are typically created during the application of a supervised 
machine learning algorithm to data and are the value returned.  It is very
unlikely that any user would create such an object by hand.
}
\section{Slots}{
  \describe{
    \item{\code{testOutcomes}:}{Object of class \code{"factor"} that
      lists the actual outcomes in the records on the test set }
    \item{\code{testPredictions}:}{Object of class \code{"factor"} that
      lists the predictions of outcomes in the test set }
    \item{\code{testScores}:}{Object of class \code{"ANY"} -- this
      element will include matrices or vectors or arrays that include
      information that is typically related to the posterior probability
      of occupancy of the predicted class or of all classes.  The actual
      contents of this slot can be determined by inspecting the converter
      element of the learnerSchema used to select the model. }
    \item{\code{trainOutcomes}:}{Object of class \code{"factor"} that
      lists the actual outcomes in records on the training set }
    \item{\code{trainPredictions}:}{Object of class \code{"factor"} that
      lists the predicted outcomes in the training set }
    \item{\code{trainScores}:}{Object of class \code{"ANY"} see
      the description of \code{testScores} above; the same information
      is returned, but applicable to the training set records.
    }
    \item{\code{trainInd}:}{Object of class \code{"numeric"} with of
      indices of data to be used for training. }
    \item{\code{RObject}:}{Object of class \code{"ANY"} -- when
      the \code{trainInd} parameter of the \code{MLearn} call is
      numeric, this slot holds
      the return value of the underlying R function that carried out
      the predictive modeling.  For example, if \code{rpartI} was used
      as MLearn \code{method}, \code{Robject} holds an instance of the
      \code{rpart} S3 class, and \code{plot} and \code{text} methods
      can be applied to this.  When the \code{trainInd} parameter
      of the \code{MLearn} call is an instance of
      \code{\linkS4class{xvalSpec}}, this slot holds a \code{list} of
      results of cross-validatory iterations.  Each element of this
      list has two elements: \code{test.idx}, giving the numeric
      indices of the test cases for the associated cross-validation
      iteration, and \code{mlans}, which is the \code{\linkS4class{classifierOutput}}
      for the associated iteration.  See the example for an illustration
      of 'digging out' the predicted probabilities associated with each
      cross-validation iteration executed through an xvalSpec specification. }
    \item{\code{embeddedCV}:}{logical value that is TRUE if
      the procedure in use performs its own cross-validation}
    \item{\code{fsHistory}:}{list of features selected
      through cross-validation process}
    \item{\code{learnerSchema}:}{propagation of the learner
      schema object used in the call}
    \item{\code{call}:}{Object of class \code{"call"} -- records the
      call used to generate the classifierOutput RObject }
  }
}

\section{Methods}{
  \describe{
    \item{confuMat}{\code{signature(obj = "classifierOutput")}: Compute
    the confusion matrix for test records. }
    \item{confuMatTrain}{\code{signature(obj = "classifierOutput")}: Compute
    the confusion matrix for training set.  Typically yields optimistically biased
    information on misclassification rate. }
    \item{RObject}{\code{signature(obj = "classifierOutput")}: The R object
     returned by the underlying classifier. This can then be passed on to
     specific methods for those objects, when they exist. }
   \item{trainInd}{\code{signature(obj = "classifierOutput")}: Returns
     the indices of data used for training. } 
   \item{show}{\code{signature(object = "classifierOutput")}: A print method
     that provides a summary of the output of the classifier. }
   \item{predictions}{\code{signature(object = "classifierOutput")}: Print
     the predicted classes for each sample/individual. The predictions
     for the training set are the training outcomes. }
   \item{predictions}{\code{signature(object = "classifierOutput", t
       = "numeric")}: Print the predicted classes for each
     sample/individual that have a \code{testScore} greater or equal
     than \code{t}. The predictions for the training set are the
     training outcomes.  Non-predicted cases and cases that 
     matche multiple classes are returned as \code{NA}s.}
   \item{predScore}{\code{signature(object = "classifierOutput")}:
     Returns the scores for predicted class for each 
     sample/individual. The scores for the training set are set to 1. } 
   \item{predScores}{\code{signature(object = "classifierOutput")}:
     Returns the prediction scores for all classes for each
     sample/individual. The scores for the training set are set to 1 for
     the appropriate class, 0 otherwise.}
   \item{testScores}{\code{signature(object = "classifierOutput")}: ... }
   \item{testPredictions}{\code{signature(object = "classifierOutput")}: Print
     the predicted classes for each sample/individual in the test set. }
   \item{testPredictions}{\code{signature(object = "classifierOutput", t
       = "numeric")}: Print the predicted classes for each
     sample/individual in the test set that have a \code{testScore}
     greater or equal than \code{t}. Non-predicted cases and cases that
     matche multiple classes are returned as \code{NA}s.}
   \item{trainScores}{\code{signature(object = "classifierOutput")}: ... }
   \item{trainPredictions}{\code{signature(object =
       "classifierOutput")}: Print the predicted classes for each
     sample/individual in the train set. } 
   \item{trainPredictions}{\code{signature(object = "classifierOutput", t
       = "numeric")}: Print the predicted classes for each
     sample/individual in the train set that have a \code{testScore}
     greater or equal than \code{t}. Non-predicted cases and cases that
     matche multiple classes are returned as \code{NA}s.}
   \item{fsHistory}{\code{signature(object = "classifierOutput")}: ... }
 }
}
\author{ V. Carey }
%\seealso{
%	~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%	or \code{\linkS4class{CLASSNAME}} for links to other classes
%}
\examples{
showClass("classifierOutput")
library(golubEsets)
data(Golub_Train) # now cross-validate a neural net
set.seed(1234)
xv5 = xvalSpec("LOG", 5, balKfold.xvspec(5))
m2 = MLearn(ALL.AML~., Golub_Train[1000:1050,], nnetI, xv5, 
   size=5, decay=.01, maxit=1900 )
testScores(RObject(m2)[[1]]$mlans)
alls = lapply(RObject(m2), function(x) testScores(x$mlans))
}
\keyword{classes}

\name{fs.absT}
\alias{fs.absT}
\alias{fs.probT}
\alias{fs.topVariance}
\title{ support for feature selection in cross-validation}
\description{ support for feature selection in cross-validation}
\usage{
fs.absT(N)
fs.probT(p)
fs.topVariance(p)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{N}{ number of features to retain; features are ordered
by descending value of abs(two-sample t stat.), and the top N are
used. }
  \item{p}{ cumulative probability (in (0,1)) in the distribution of absolute t statistics
above which we retain features}
}
\details{
This function returns a function that will be used as a parameter
to \code{\link{xvalSpec}} in applications of \code{\link{MLearn}}.
}
\value{
a function is returned, that will itself return a formula
consisting of the selected features for application of \code{\link{MLearn}}.
}
%\references{ ~put references to the literature/web site here ~ }
\author{ VJ Carey <stvjc@channing.harvard.edu> }
\note{ The functions \code{fs.absT} and \code{fs.probT} are
two examples of approaches to embedded feature selection that make
sense for two-sample prediction problems.  For selection based on
linear models or other discrimination measures, you will need to create
your own selection helper, following the code in these functions as
examples.

fs.topVariance performs non-specific feature selection based on the 
variance.  Argument p is the variance percentile beneath which features are
discarded.
}
\seealso{ \code{\link{MLearn}} }
\examples{
library("MASS")
data(crabs)
# we will demonstrate this procedure with the crabs data.
# first, create the closure to pick 3 features
demFS = fs.absT(3)
# run it on the entire dataset with features excluding sex
demFS(sp~.-sex, crabs)
# emulate cross-validation by excluding last 50 records
demFS(sp~.-sex, crabs[1:150,])
# emulate cross-validation by excluding first 50 records -- different features retained
demFS(sp~.-sex, crabs[51:200,])
}
\keyword{ models }% __ONLY ONE__ keyword per line

\name{RAB}
\alias{RAB}
\alias{RAB4es}
\alias{DAB}
\alias{Predict}
\alias{tonp}
\alias{mkfmla}
\alias{Predict,raboostCont-method}
\alias{Predict,daboostCont-method}
\title{real adaboost (Friedman et al) }
\description{
read adaboost ... a demonstration version
}
\usage{
RAB(formula, data, maxiter=200, maxdepth=1)
}
\arguments{
  \item{formula}{ formula -- the response variable must be coded -1, 1}
  \item{data}{ data}
  \item{maxiter}{ maxiter}
  \item{maxdepth}{ maxdepth -- passed to rpart}
}
%\details{
%}
\value{
an instance of raboostCont
}
\references{Friedman et al Ann Stat 28/2 337  }
\author{Vince Carey <stvjc@channing.harvard.edu>}
%\note{  }


%\seealso{  }

\examples{
library(MASS)
library(rpart)
data(Pima.tr)
data(Pima.te)
Pima.all = rbind(Pima.tr, Pima.te)
tonp = ifelse(Pima.all$type == "Yes", 1, -1)
tonp = factor(tonp)
Pima.all = data.frame(Pima.all[,1:7], mtype=tonp)
fit1 = RAB(mtype~ped+glu+npreg+bmi+age, data=Pima.all[1:200,], maxiter=10, maxdepth=5)
pfit1 = Predict(fit1, newdata=Pima.tr)
table(Pima.tr$type, pfit1)
}
\keyword{ models }

\name{planarPlot-methods}
\docType{methods}
\alias{planarPlot}
\alias{planarPlot-methods}
\alias{planarPlot,classifierOutput,ExpressionSet,character-method}
\alias{planarPlot,classifierOutput,data.frame,character-method}
\title{ Methods for Function planarPlot in Package `MLInterfaces' }
\description{
show the classification boundaries on the plane dictated
by two genes in an ExpressionSet
}
\section{Methods}{
\describe{
\item{clo = "classifierOutput", eset = "ExpressionSet", classifLab = "character"}{ uses two genes in the ExpressionSet
to exhibit the decision boundaries in the plane}
\item{clo = "classifierOutput", eset = "data.frame", classifLab = "character"}{ uses two columns in the data.frame
to exhibit the decision boundaries in the plane}
}
}
\examples{
library(ALL)
library(hgu95av2.db)
data(ALL)
#
# restrict to BCR/ABL or NEG
#
bio <- which( ALL$mol.biol \%in\% c("BCR/ABL", "NEG"))
#
# restrict to B-cell
#
isb <- grep("^B", as.character(ALL$BT))
kp <- intersect(bio,isb)
all2 <- ALL[,kp]
#
# sample 2 genes at random
#
set.seed(1234)
ng <- nrow(exprs(all2)) # pick 5 in case any NAs come back
pick <- sample(1:ng, size=5, replace=FALSE)
gg <- all2[pick,]
sym <- unlist(mget(featureNames(gg), hgu95av2SYMBOL))
bad = which(is.na(sym))
if (length(bad)>0) {
  gg = gg[-bad,]
  sym = sym[-bad]
  }
gg = gg[1:2,]
sym = sym[1:2]
featureNames(gg) <- sym
gg$class = factor(ifelse(all2$mol.biol=="NEG", "NEG", "POS"))

cl1 <- which( gg$class == "NEG" )
cl2 <- which( gg$class != "NEG" )
#
# create balanced training sample
#
trainInds <- c( sample(cl1, size=floor(length(cl1)/2) ),
      sample(cl2, size=floor(length(cl2)/2)) )
#
# run rpart
#
tgg <- MLearn(class~., gg, rpartI, trainInds, minsplit=4 )
opar <- par(no.readonly=TRUE)
par(mfrow=c(2,2))
planarPlot( tgg, gg, "class" )
title("rpart")
points(exprs(gg)[1,trainInds], exprs(gg)[2,trainInds], col=ifelse(gg$class[trainInds]=="NEG", "yellow", "black"), pch=16)
#
# run nnet
#
ngg <- MLearn( class~., gg, nnetI, trainInds, size=8 )
planarPlot( ngg, gg, "class" )
points(exprs(gg)[1,trainInds], exprs(gg)[2,trainInds], col=ifelse(gg$class[trainInds]=="NEG", "yellow", "black"), pch=16)
title("nnet")
#
# run knn
#
kgg <- MLearn( class~.,  gg, knnI(k=3,l=1), trainInds)
planarPlot( kgg, gg, "class" )
points(exprs(gg)[1,trainInds], exprs(gg)[2,trainInds], col=ifelse(gg$class[trainInds]=="NEG", "yellow", "black"), pch=16)
title("3-nn")
#
# run svm
#
sgg <- MLearn( class~., gg, svmI, trainInds )
planarPlot( sgg, gg, "class" )
points(exprs(gg)[1,trainInds], exprs(gg)[2,trainInds], col=ifelse(gg$class[trainInds]=="NEG", "yellow", "black"), pch=16)
title("svm")
par(opar)
}
\keyword{methods}

\name{projectLearnerToGrid}
\alias{projectLearnerToGrid}

\title{
create learned tesselation of feature space after PC transformation
}
\description{
create learned tesselation of feature space after PC transformation
}
\usage{
projectLearnerToGrid(formula, data, learnerSchema, 
   trainInds, ..., 
   dropIntercept = TRUE, 
   ngpts = 20, 
   predExtras = list(), 
   predWrapper = force)
}

\arguments{
  \item{formula}{
standard formula, typically of the form "y~." where y denotes
the class label variable to be predicted by all remaining features
in the input data frame
}
  \item{data}{
a data.frame instance
}
  \item{learnerSchema}{
an instance of \code{\link{learnerSchema-class}}
}
  \item{trainInds}{
integer vector of rows of \code{data} to use for training
}
  \item{\dots}{
additional parameters for use with \code{learnerSchema}
}
  \item{dropIntercept}{
logical indicating whether to include column of 1s among feature
column-vectors
}
  \item{ngpts}{
number of equispaced points along the range of each input feature
to use in forming a grid in feature space
}
  \item{predExtras}{
a list with named elements giving binding to extra parameters needed
to predict labels for the learner in use.  For example, with 
\code{ldaI}, set \code{predExtras=list(type="class")}
}
  \item{predWrapper}{
Sometimes a function call is needed to extract the predicted
labels from the RObject applied to the \code{fittedLearner}
slot of the output object; this parameter defines that call.
}
}



\value{
instance of \code{\link{projectedLearner-class}}





}
\references{
none.
}
\author{
VJ Carey <stvjc@channing.harvard.edu>
}









\examples{
library(mlbench)
# demostrate with 3 dimensional hypercube problem
kk = mlbench.hypercube()
colnames(kk$x) = c("f1", "f2", "f3")
hcu = data.frame(cl=kk$classes, kk$x)
set.seed(1234)
sam = sample(1:nrow(kk$x), size=nrow(kk$x)/2)
ldap = projectLearnerToGrid(cl~., data=hcu, ldaI, 
   sam, predWrapper=function(x)x$class)
plot(ldap)
confuMat(ldap@fittedLearner)
nnetp = projectLearnerToGrid(cl~., data=hcu, nnetI, sam, size=2,
   decay=.01, predExtras=list(type="class"))
plot(nnetp)
confuMat(nnetp@fittedLearner)
#if (requireNamespace("rgl") && interactive()) {
#    learnerIn3D(nnetp)
#    ## customising the rgl plot
#    learnerIn3D(nnetp, size = 10, alpha = 0.1)
#}
}


\keyword{ models }

\name{balKfold.xvspec}
\alias{balKfold.xvspec}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ generate a partition function for cross-validation,
where the partitions are approximately balanced with respect to
the distribution of a response variable}
\description{generate a partition function for cross-validation,
where the partitions are approximately balanced with respect to
the distribution of a response variable}
\usage{
balKfold.xvspec(K)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{K}{ number of partitions to be computed }
}
\details{
This function returns a closure.  The symbol \code{K} is
bound in the environment of the returned function.
}
\value{
A closure consisting of a function that can be used
as a \code{partitionFunc} for passage in \code{\link{xvalSpec}}.
}
%\references{ ~put references to the literature/web site here ~ }
\author{ VJ Carey <stvjc@channing.harvard.edu> }
%\note{ ~~further notes~~ 

% ~Make other sections like Warning with \section{Warning }{....} ~
%}
%\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
\examples{
## The function is currently defined as
function (K) 
function(data, clab, iternum) {
    clabs <- data[[clab]]
    narr <- nrow(data)
    cnames <- unique(clabs)
    ilist <- list()
    for (i in 1:length(cnames)) ilist[[cnames[i]]] <- which(clabs == 
        cnames[i])
    clens <- lapply(ilist, length)
    nrep <- lapply(clens, function(x) ceiling(x/K))
    grpinds <- list()
    for (i in 1:length(nrep)) grpinds[[i]] <- rep(1:K, nrep[[i]])[1:clens[[i]]]
    (1:narr)[-which(unlist(grpinds) == iternum)]
  }
# try it out
library("MASS")
data(crabs)
p1c = balKfold.xvspec(5)
inds = p1c( crabs, "sp", 3 )
table(crabs$sp[inds] )
inds2 = p1c( crabs, "sp", 4 )
table(crabs$sp[inds2] )
allc = 1:200
# are test sets disjoint?
intersect(setdiff(allc,inds), setdiff(allc,inds2))
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ models }
\keyword{ manip }

\name{learnerSchema-class}
\docType{class}
\alias{learnerSchema-class}
\alias{nonstandardLearnerSchema-class}
\alias{show,learnerSchema-method}

\title{Class "learnerSchema" -- convey information on a machine learning
function to the MLearn wrapper }
\description{	 conveys information about machine learning functions in
CRAN packages, for example, to MLearn wrapper }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("learnerSchema", ...)}.
}
\section{Slots}{
	 \describe{
    \item{\code{packageName}:}{Object of class \code{"character"} string naming the
package in which the function to be used is defined. }
    \item{\code{mlFunName}:}{Object of class \code{"character"} string naming
the function to be used }
    \item{\code{converter}:}{Object of class \code{"function"} function with parameters
obj, data, trainInd, that will produce a classifierOutput instance }
  }
}
\section{Methods}{
  \describe{
    \item{MLearn}{\code{signature(formula = "formula", data = "ExpressionSet", method = "learnerSchema", trainInd = "numeric")}: execute desired learner passing a formula
and ExpressionSet}
    \item{MLearn}{\code{signature(formula = "formula", data = "data.frame", method = "learnerSchema", trainInd = "numeric")}: execute desired learner passing a formula }
    \item{show}{\code{signature(object = "learnerSchema")}: concise display }
	 }
}
%\references{ ~put references to the literature/web site here ~ }
\author{ Vince Carey <stvjc@channing.harvard.edu>}
%\note{ ~~further notes~~ }

% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{
%	~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%	or \code{\linkS4class{CLASSNAME}} for links to other classes
%}
\examples{
showClass("learnerSchema")
}
\keyword{classes}

\name{xvalSpec}
\alias{xvalSpec}
\alias{xvalSpec-class}

\title{container for information specifying a cross-validated
machine learning exercise}
\description{container for information specifying a cross-validated
machine learning exercise}
\usage{
xvalSpec(type, niter=0, 
         partitionFunc = function(data, classLab,iternum) { (seq_len(nrow(data)))[-iternum] },
         fsFun = function(formula, data) formula )
}
\arguments{

  \item{type}{a string, "LOO" indicating leave-one-out
cross-validation, or "LOG" indicating leave-out-group, or
"NOTEST", indicating the entire dataset is used in a single
training run.}

  \item{niter}{numeric specification of the number of
cross-validation iterations to use.  Ignored if \code{type}
is \code{"LOO"}.}
  \item{partitionFunc}{function, with parameters data (bound
to data.frame), clab (bound to character string), iternum (bound
to numeric index into sequence of 1:\code{niter}).  This function's job
is to provide the indices of training cases for each cross-validation
step.  An example is \code{\link{balKfold.xvspec}}, which computes
a series of indices that are approximately balanced with respect
to frequency of outcome types.}
  \item{fsFun}{function, with parameters formula, data.  The function
must return a formula suitable for defining a model on the basis of the
main input data.  A candidate fsFun  is given in example for fsHistory function.}
}
\details{
If \code{type == "LOO"}, no other parameters are inspected.
If \code{type == "LOG"} a value for \code{partitionFunc} must be
supplied.  We recommend using \code{balKfold.xvspec(K)}.  The
values of \code{niter} and \code{K} in this usage must be the same.
This redundancy will be removed in a future upgrade.

If the \code{parallel} package is attached and symbol \code{mc_fork} is loaded, cross-validation will
be distributed to cores using \code{\link{mclapply}}.
} % end details
\value{
An instance of \code{\linkS4class{classifierOutput}}, with a special
structure.  The \code{RObject} return slot is populated with a
list of \code{niter} cross-validation results.  Each element of this list
is itself a list with two elements: \code{test.idx} (the indices
of the test set for the associated cross-validation  iteration,
and \code{mlans}, the \code{\linkS4class{classifierOutput}} generated at
each iteration.  Thus there are \code{classifierOutput}
instances nested within the main \code{classifierOutput} returned
when a \code{xvalSpec} is used.
}
%\references{  }
\author{Vince Carey <stvjc@channing.harvard.edu>}
%\note{  }


%\seealso{  }

\examples{
library("MASS")
data(crabs)
set.seed(1234)
#
# demonstrate cross validation
#
nn1cv = MLearn(sp~CW+RW, data=crabs, nnetI, xvalSpec("LOG",
   5, balKfold.xvspec(5)), size=3, decay=.01 )
nn1cv
confuMat(nn1cv)
names(RObject(nn1cv)[[1]])
RObject(RObject(nn1cv)[[1]]$mlans)
}

\keyword{ models }

\name{performance-analytics}
\docType{methods}
\alias{precision-methods}
\alias{precision,classifierOutput,character-method}
\alias{precision,classifierOutput,missing-method}
\alias{precision,classifierOutput,numeric-method}
\alias{precision,table,missing-method}
\alias{precision}
\alias{recall-methods}
\alias{recall,classifierOutput,character-method}
\alias{recall,classifierOutput,missing-method}
\alias{recall,classifierOutput,numeric-method}
\alias{recall,table,missing-method}
\alias{recall}
\alias{sensitivity-methods}
\alias{sensitivity,classifierOutput,character-method}
\alias{sensitivity,classifierOutput,missing-method}
\alias{sensitivity,classifierOutput,numeric-method}
\alias{sensitivity,table,missing-method}
\alias{sensitivity}
\alias{macroF1-methods}
\alias{macroF1,classifierOutput,character-method}
\alias{macroF1,classifierOutput,missing-method}
\alias{macroF1,classifierOutput,numeric-method}
\alias{macroF1,table,missing-method}
\alias{macroF1,numeric,numeric-method}
\alias{macroF1}
\alias{acc,table-method}
\alias{acc}
\alias{specificity,table-method}
\alias{specificity}
\alias{tp,table-method}
\alias{tp}
\alias{tn,table-method}
\alias{tn}
\alias{fp,table-method}
\alias{fp}
\alias{fn,table-method}
\alias{fn}
\alias{F1,table-method}
\alias{F1}

\title{ Assessing classifier performance }

\description{
  Methods to calculate the number of true positives (\code{tp}),
  true negatives (\code{tn}), false negatives (\code{fn}),
  false positive (\code{fp}), accuracy (\code{acc}),  
  \code{precision}, \code{recall} (same as \code{sensitivity}),
  \code{specificity}, \code{F1} and \code{macroF1} scores.

  Each method also accepts an \code{naAs0} argument definiting if
  \code{NAs} should be replaced by \code{0} (default is \code{FALSE}).
}

\section{Methods}{
  Methods \code{tp}, \code{tn}, \code{fp}, \code{fn}, \code{F1},
  \code{acc} and \code{specificity}:
  \describe{
    \item{\code{signature(obj = "table")}}{ }
  }
  Methods \code{recall} (\code{sensitivity}), \code{precision} and
  \code{macroF1}: 
  \describe{
    \item{\code{signature(obj = "classifierOutput", type = "character")}}{
      %%  ~~describe this method here~~
    }
    \item{\code{signature(obj = "classifierOutput", type = "missing")}}{
      %%  ~~describe this method here~~
    }
    \item{\code{signature(obj = "classifierOutput", type = "numeric")}}{
      %%  ~~describe this method here~~
    }
    \item{\code{signature(obj = "table")}}{ }
  }
}

\examples{
## the confusion matrix
cm <- table(iris$Species, sample(iris$Species))
tp(cm)
tn(cm)
fp(cm)
fn(cm)
acc(cm)
precision(cm)
recall(cm)
F1(cm)
macroF1(cm)
}

\keyword{methods}

\name{projectedLearner-class}
\Rdversion{1.1}
\docType{class}
\alias{projectedLearner-class}
\alias{learnerIn3D,projectedLearner-method}
\alias{plot,projectedLearner,ANY-method}
\alias{plotOne,projectedLearner-method}
\alias{show,projectedLearner-method}
\alias{plotOne}
\alias{learnerIn3D}

\title{Class \code{"projectedLearner"}}
\description{
helps depict prediction hyperregions from high-dimensional models
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("projectedLearner", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{fittedLearner}:}{Object of class \code{"classifierOutput"}  }
    \item{\code{trainingSetPCA}:}{Object of class \code{"prcomp"} }
    \item{\code{trainingLabels}:}{Object of class \code{"ANY"} given
labels for features used in training }
    \item{\code{testLabels}:}{Object of class \code{"ANY"} given labels
for features used in testing }
    \item{\code{gridFeatsProjectedToTrainingPCs}:}{Object of class \code{"matrix"} rotated coordinates of training features }
    \item{\code{gridPredictions}:}{Object of class \code{"ANY"} predicted
labels for all grid points }
    \item{\code{trainFeatsProjectedToTrainingPCs}:}{Object of class \code{"matrix"} rotated coordinates of training features }
    \item{\code{testFeatsProjectedToTrainingPCs}:}{Object of class \code{"matrix"} rotated coordinates of test features }
    \item{\code{trainPredictions}:}{Object of class \code{"ANY"} predicted
labels for training features }
    \item{\code{testPredictions}:}{Object of class \code{"ANY"} predicted
labels for test features }
    \item{\code{theCall}:}{Object of class \code{"call"} call used to
generate this wonderful thing }
  }
}
\section{Methods}{
  \describe{   
    \item{learnerIn3D}{\code{signature(x = "projectedLearner")}: uses
      \code{rgl} to give a dynamic 3d-like projection of labels in
      colored regions.  See \code{\link{projectLearnerToGrid}} for an
      example.}
    \item{plot}{\code{signature(x = "projectedLearner", y = "ANY")}: pairs
      plot of the tesselated PCA of the training features }
    \item{plotOne}{\code{signature(x = "projectedLearner")}: a 2d plot
      of tesselation projection for selected axes of the PCA}
    \item{show}{\code{signature(object = "projectedLearner")}: object
      housing numerical resources for the renderings  }
  }
}
\references{
None.
}
\author{
VJ Carey <stvjc@channing.harvard.edu>
}
\note{
\code{plot} may need to be modified when there are many features/PCs in use

\code{plotOne} has additional arguments \code{ind1}, \code{ind2}, and \code{type}.  ind1 and ind2 specify the PCs to display.  type is one of 
\code{"showTestPredictions"} (default),
\code{"showTrainPredictions"},  
\code{"showTestLabels"},  
\code{"showTrainLabels"}.  These indicate what will be used to locate
glyphs with labels in the projected scatterplots.

}


\examples{
showClass("projectedLearner")
}
\keyword{classes}

\name{predict.classifierOutput}
\alias{predict.classifierOutput}


\title{
  Predict method for \code{classifierOutput} objects
}

\description{
  This function predicts values based on models trained with
  MLInterfaces' \code{MLearn} interface to many machine learning
  algorithms. 
}

\usage{
\method{predict}{classifierOutput}(object, newdata, ...)
}

\arguments{
  \item{object}{
    An instance of class \code{\linkS4class{classifierOutput}}.
  }
  \item{newdata}{
    An object containing the new input data: either a \code{matrix}, a
    \code{data.frame} or an \code{ExpressionSet}.
  }
  \item{\dots}{
    Other arguments to be passed to the algorithm-specific predict
    methods. 
  }
}

\details{
  This S3 method will extract the ML model from the
  \code{\linkS4class{classifierOutput}} instance and call either a
  generic predict method or, if available, a specficly written wrapper
  to do classes prediction and class probabilities. 
}

\value{
  Currently, a list with 
  \item{testPredictions}{A factor with class predictions.}
  \item{testScores}{A \code{numeric} or \code{matrix} with class
    probabilities.}
}

\author{
  Laurent Gatto <lg390@cam.ac.uk>
}

\note{
  The function output will most likely be updated in a near future to a
  \code{classifierOutput} (or similar) object.
}

\seealso{
  \code{\link{MLearn}} and \code{\linkS4class{classifierOutput}}.
}

\examples{
\dontrun{
set.seed(1234)
data(sample.ExpressionSet)
trainInd <- 1:16

clout.svm <- MLearn(type~., sample.ExpressionSet[100:250,], svmI, trainInd)
predict(clout.svm, sample.ExpressionSet[100:250,-trainInd])

clout.ksvm <- MLearn(type~., sample.ExpressionSet[100:250,], ksvmI, trainInd)
predict(clout.ksvm, sample.ExpressionSet[100:250,-trainInd])

clout.nnet <- MLearn(type~., sample.ExpressionSet[100:250,], nnetI, trainInd, size=3, decay=.01 )
predict(clout.nnet, sample.ExpressionSet[100:250,-trainInd])

clout.knn <- MLearn(type~., sample.ExpressionSet[100:250,], knnI(k=3), trainInd)
predict(clout.knn, sample.ExpressionSet[100:250,-trainInd],k=1)
predict(clout.knn, sample.ExpressionSet[100:250,-trainInd],k=3)

#clout.plsda <- MLearn(type~., sample.ExpressionSet[100:250,], plsdaI, trainInd)
#predict(clout.plsda, sample.ExpressionSet[100:250,-trainInd])

clout.nb <- MLearn(type~., sample.ExpressionSet[100:250,], naiveBayesI, trainInd)
predict(clout.nb, sample.ExpressionSet[100:250,-trainInd])

# this can fail if training set does not yield sufficient diversity in response vector;
# setting seed seems to help with this example, but other applications may have problems
#
clout.rf <- MLearn(type~., sample.ExpressionSet[100:250,], randomForestI, trainInd)
predict(clout.rf, sample.ExpressionSet[100:250,-trainInd])
} # end of dontrun
}

\name{varImpStruct-class}
\docType{class}
\alias{varImpStruct-class}
\alias{plot}
\alias{plot,varImpStruct-method}
\alias{plot,varImpStruct,ANY-method}
\alias{show,varImpStruct-method}
\alias{report,varImpStruct-method}
\alias{report}
\alias{getVarImp}
\alias{getVarImp,classifOutput,logical-method}
\alias{getVarImp,classifierOutput,logical-method}
\alias{getVarImp,classifierOutput,missing-method}
\title{Class "varImpStruct" -- collect data on variable importance
 from various machine learning methods}
\description{  collects data on variable importance }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("varImpStruct", ...)}.
These are matrices of importance measures with separate 
slots identifying algorithm generating the measures and
variable names.
}
\section{Slots}{
  \describe{
    \item{\code{.Data}:}{Object of class \code{"matrix"} actual importance
measures }
    \item{\code{method}:}{Object of class \code{"character"} tag }
    \item{\code{varnames}:}{Object of class \code{"character"} conformant
vector of names of variables }
  }
}
\section{Extends}{
Class \code{"matrix"}, from data part.
Class \code{"structure"}, by class \code{"matrix"}.
Class \code{"array"}, by class \code{"matrix"}.
Class \code{"vector"}, by class "matrix", with explicit coerce.
Class \code{"vector"}, by class "matrix", with explicit coerce.
}
\section{Methods}{
  \describe{
    \item{plot}{\code{signature(x = "varImpStruct")}: make a bar plot,
you can supply arguments \code{plat}
and \code{toktype} which will use \code{lookUp(...,plat,toktype)}
from the \code{annotate} package to translate probe names to, e.g.,
gene symbols.}
    \item{show}{\code{signature(object = "varImpStruct")}: simple abbreviated
display }
    \item{getVarImp}{\code{signature(object = "classifOutput", fixNames="logical")}: extractor
of variable importance structure; fixNames parameter is to remove leading X used
to make variable names syntactic by randomForest (ca 1/2008).  You can set fixNames to false
if using hu6800 platform, because all featureNames are syntactic as given.}
    \item{report}{\code{signature(object = "classifOutput", fixNames="logical")}: extractor
of variable importance data, with annotation; fixNames parameter is to remove leading X used
to make variable names syntactic by randomForest (ca 1/2008).  You can set fixNames to false
if using hu6800 platform, because all featureNames are syntactic as given.}
  }
}
%\references{ ~put references to the literature/web site here ~ }
%\author{ ~~who you are~~ }
%\note{ ~~further notes~~ }
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%
%\seealso{
%  ~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%  or \code{\link{CLASSNAME-class}} for links to other classes
%}
\examples{
library(golubEsets)
data(Golub_Merge)
library(hu6800.db)
smallG <- Golub_Merge[1001:1060,]
set.seed(1234)
opar=par(no.readonly=TRUE)
par(las=2, mar=c(10,11,5,5))
rf2 <- MLearn(ALL.AML~., smallG, randomForestI, 1:40, importance=TRUE,
 sampsize=table(smallG$ALL.AML[1:40]), mtry=sqrt(ncol(exprs(smallG))))
plot( getVarImp( rf2, FALSE ), n=10, plat="hu6800", toktype="SYMBOL")
par(opar)
report( getVarImp( rf2, FALSE ), n=10, plat="hu6800", toktype="SYMBOL")
requireNamespace("airway")
requireNamespace("SummarizedExperiment")
data(airway, package="airway")
set.seed(1234)
xx = MLearn(dex~., data=airway[1:2000,], randomForestI, 1:8, importance=TRUE)
RObject(xx)
vi = getVarImp(xx)
tm = SummarizedExperiment::rowData(airway)$gene_name
names(tm) = rownames(airway)
par(mar=c(4,8,3,3))
plot(vi, tmap=tm, las=2)
}
\keyword{classes}

\name{raboostCont-class}
\docType{class}
\alias{raboostCont-class}
\alias{daboostCont-class}
\alias{show,raboostCont-method}

\title{Class "raboostCont" ~~~ }
\description{	 ~~ A concise (1-5 lines) description of what the class is.  ~~}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("raboostCont", ...)}.
	 ~~ describe objects here ~~ 
}
\section{Slots}{
	 \describe{
    \item{\code{.Data}:}{Object of class \code{"list"} ~~ }
    \item{\code{formula}:}{Object of class \code{"formula"} ~~ }
    \item{\code{call}:}{Object of class \code{"call"} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{list}"}, from data part.
Class \code{"\linkS4class{vector}"}, by class "list", distance 2.
}
\section{Methods}{
\code{Predict} is an S4 method that can apply to instances of this class.
}
%\references{ ~put references to the literature/web site here ~ }
\author{ VJ Carey <stvjc@channing.harvard.edu>}
%\note{ ~~further notes~~ }
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%
%\seealso{
%	~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%	or \code{\linkS4class{CLASSNAME}} for links to other classes
%}
\examples{
showClass("raboostCont")
}
\keyword{classes}

\name{fsHistory}
\alias{fsHistory}
\title{extract history of feature selection for a cross-validated
machine learner  }
\description{extract history of feature selection for a cross-validated
machine learner  }
\usage{
fsHistory(x)
}
\arguments{
  \item{x}{ instance of \code{\linkS4class{classifierOutput}}}
}
\details{
returns a list of names of selected features
}
\value{
a list; the names of variables are made 'syntactic'
}
%\references{  }
\author{Vince Carey <stvjc@channing.harvard.edu>}
%\note{  }


%\seealso{  }

\examples{
data(iris)
iris2 = iris[ iris$Species \%in\% levels(iris$Species)[1:2], ]
iris2$Species = factor(iris2$Species) # drop unused levels
x1 = MLearn(Species~., iris2, ldaI, xvalSpec("LOG", 3, 
   balKfold.xvspec(3), fs.absT(3)))
fsHistory(x1)
}
\keyword{ models }

\name{brennan_2013_tabS7exc}
\alias{brennan_2013_tabS7exc}
\docType{data}
\title{
Clinical characterization of 158 GBM samples from https://doi.org/10.1016/j.cell.2013.09.034 supp table S7
}
\description{
The clinical characteristics table of https://doi.org/10.1016/j.cell.2013.09.034 in supplemental table
S7 was aligned with the GBM samples in curatedTCGAData (selecting GBM and version 2.0.1 with curatedTCGAData
1.17.0.
}
\usage{data("brennan_2013_tabS7exc")}
\format{
  A data frame with 158 observations on the following 16 variables.
  \describe{
    \item{\code{Case_ID}}{a character vector}
    \item{\code{Secondary_or_Recurrent}}{a character vector}
    \item{\code{Age_at_Procedure}}{a numeric vector}
    \item{\code{Gender}}{a character vector}
    \item{\code{Path_Dx}}{a character vector}
    \item{\code{MGMT_Status}}{a character vector}
    \item{\code{Methylation_Class_2012}}{a character vector}
    \item{\code{G_CIMP_methylation}}{a character vector}
    \item{\code{IDH1_status}}{a character vector}
    \item{\code{Expression_Subclass}}{a character vector}
    \item{\code{Therapy_Class}}{a character vector}
    \item{\code{Vital_Status}}{a character vector}
    \item{\code{OS_days}}{a numeric vector}
    \item{\code{Progression_Status}}{a character vector}
    \item{\code{PFS_days}}{a numeric vector}
    \item{\code{V16}}{a logical vector}
  }
}
\details{
Simple intersection on Case_ID in Supp Tab 7 with patientID in the GBM from
curatedTCGAData.
}
\source{
\url{https://doi.org/10.1016/j.cell.2013.09.034}
}
\references{
The Somatic Genomic Landscape of Glioblastoma by
Cameron W. Brennan, 
Roel G.W. Verhaak,
Aaron McKenna, and others, Cell Oct 10 2013.
}
\examples{
data(brennan_2013_tabS7exc)
head(brennan_2013_tabS7exc)
}
\keyword{datasets}

\name{xvalLoop}
\alias{xvalLoop}
\alias{xvalLoop,ANY-method}
\title{Cross-validation in clustered computing environments}
\description{Use cross-validation in a clustered computing environment}
\usage{xvalLoop( cluster, ... )}
\arguments{
 \item{cluster}{Any S4-class object, used to indicate how to perform clustered
   computations.}
 \item{...}{Additional arguments used to inform the clustered computation.}
}
\details{
  Cross-validiation usually involves repeated calls to the same
  function, but with different arguments. This provides an obvious
  place for using clustered computers to enhance execution. The method
  xval is structured to exploit this; \code{xvalLoop}
  provides an easy mechanism to change how \code{xval} performs
  cross-validation.

  The idea is to write an \code{xvalLoop} method that returns a
  function. The function is then used to execute the
  cross-validation. For instance, the default method returns the
  function \code{lapply}, so the cross-validation is performed by using
  \code{lapply}. A different method might return a function that
  executed lapply-like functions, but sent different parts of the
  function to different computer nodes.

  An accompanying vignette illustrates the technique in greater
  detail. An effective division of labor is for experienced cluster
  programmers to write lapply-like methods for their favored clustering
  environment. The user then only has to add the cluster object to the
  list of arguments to \code{xval} to get clustered calculations.
}
\value{A function taking arguments like those for \code{\link{lapply}}}
\examples{
\dontrun{
library(golubEsets)
data(Golub_Merge)
smallG <- Golub_Merge[200:250,]

# Evaluation on one node

lk1 <- xval(smallG, "ALL.AML", knnB, xvalMethod="LOO", group=as.integer(0))
table(lk1,smallG$ALL.AML)

# Evaluation on several nodes -- a cluster programmer might write the following...

library(snow)
setOldClass("spawnedMPIcluster")

setMethod("xvalLoop", signature( cluster = "spawnedMPIcluster"),
## use the function returned below to evalutae
## the central cross-validation loop in xval
function( cluster, ... ) {
    clusterExportEnv <- function (cl, env = .GlobalEnv)
    {
        unpackEnv <- function(env) {
            for ( name in ls(env) ) assign(name, get(name, env), .GlobalEnv )
            NULL
        }
        clusterCall(cl, unpackEnv, env)
    }
    function(X, FUN, ...) { # this gets returned to xval
        ## send all visible variables from the parent (i.e., xval) frame
        clusterExportEnv( cluster, parent.frame(1) )
        parLapply( cluster, X, FUN, ... )
    }
})

# ... and use the cluster like this...

cl <- makeCluster(2, "MPI")
clusterEvalQ(cl, library(MLInterfaces))

lk1 <- xval(smallG, "ALL.AML", knnB, xvalMethod="LOO", group=as.integer(0), cluster = cl)
table(lk1,smallG$ALL.AML)
}}
\keyword{methods}

\name{clusteringOutput-class}
\docType{class}
\alias{clusteringOutput-class}
\alias{RObject,clusteringOutput-method}
\alias{plot,clusteringOutput,ANY-method}
\alias{show,clusteringOutput-method}
\alias{show,clusteringSchema-method}
\alias{getConverter,clusteringSchema-method}
\alias{getDist,clusteringSchema-method}
\alias{getConverter}
\alias{getDist}
\alias{clusteringSchema-class}
\alias{prcompObj-class}
\alias{silhouette-class}
\alias{prcomp-class}

\title{container for clustering outputs in uniform structure}
\description{container for clustering outputs in uniform structure}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("clusteringOutput", ...)}.
}
\section{Slots}{
	 \describe{
    \item{\code{partition}:}{Object of class \code{"integer"}, labels for
observations as clustered }
    \item{\code{silhouette}:}{Object of class \code{"silhouette"},
structure from Rousseeuw cluster package measuring cluster
membership strength per observation}
    \item{\code{prcomp}:}{Object of class \code{"prcompObj"} a wrapped
instance of stats package prcomp output }
%    \item{\code{metric}:}{Object of class \code{"character"} string
%identifying the distance function used to orient objects in feature space }
    \item{\code{call}:}{Object of class \code{"call"} for auditing }
    \item{\code{learnerSchema}:}{Object of class \code{"learnerSchema"}, a
formal object indicating the package, function, and other attributes
of the clustering algorithm employed to generate this object  }
    \item{\code{RObject}:}{Object of class \code{"ANY"}, the
unaltered output of the function called according to learnerSchema }
    \item{\code{converter}:}{converter propagated from call}
    \item{\code{distFun}:}{distfun propagated from call}
  }
}
\section{Methods}{
  \describe{
    \item{RObject}{\code{signature(x = "clusteringOutput")}: extract
the unaltered output of the R function or method called according
to learnerSchema }
    \item{plot}{\code{signature(x = "clusteringOutput", y = "ANY")}: 
a 4-panel plot showing features of the clustering, including the
scree plot for a principal components transformation and a display
of the partition in PC1xPC2 plane.  For a clustering method that
does not have a native plot procedure, such as kmeans, the parameter
y should be bound to a data frame or matrix with feature data for all records;
an image plot of robust feature z-scores (z=(x-median(x))/mad(x)) and
the cluster indices is produced in the northwest panel.  }
    \item{show}{\code{signature(object = "clusteringOutput")}: concise
report }
	 }
}
%\references{ ~put references to the literature/web site here ~ }
\author{ VJ Carey <stvjc@channing.harvard.edu>}
%\note{ ~~further notes~~ }
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%
%\seealso{
%	~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%	or \code{\linkS4class{CLASSNAME}} for links to other classes
%}
\examples{
showClass("clusteringOutput")
}
\keyword{classes}

\name{MLearn}
\alias{MLearn_new}
\alias{MLearn}
\alias{baggingI}
\alias{dlda}
\alias{glmI.logistic} 
\alias{knnI} 
\alias{knn.cvI} 
\alias{ksvmI} 
\alias{ldaI} 
\alias{lvqI} 
\alias{naiveBayesI} 
\alias{nnetI}
\alias{qdaI} 
\alias{RABI}
\alias{randomForestI} 
\alias{rpartI}
\alias{svmI}
\alias{svm2}
\alias{ksvm2}
\alias{plsda2}
\alias{plsdaI}
\alias{dlda2}
\alias{dldaI}
\alias{sldaI}
\alias{blackboostI}
\alias{knn2}
\alias{knn.cv2}
\alias{ldaI.predParms}
\alias{lvq}
\alias{rab}
\alias{adaI}
\alias{MLearn,formula,ExpressionSet,character,numeric-method}
\alias{MLearn,formula,ExpressionSet,learnerSchema,numeric-method}
\alias{MLearn,formula,SummarizedExperiment,learnerSchema,numeric-method}
\alias{MLearn,formula,data.frame,learnerSchema,numeric-method}
\alias{MLearn,formula,data.frame,learnerSchema,xvalSpec-method}
\alias{MLearn,formula,ExpressionSet,learnerSchema,xvalSpec-method}
\alias{MLearn,formula,data.frame,clusteringSchema,ANY-method}
\alias{plotXvalRDA}
\alias{BgbmI}
\alias{gbm2}
\alias{hclustI}
\alias{kmeansI}
\alias{pamI}
\alias{makeLearnerSchema}
\alias{standardMLIConverter}



\title{revised MLearn interface for machine learning}
\description{revised MLearn interface for machine learning, emphasizing
a schematic description of external learning functions like knn, lda, nnet, etc.
}
\usage{
MLearn( formula, data, .method, trainInd, ... )
makeLearnerSchema(packname, mlfunname, converter, predicter)
}
\arguments{
  \item{formula}{ standard model formula }
  \item{data}{ data.frame or ExpressionSet or SummarizedExperiment instance}
  \item{.method}{ instance of learnerSchema }
  \item{trainInd}{ obligatory numeric vector of indices of data to be used for training;
all other data are used for testing, or instance of the xvalSpec class }
  \item{\dots}{ additional named arguments passed to external learning function }
  \item{packname}{character -- name of package harboring a learner function}
  \item{mlfunname}{character -- name of function to use}
  \item{converter}{function -- with parameters (obj, data, trainInd) that tells
    how to convert the material in obj [produced by [packname::mlfunname] ] into a
    classifierOutput instance.}
  \item{predicter}{function -- with parameters (obj, newdata, ...) that
    tells how to use the material in \code{obj} to predict
    \code{newdata}.}
}

\details{
%This implementation attempts to reduce complexity of the basic
%MLInterfaces engine.  The primary MLearn method, which includes 
%"learnerSchema" in its signature, is very concise.  Details
%of massaging inputs and outputs are left to a learnerSchema class instance.
%The MLint\_devel vignette describes the schema formulation.  learnerSchema instances
%are provided for following methods; the naming convention is that the
%method basename is prepended to `I'.
%
%Note that some schema instances are presented as functions.  The
%parameters must be set to use these models.
The purpose of the MLearn methods is to provide a uniform calling sequence
to diverse machine learning algorithms.  In R package, machine learning functions
can have parameters \code{(x, y, ...)} or \code{(formula, data, ...)} or some
other sequence, and these functions can return lists or vectors or other
sorts of things.  With MLearn, we
always have calling sequence \code{MLearn(formula, data, .method, trainInd, ...)}, 
and \code{data} can be a \code{data.frame} or \code{ExpressionSet}.  \code{MLearn}
will always return an S4 instance of \code{classifierObject} or \code{clusteringObject}.

At this time (1.13.x), NA values
in predictors trigger an error.

To obtain documentation on the older (pre bioc 2.1) version of the MLearn
method, please use help(MLearn-OLD).

\describe{
\item{randomForestI}{\link[randomForest]{randomForest}.  Note, that to obtain the
default performance of randomForestB, you need to set mtry and sampsize parameters
to sqrt(number of features) and table([training set response factor]) respectively,
as these were not taken to be the function's defaults.   Note you can use
xvalSpec("NOTEST") as trainInd, to use all the samples; the RObject() result
will print the misclassification matrix estimate along with OOB error rate estimate.}
\item{knnI(k=1,l=0)}{\link[class]{knn}; special support bridge required, defined in MLint}
\item{knn.cvI(k=1,l=0)}{\link[class]{knn.cv}; special support bridge required, defined in MLint.  This option uses the embedded leave-one-out
cross-validation of \code{knn.cv}, and thereby
achieves high performance.  You can have more general cross-validation
using \code{knnI} with an \code{xvalSpec}, but it will be slower.
When using this learner schema, you should use the
numerical \code{trainInd} setting with \code{1:N} where
\code{N} is the number of samples.}
\item{dldaI}{\link[sfsmisc]{diagDA}; special support bridge required, defined in MLint}
\item{nnetI}{\link[nnet]{nnet}}
\item{rpartI}{\link[rpart]{rpart}}
\item{ldaI}{\link[MASS]{lda}}
\item{svmI}{\link[e1071]{svm}}
\item{qdaI}{\link[MASS]{qda}}
\item{logisticI(threshold)}{\link[stats]{glm} -- with binomial family, expecting a dichotomous
factor as response variable, not bulletproofed against other responses yet.  If response
probability estimate exceeds threshold, predict 1, else 0}
%\item{RABI}{\link[MLint]{RAB} -- an experimental implementation of real Adaboost
%of Friedman Hastie Tibshirani Ann Stat 2001}
\item{adaI}{\link[ada]{ada}}
\item{BgbmI}{\link[gbm]{gbm}, forcing the Bernoulli loss function.}
\item{blackboostI}{\link[mboost]{blackboost} -- you MUST supply
a family parameter relevant for mboost package procedures}
\item{lvqI}{\link[class]{lvqtest} after building codebook with lvqinit and updating with
olvq1.  You will need to write your own detailed schema if you want to tweak tuning
parameters.}
\item{naiveBayesI}{\link[e1071]{naiveBayes}}
\item{baggingI}{\link[ipred]{bagging}}
\item{sldaI}{\link[ipred]{slda}}
\item{ksvmI}{\link[kernlab]{ksvm}}
\item{hclustI(distMethod, agglomMethod)}{\link[stats]{hclust} --
you must explicitly specify distance and agglomeration procedure.}
\item{kmeansI(centers, algorithm)}{\link[stats]{kmeans} --
you must explicitly specify centers and algorithm name.}
} % end list of schemas

If the \code{parallel} package is attached, cross-validation will
be distributed to cores using \code{\link{mclapply}}.

} % end details
\value{
Instances of classifierOutput or clusteringOutput
}
%\references{  }
\author{Vince Carey <stvjc@channing.harvard.edu>}
%\note{  }


\seealso{Try \code{example(hclustWidget, ask=FALSE)} for an interactive
approach to cluster analysis tuning.  }

\examples{
library("MASS")
data(crabs)
set.seed(1234)
kp = sample(1:200, size=120)
rf1 = MLearn(sp~CW+RW, data=crabs, randomForestI, kp, ntree=600 )
rf1
nn1 = MLearn(sp~CW+RW, data=crabs, nnetI, kp, size=3, decay=.01,
    trace=FALSE )
nn1
RObject(nn1)
knn1 = MLearn(sp~CW+RW, data=crabs, knnI(k=3,l=2), kp)
knn1
names(RObject(knn1))
dlda1 = MLearn(sp~CW+RW, data=crabs, dldaI, kp )
dlda1
names(RObject(dlda1))
lda1 = MLearn(sp~CW+RW, data=crabs, ldaI, kp )
lda1
names(RObject(lda1))
slda1 = MLearn(sp~CW+RW, data=crabs, sldaI, kp )
slda1
names(RObject(slda1))
svm1 = MLearn(sp~CW+RW, data=crabs, svmI, kp )
svm1
names(RObject(svm1))
ldapp1 = MLearn(sp~CW+RW, data=crabs, ldaI.predParms(method="debiased"), kp )
ldapp1
names(RObject(ldapp1))
qda1 = MLearn(sp~CW+RW, data=crabs, qdaI, kp )
qda1
names(RObject(qda1))
logi = MLearn(sp~CW+RW, data=crabs, glmI.logistic(threshold=0.5), kp, family=binomial ) # need family
logi
names(RObject(logi))
rp2 = MLearn(sp~CW+RW, data=crabs, rpartI, kp)
rp2
## recode data for RAB
#nsp = ifelse(crabs$sp=="O", -1, 1)
#nsp = factor(nsp)
#ncrabs = cbind(nsp,crabs)
#rab1 = MLearn(nsp~CW+RW, data=ncrabs, RABI, kp, maxiter=10)
#rab1
#
# new approach to adaboost
#
ada1 = MLearn(sp ~ CW+RW, data = crabs, .method = adaI, 
    trainInd = kp, type = "discrete", iter = 200)
ada1
confuMat(ada1)
#
lvq.1 = MLearn(sp~CW+RW, data=crabs, lvqI, kp )
lvq.1
nb.1 = MLearn(sp~CW+RW, data=crabs, naiveBayesI, kp )
confuMat(nb.1)
bb.1 = MLearn(sp~CW+RW, data=crabs, baggingI, kp )
confuMat(bb.1)
#
# new mboost interface -- you MUST supply family for nonGaussian response
#
require(party)  # trafo ... killing cmd check
blb.1 = MLearn(sp~CW+RW+FL, data=crabs, blackboostI, kp, family=mboost::Binomial() )
confuMat(blb.1)
#
# ExpressionSet illustration
# 
data(sample.ExpressionSet)
#  needed to increase training set size to avoid a new randomForest condition
# on empty class
set.seed(1234)
X = MLearn(type~., sample.ExpressionSet[100:250,], randomForestI, 1:19, importance=TRUE )
library(randomForest)
library(hgu95av2.db)
opar = par(no.readonly=TRUE)
par(las=2)
plot(getVarImp(X), n=10, plat="hgu95av2", toktype="SYMBOL")
par(opar)
#
# demonstrate cross validation
#
nn1cv = MLearn(sp~CW+RW, data=crabs[c(1:20,101:120),], 
   nnetI, xvalSpec("LOO"), size=3, decay=.01, trace=FALSE )
confuMat(nn1cv)
nn2cv = MLearn(sp~CW+RW, data=crabs[c(1:20,101:120),], nnetI, 
   xvalSpec("LOG",5, balKfold.xvspec(5)), size=3, decay=.01,
   trace=FALSE )
confuMat(nn2cv)
nn3cv = MLearn(sp~CW+RW+CL+BD+FL, data=crabs[c(1:20,101:120),], nnetI, 
   xvalSpec("LOG",5, balKfold.xvspec(5), fsFun=fs.absT(2)), size=3, decay=.01,
   trace=FALSE )
confuMat(nn3cv)
nn4cv = MLearn(sp~.-index-sex, data=crabs[c(1:20,101:120),], nnetI, 
   xvalSpec("LOG",5, balKfold.xvspec(5), fsFun=fs.absT(2)), size=3, decay=.01,
   trace=FALSE )
confuMat(nn4cv)
#
# try with expression data
#
library(golubEsets)
data(Golub_Train)
litg = Golub_Train[ 100:150, ]
g1 = MLearn(ALL.AML~. , litg, nnetI, 
   xvalSpec("LOG",5, balKfold.xvspec(5), 
   fsFun=fs.probT(.75)), size=3, decay=.01, trace=FALSE )
confuMat(g1)
#
# computations related to ALL that were used for rda and may be used elsewhere
#
library(ALL)
data(ALL)
#
# restrict to BCR/ABL or NEG
#
bio <- which( ALL$mol.biol \%in\% c("BCR/ABL", "NEG"))
#
# restrict to B-cell
#
isb <- grep("^B", as.character(ALL$BT))
kp <- intersect(bio,isb)
all2 <- ALL[,kp]
mads = apply(exprs(all2),1,mad)
kp = which(mads>1)  # get around 250 genes
vall2 = all2[kp, ]
vall2$mol.biol = factor(vall2$mol.biol) # drop unused levels

# illustrate clustering support

cl1 = MLearn(~CW+RW+CL+FL+BD, data=crabs, hclustI(distFun=dist, cutParm=list(k=4)))
plot(cl1)

cl1a = MLearn(~CW+RW+CL+FL+BD, data=crabs, hclustI(distFun=dist, cutParm=list(k=4)), 
   method="complete")
plot(cl1a)

cl2 = MLearn(~CW+RW+CL+FL+BD, data=crabs, kmeansI, centers=5, algorithm="Hartigan-Wong")
plot(cl2, crabs[,-c(1:3)])

c3 = MLearn(~CL+CW+RW, crabs, pamI(dist), k=5)
c3
plot(c3, data=crabs[,c("CL", "CW", "RW")])


#  new interfaces to PLS thanks to Laurent Gatto

set.seed(1234)
kp = sample(1:200, size=120)

#plsda.1 = MLearn(sp~CW+RW, data=crabs, plsdaI, kp, probMethod="Bayes")
#plsda.1
#confuMat(plsda.1)
#confuMat(plsda.1,t=.65) ## requires at least 0.65 post error prob to assign species
#
#plsda.2 = MLearn(type~., data=sample.ExpressionSet[100:250,], plsdaI, 1:16)
#plsda.2
#confuMat(plsda.2)
#confuMat(plsda.2,t=.65) ## requires at least 0.65 post error prob to assign outcome

## examples for predict
#clout <- MLearn(type~., sample.ExpressionSet[100:250,], svmI , 1:16)
#predict(clout, sample.ExpressionSet[100:250,17:26])

}

\keyword{ models }

\name{MLIntInternals}
 \alias{getGrid}
 \alias{getGrid,data.frame-method}
 \alias{getGrid,ExpressionSet-method}
\alias{MLLabel }
\alias{MLOutput }
\alias{MLScore }
\alias{SOMBout }
\alias{classifOutput }
\alias{clustOutput }
\alias{groupIndex}
\alias{membMat }
\alias{probArray }
\alias{probMat }
\alias{qualScore }
\alias{silhouetteVec }
\alias{somout}

\alias{MLIConverter.Bgbm}
\alias{MLIConverter.RAB}
\alias{MLIConverter.blackboost}
\alias{MLIConverter.dlda}
\alias{MLIConverter.knn}
\alias{MLIConverter.knncv}
\alias{MLIConverter.ksvm}
\alias{MLIConverter.ldaPredMeth}
\alias{MLIConverter.logistic}
\alias{MLIConverter.naiveBayes}
\alias{MLIConverter.nnet}
\alias{MLIConverter.plsda}
\alias{MLIConverter.randomForest}
\alias{MLIConverter.rpart}
\alias{MLIConverter.selftesting}
\alias{MLIConverter.slda}
\alias{MLIConverter.svm}
\alias{MLIConverterListEl.class}
\alias{MLIConverterPredType.class}
\alias{MLIPredicter.knn}
\alias{MLIPredicter.ksvm}
\alias{MLIPredicter.naiveBayes}
\alias{MLIPredicter.nnet}
\alias{MLIPredicter.plsda}
\alias{MLIPredicter.randomForest}
\alias{MLIPredicter.svm}
\alias{cverrs}
\alias{es2df}
\alias{se2df}
\alias{hclustConverter}
\alias{kmeansConverter}
\alias{makeClusteringSchema}
\alias{makeConfuMat}
\alias{mapPSvec}
\alias{naAs0}
\alias{pamConverter}
\alias{partPlot}
\alias{planarPlot2}
\alias{plspinDF}
\alias{predict.RAB}
\alias{predict.dlda2}
\alias{predict.gbm2}
\alias{predict.knn.cv2}
\alias{predict.knn2}
\alias{predict.lvq}
\alias{x}


\title{MLInterfaces infrastructure}
\description{
These functions are internal tools for \code{MLInterfaces}.
Users will generally not call these functions directly.
}
\usage{
getGrid(x)
}

\arguments{
  \item{x}{a vector or matrix or ExpressionSet}
}
\details{
Forthcoming.
}
\value{
Functions with `new' as prefix are constructor helpers.
}

\author{VJ Carey <stvjc@channing.harvard.edu>}

\keyword{ classif }

\name{plspinHcube}
\alias{plspinHcube}

\title{
shiny app for interactive 3D visualization of mlbench hypercube
}
\description{
shiny app for interactive 3D visualization of mlbench hypercube
}
\usage{
plspinHcube(insbwidth=4)
}
\arguments{
 \item{insbwidth}{numeric, sidebar width}
}

\details{

}
\value{
Runs \code{\link[shiny]{shinyApp}} on ui and server that
render gaussian data at hypercube vertices.  
}



\author{
VJ Carey <stvjc@channing.harvard.edu>
}






\seealso{
\code{\link[mlbench]{mlbench.hypercube}}
}
\examples{
if (interactive()) plspinHcube()
}


\keyword{ models }

\name{confuMat-methods}
\docType{methods}
\alias{confuMat}
\alias{confuMat-methods}
\alias{confuMat,classifierOutput-method}
\alias{confuMat,classifierOutput,character-method}
\alias{confuMat,classifierOutput,missing-method}
\alias{confuMat,classifierOutput,numeric-method}
\title{ Compute the confusion matrix for a classifier. }
\description{
This function will compute the confusion matrix for a classifier's output
}
\section{Methods}{
  \describe{
    \item{obj = "classifOutput", ...}{ Typically, an instance of class 
      \code{"\linkS4class{classifierOutput}"}
      is built on a training subset of the input data. The model is then
      used to predict the class of samples in the test set.  When the
      true class labels for the test set are available the confusion matrix
      is the cross-tabulation of the true labels
      of the test set against the predictions from the classifier. An
      optional \code{t} score threshold can also be specified.
    } % end item
    \item{obj = "classifierOutput", type="character", ...}{ 
      For instances of \linkS4class{classifierOutput}, it is possible
      to specify the \code{type} of confusion matrix desired.
      The default is \code{test}, which tabulates classes from the
      test set against the associated predictions.  If \code{type} is
      \code{train}, the training class vector is tabulated against the
      predictions on the training set. An optional \code{t} score
      threshold can also be specified. 
    } % end item
    \item{obj = "classifierOutput", type="numeric"}{ 
      For instances of \linkS4class{classifierOutput}, it is possible
      to specify the minimum score feature classification
      threshold. Features with a score less than the threshold are
      classified as \code{NA} in the confustion \code{train} or
      \code{test}  confusion matrix.
    } % end item
  } % end describe
}  % end Methods section
\examples{
library(golubEsets)
data(Golub_Merge)
smallG <- Golub_Merge[101:150,]
k1 <- MLearn(ALL.AML~., smallG, knnI(k=1), 1:30)
confuMat(k1)
confuMat(k1, "train")
}
\keyword{methods}
\keyword{ classif }

\name{confuTab}
\alias{confuTab}


\title{
  Compute confusion tables for a confusion matrix.
}

\description{
  Given a \code{n} by \code{n} confusion matrix, the function returns a
  \code{list} of \code{n} 2 by 2 tables with false positives, false
  negatives, false positives and true negative for each initial variables.
}

\usage{
confuTab(obj, naAs0. = FALSE)
}


\arguments{
  \item{obj}{
    An instance of class \code{table}. Must be square.
  }
  \item{naAs0.}{
    A \code{logical}, defining if \code{NA}s are to be replaced by
  \code{0}s. 
  }
}

\value{
  A \code{list} of length \code{nrow(obj)} and names
  \code{rownames(obj)}. 
}

\author{
  Laurent Gatto <lg390@cam.ac.uk>
}

\seealso{
  The \code{\link{tp}}, \code{\link{tn}}, \code{\link{fp}},
  \code{\link{fn}}, methods to extract the respective classification
  outcomes from a contingency matrix.
}

\examples{
## the confusion matrix
cm <- table(iris$Species, sample(iris$Species))
## the 3 confusion tables
(ct <- confuTab(cm))
}

\name{hclustWidget}
\alias{hclustWidget}
\alias{mlearnWidget}

\title{
shiny-oriented GUI for cluster or classifier exploration
}
\description{
shiny-oriented GUI for cluster or classifier exploration
}
\usage{
hclustWidget(mat, featureName = "feature", title =
                 paste0("hclustWidget for ", deparse(substitute(mat))),
                 minfeats = 2, auxdf = NULL)

mlearnWidget(eset, infmla)
}

\arguments{
  \item{mat}{
matrix with feature vectors in rows
}
  \item{featureName}{
name to be used for control that asks for number of features to use
}
  \item{title}{
widget title
}
  \item{minfeats}{
lower bound on number of features to use
}  \item{auxdf}{
data.frame with number of rows equal to nrow(mat), with metadata
to be displayed in hovering tooltip
}
  \item{eset}{instance of \code{\link{ExpressionSet-class}}}
  \item{infmla}{instance of \code{formula}, with dependent variable
values obtained in \code{pData(eset)}, and independent variable
specified as "." or as properly munged elements of \code{featureNames(eset)}.}
}
\details{
Experimental tool to illustrate impacts of choice of distance,
agglomeration method, etc.
}
\value{
a shinyApp result that will display in active browser
}



\author{
VJ Carey <stvjc@channing.harvard.edu>
}
\note{
\code{mlearnWidget} will attempt to nicely produce a variable
importance plot using \code{\link{randomForestI}}.  This means
that the annotation package for probe identifiers should be loaded
or an error will be thrown.
}






\examples{
# should run with example(hclustWidget, ask=FALSE)
if (interactive()) {
 library(shiny)
 library(MASS)
 data(crabs)
 cr = data.matrix(crabs[,-c(1:3)])
 au = crabs[,1:3]
 show(hclustWidget(cr, auxdf=au))
## must use stop widget button to proceed
  library(ALL)
  library(hgu95av2.db)
  data(ALL)
  show(mlearnWidget(ALL[1:500,], mol.biol~.))
 }
}


\keyword{ models }
